/*
	combank.c

	08/11/95
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#undef abs;

extern FILE *fmem5;

extern char transdata[];
extern char jobnamew[];
extern char atfactor[];
extern char isonoj[];
extern char unitoftime[];
extern char skalfak[];
extern char melding[];
extern char compu[];
extern char Uunitoftime[];
extern char Uskalfak[];
extern char Uisonoj[];
extern char transname[];

extern char activnr;
extern char eruddata;
extern char overstar;
extern char pctcalc;
extern char jobbank;
extern char AUX_peger;
extern char SAVE_peger;
extern char PCT_peger;
extern char min_posS;

char styrefiler = 0;
char min_pos = 0;
char STYR_act = - 1;

extern char *timedef[];
extern char *isofac[];
extern char *isoval[];
extern char *paratex[];
extern char *promtstr[];

extern int styrk[3][3];

extern int basenum[];

extern int jobmax;
extern int jobtal;
extern int nummer;
extern int antalibase;
extern int protected;
extern int KONS_job;
extern int mabaton;

extern double out[11][15];
extern double valuta[4][16];

extern double bas[];
extern double cas[];
extern double sas[];

extern double faktor;

void savenuba(int parm, int parm1)
{
FILE *fmem1;

	int tal, tal1;
	char strmellem[20], reorgan;
	double mellem;
	long bytepos = 0;

	reorgan = 0;
	if(parm <= - 1 && parm1 >= 0)  reorgan = 1;

	fmem1 = fopen("MASINUBA", "rt+");
	if(parm >= 0)  {
	     bytepos = 18 * (long) parm;
	     tal1 = 0;
	    }
	else
	    {
	     parm = - parm;
	     parm1 = parm;
	     tal1 = 2;
	    }
	fseek(fmem1, bytepos, tal1);

	for(tal = parm; tal <= parm1; tal++)  {
	     if(tal == 0)  tal1 = protected;
	     else
		 {
		  if(reorgan <= 0)  tal1 = basenum[tal];
		  else  tal1 = parm;
		 }
	     mellem = (double) tal1;
	     sprintf(strmellem, "%f", mellem);
	     fprintf(fmem1, "%s\n", strmellem);

	     for(tal1 = 1; tal1 <= 14 - strlen(strmellem); tal1++)  putc(120, fmem1);
	     strmellem[0] = '\0';
	     fprintf(fmem1, "%s\n", strmellem);
	    }
	fclose(fmem1);
}

void finubase(void)
{
char postlas[90], strmellem[20];
int tal;
long bytebase;
double  mellem;

	tal = (int) sas[0];
	bytebase = 888 * (long) (tal - 1);
	fseek(fmem5, bytebase, 0);

	transname[0] = '\0';
	fgets(postlas, 90, fmem5);
	strncat(transname, postlas, strlen(postlas) - 1);

	for(tal = 1; tal <= 34; tal++)  {
	     strmellem[0] = '\0';
	     fgets(postlas, 40, fmem5);
	     strncat(strmellem, postlas, strlen(postlas) - 1);
	     mellem = atof(strmellem);
	     if(mellem > - 0.000001 && mellem < 0.000001)  mellem = 0.0;
	     if(styrefiler != 1)  sas[tal] = mellem;
	     else  bas[tal] = mellem;
	    }

	for(tal = 1; tal <= 8; tal++)  {
	     paratex[tal][0] = '\0';
	     fgets(postlas, 40, fmem5);
	     strncat(paratex[tal], postlas, strlen(postlas) - 1);
	    }

}

void sknubase(void)
{
char strmellem[40];
int tal, tal1, Xlen;
long bytebase = 0;

	if((int) sas[0] <= - 1)  goto expand;

	tal = (int) sas[0];
	goto poskri;

expand:	sas[0] = - sas[0];
	tal1 = 2;
	goto skrip1;

poskri: bytebase = 888 * (long) (tal - 1);
	tal1 = 0;

skrip1: fseek(fmem5, bytebase, tal1);
	Xlen = 307;
	strncat(transname, "                                                                    ", 67 - strlen(transname));
	fprintf(fmem5, "%s\n", transname);

	for(tal = 1; tal <= 34; tal++)  {
	     if(styrefiler != 1)  sprintf(strmellem, "%f", sas[tal]);
	     else  sprintf(strmellem, "%f", bas[tal]);
	     fprintf(fmem5, "%s\n", strmellem);
	     Xlen = Xlen + strlen(strmellem);
	    }

	for(tal = 1; tal <= 8; tal++)  {
	     strcpy(strmellem, paratex[tal]);
	     strncat(strmellem, "                              ", 30 - strlen(strmellem));
	     fprintf(fmem5, "%s\n", strmellem);
	    }

	for(tal = 1; tal <= 800 - Xlen; tal++)  putc(120, fmem5);
	strmellem[0] = '\0';
	fprintf(fmem5, "%s\n", strmellem);


}

void unit_num(void)
{
int tal;

	for(tal = 1; tal <= 4; tal++)  {
	     if(strcmp(timedef[tal], unitoftime) == 0)  break;
	    }
	bas[27] = (double) tal;
	for(tal = 1; tal <= 4; tal++)  {
	     if(strcmp(isofac[tal], atfactor) == 0)  break;
	    }
	bas[28] = (double) tal;
}

void combank(char parm)
{
FILE *fmem1;
FILE *fmem2;

	int tal, tal1, tal2, nuta, starnut;
	int selekt, endjob, uddata, Rjobtal;
	double summe[35], mellem, bas27, bas29, maxfun, minfun, maxtid, maxskal;
	char *Rparatex[9], strmellem[225], RESET_peger;
	char Rjobnamew[80], Rfaktor[3], Risonoj[5];

	for(tal = 0; tal <= 8; tal++) {
	     Rparatex[tal] = malloc(35);
	     strcpy(Rparatex[tal], paratex[tal]);
	    }
	strcpy(Rjobnamew, jobnamew);
	strcpy(Rfaktor, atfactor);
	strcpy(Risonoj, isonoj);

	for(tal = 0; tal <= 34; tal++)  summe[tal] = 0.0;

	uddata = 0;
	endjob = 0;
	Rjobtal = jobtal;
	RESET_peger = 0;
	maxtid = 0.0;
	maxskal = 0.0;
	maxfun = 0.0;
	minfun = 0.0;

	if(parm == 2)  goto genudda;
	if(parm == 1)  goto savejob;

	endjob = analyjob(summe);
	uddata = styrk[2][0];

	if(mabaton == 0)  RESET_peger = 1;
	if(mabaton == 0)  goto resetud;

	for(tal = 0; tal <= 4; tal++)  {
	     if(strcmp(timedef[tal], Uunitoftime) == 0)  break;
	    }
	bas27 = (double) tal;
	if(eruddata <= 0)  summe[27] = bas27;

	for(tal = 1; tal <= 15; tal++)  {
	     if(strcmp(isoval[tal], Uisonoj) == 0)  break;
	    }
	summe[29] = valuta[1][tal];
	if(eruddata <= 0 && pctcalc <= 0)  bas29 = (double) tal;
	else
	    {
	     maxtid = - 1.0;
	     if(pctcalc <= 0)  endjob = uddata;
	     else  endjob = 2;
	     for(tal = 1; tal <= 3; tal++)  {
		  for(tal1 = 0; tal1 <= 14; tal1++)  out[tal][tal1] = 0.0;
		 }
	    }

	styrk[0][2] = - endjob;
	if((eruddata == 5 && mabaton == 3) || eruddata == 6 || eruddata == 7)  {
	      RESET_peger = 1;
	      styrk[0][2] = - 2 * endjob;
	     }
	starnut = 0;
gentage:if(starnut == - 1)  starnut = 1;
	if(eruddata <= 0 || pctcalc == 2)  strcpy(strmellem, "MASIDAJN");
	else  strcpy(strmellem, "MASIUDDA");
	fmem1 = fopen(strmellem, "rt");

	for(nuta = 1; nuta <= endjob; nuta++)  {
	     if(eruddata <= 0 && jobtal == 1)  goto onejob;

	     sas[0] = (double) nuta;
	     fmem5 = fmem1;
	     finubase();

	     if(eruddata >= 1 || pctcalc >= 1)  {
		  out[1][0] = maxtid;
		  konvudda(summe, minfun, maxfun, maxskal, starnut, nuta);
		  maxtid = out[1][0];
		  continue;
		 }

	     tal = 0;
	     for(tal1 = 1; tal1 <= 18; tal1++)  {
		  if(!(tal1 == 1 || tal1 == 3  || tal1 == 6  || tal1 == 7 || tal1 == 14 || tal1 == 15 || tal1 == 18))  continue;
		  if(sas[tal1] != 0.0)  tal = 1;
		 }
	     if(tal == 0)  continue;

     onejob: konvjobs(summe, 1);
	     if(maxtid < sas[25]/sas[27])  maxtid = sas[25]/sas[27];
	    }
	fclose(fmem1);

	if(RESET_peger == 1 && starnut != 1)  {
	     maxskal = maxfun;
	     if(- minfun > maxfun)  maxskal = - minfun;
	     starnut = - 1;
	    }
	if(starnut == - 1 && maxskal > 0.0)  goto gentage;

	if(RESET_peger == 1 && starnut == 1)  uddstop();
	min_posS = (char) sas[34];
	if(RESET_peger == 1)  goto soegeud;
	if(eruddata >= 1)  goto uddskal;

	konvjobs(summe, 2);
	maxtid = bas27 * maxtid;
	if(maxtid < 1.0)  maxtid = 1.0;
	if(maxtid > 12.0)  maxtid = 12.0;
	if(maxtid >= 12.0)  {
	     bas[33] = 0.0;
	     sas[33] = 0.0;
	    }
	else
	    {
	     if(jobtal == 1 && sas[33] != 0)  {
		  bas[33] = bas27 * sas[33];
		  if(bas[33] > 12.0 - maxtid)  bas[33] = 12.0 - maxtid;
		  sas[33] = bas[33];
		 }
	    }
	sas[25] = (double) ((int) maxtid);
	sas[27] = bas27;
	sas[29] = bas29;

	for(tal = 0; tal <= 34; tal++)  {
	     summe[tal] = bas[tal];
	     bas[tal] = sas[tal];
	    }

// styre numskal(x)
	if(0 != numskal(- 2) && jobbank >= 0)  mabaton = 0;
	if(mabaton == 0)  goto resetud;

	for(tal = 1; tal <= 30; tal++)  {
	     if(bas[tal] > - 0.000001 && bas[tal] < 0.000001)  bas[tal] = 0.0;
	    }
	if(eruddata <= 0 && jobbank >= 0)  {
	     if(eruddata == 0)  strcpy(unitoftime, Uunitoftime);
	     strcpy(Risonoj, isonoj);
	     strcpy(isonoj, Uisonoj);
	    }
	if(jobtal >= 2)  {
	     bas[33] = 0.0;
	     for(tal = 1; tal <= 8; tal++)  strcpy(paratex[tal], paratex[tal + 8]);
	    }

	if(jobbank >= 0 || eruddata == - 1)  {
	     if(activnr != 0)  strcpy(paratex[activnr], paratex[0]);
	    }
	if(eruddata == - 1)  bas[25] = 5.0;
	if(eruddata == - 1)  goto puudsa1;
	if(jobtal == 1)  KONS_job = 0;
	else
	    {
	     fmem1 = fopen("MASIDAJN", "rt");
	     fmem2 = fopen("MASICONS", "wt");
	     while (fgets(strmellem, 225, fmem1) != NULL)  fputs(strmellem, fmem2);
	     fclose(fmem1);
	     fclose(fmem2);
	     jobtal = Rjobtal;
	     KONS_job = Rjobtal;
	    }
	goto punkt1;

uddskal:jobtal = - Rjobtal;
	min_pos = (char) sas[34];

genudda:if(!(AUX_peger == - 1 && parm == 2))  {
	     if(AUX_peger == - 2 && parm == 2)  AUX_peger = - 1;
	     if(styrk[0][0] != 7)  {
		  if(eruddata == 0)  out[0][0] = faktor;
		  else  numskal(5);
		 }
	     else  numskal(6);
	    }
	mellem = out[0][0];
	if(mellem < - 0.5)  RESET_peger = 1;
	if(RESET_peger == 1)  goto soegeud;

savejob:tal = 0;
	if(AUX_peger == 2 || (AUX_peger == - 1 && parm == 2))  {
	     nametest(0);
	     if(mabaton == - 55)  tal = 1;
	    }
	if(tal != 0)  goto punkt1;

	for(tal = 1; tal <= 34; tal++)  summe[tal] = bas[tal];

	if(AUX_peger == 2 || eruddata >= 1)  goto savudda;

	punforb();

	bas[34] = (double) min_posS;

	goto puudsa1;

savudda:if(parm != 2 && eruddata != 0 && jobbank >= 0)  nametest(1);

	strcpy(transname, transdata);
	if(eruddata <= 0)  {
	     tal1 = compu[styrk[0][1] - 30];
	     mellem = faktor;
	    }
	else  tal1 = 1;

	for(tal = 1; tal <= 14; tal++)  {
	     maxfun = out[tal1][tal];
	     if(maxfun > - 0.000001 && maxfun < 0.000001)  maxfun = 0.0;
	     bas[tal] = maxfun;
	    }

	if(PCT_peger != 0)  bas[14] = (double) PCT_peger;
	bas[15] = mellem;
	bas[34] = (double)  min_pos;
	bas[25] = out[tal1][0];
	bas[26] = (double)  STYR_act;

puudsa1:if(eruddata != 0 || AUX_peger == 2)  {
	     for(tal = 0; tal <= 5; tal++)  {
		  if(strcmp(timedef[tal], Uunitoftime) == 0)  break;
		 }
	     bas[27] = (double) tal;
	     if(parm != 2)  {
		  if((int) bas[26] <= - 1)  strcpy(Uskalfak, skalfak);
		  else
		      {
		       strcpy(Uskalfak, atfactor);
		       if(eruddata == - 1)  {
			    actitest(1);
			    bas[26] = (double) activnr;
			    strcpy(Uisonoj, isonoj);
			    strcpy(transname, jobnamew);
			    jobtal = - Rjobtal;
			   }
		      }
		 }
	     for(tal = 1; tal <= 4; tal++)  {
		  if(strcmp(isofac[tal], Uskalfak) == 0)  break;
		 }
	     bas[28] = (double) tal;
	    }
	else
	    {
	     unit_num();
	     strcpy(Uisonoj, isonoj);
	    }

	for(tal = 1; tal <= 15; tal++)  {
	     if(strcmp(isoval[tal], Uisonoj) == 0)  break;
	    }
	bas[29] = (double) tal;

	selekt = 1;
	goto pusave1;

resetud:jobtal = - Rjobtal;
	goto punkt1x;

saveslu:if(KONS_job < - 1 || jobbank == - 3)  goto deconso;
soegeud:goto punkt1x;

deconso:SAVE_peger = 1;
	selekt = abs(KONS_job);
	styrk[0][2] = - (selekt + 1);
	fmem1 = fopen("MASICONS", "rt");
pusave1:fmem2 = fopen("MASIBASE", "rt+");
	styrefiler = 1;

	for(nuta = 1; nuta <= selekt; nuta++)  {
	     if(selekt == 1)  goto pusade;

	     sas[0] = (double) nuta;
	     fmem5 = fmem1;
	     finubase();
	     if(jobbank == - 3)  goto pusade;

	     numskal(- 1);

	     if((int) bas[26] >= 1)  {
		  actitest(1);
		  strcpy(transname, jobnamew);
		 }

     pusade: tal2 = 0;
	     if(basenum[0] >= jobmax + 1)  tal1 = - basenum[jobmax + 1];
	     else
		 {
		  tal2 = 1;
		  antalibase = antalibase + 1;
		  tal1 = - antalibase;
		 }
	     jobmax = jobmax + 1;
	     sas[0] = (double) tal1;
	     if(tal2 == 0)  goto poskri;
	     basenum[0] = basenum[0] + 1;

      poskri:fmem5 = fmem2;
	     sknubase();

	     basenum[jobmax] = (int) sas[0];
	     if(tal2 == 0)  uddata = jobmax;
	     else  uddata = - jobmax;

	     endjob = uddata;
	     savenuba(uddata, endjob);

	     if((int) bas[25] >= 0 && overstar == 0 && eruddata != - 1)  strcpy(promtstr[1], transname);
	    }
	fclose(fmem2);
	styrefiler = 0;
	if(selekt == 1)  goto saveslu;
	fclose(fmem1);

punkt1x:strcpy(jobnamew, Rjobnamew);
	strcpy(atfactor, Rfaktor);
	strcpy(isonoj, Risonoj);
	for(tal = 0; tal <= 34; tal++)  {
	     if(tal <= 8)  strcpy(paratex[tal], Rparatex[tal]);
	     if(RESET_peger != 1)  bas[tal] = summe[tal];
	    }
	actitest(1);

punkt1: if(eruddata >= 1 && mabaton == 4)  mabaton = 0;
	eruddata = 0;

}
