/*
	filcheck.c

	08/11/95
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

extern FILE *fmem5;

extern char jobnamew[];
extern char filbasis[];
extern char dirbase_R[];
extern char installed[];
extern char Uunitoftime[];
extern char Uisonoj[];
extern char netdrev[];

char transdata[80];
char transname[80];
char sti_server[20];
char YESnovalg[5];
char valgdrive[5];
char facstri[10];
char unistri[60];
char dimstri[30];
char printstri[30];
char compu[51];
char raekkenr[3];
char FILECOMM[20];
char installed[20];

char komfejl = 0;

extern char min_pos;

char *isoval[16] = {"","EUR","SEK","FIM","NOK","DKK","GBP","CHF","USD","EEK","LVL","LTL","PLN","CZK","HUF","JYP"};
// 20
char *timedef[6] = {"Month (t)","Year  (T)","Halfyear (t)","Tertial (t)","Quater (t)","Mixed time"};
// 10
char *dimvis[5] = {"val","val/t","pce","pce/t","val/p"};
// 5
char *isofac[5] = {""," ","K","M","G"};
// 20
char *printset[2] = {"Paper tape","A4 Sheet"};

char *tid_Refer[37];
char *valtype[3];
char *paratex[82];
char *coparatex[12];
char *coisonoj[12];
char *counitoftime[12];
char *promtstr[8];

double out[11][15];
double sas[35];
double wbas[12];

extern int styrk[3][3];

extern int basenum[];
extern int telec[];

extern int jobtotal;
extern int jobtotalt;
extern int nummer;
extern int aktside;
extern int refaktside;
extern int starbud;
extern int jobmax;
extern int jobtal;
extern int jobmaxt;
extern int mabaton;

void initvara(char parm)
{
	int tal, tal1;

	if(parm == 1)  goto punkt1;

	for(tal = 0; tal <= 81; tal++)   {
	     paratex[tal] = malloc(32);
	     paratex[tal][0] = '\0';
	     if(tal <= 40)  {
		  for(tal1 = 0; tal1 <= 14; tal1++)  {
		       if(tal <= 2 && tal1 <= 2)  styrk[tal][tal1] = 0;
		       if(tal <= 10)  out[tal][tal1] = 0.0;
		      }
		 }
	     if(tal <= 36)  {
		  tid_Refer[tal] = malloc(5);
		  tid_Refer[tal][0] = '\0';
		 }
	     if(tal <= 34)  sas[tal] = 0.0;
	     if(tal <= 11)  {
		  coparatex[tal] = malloc(32);
		  coparatex[tal][0] = '\0';
		  counitoftime[tal] = malloc(20);
		  counitoftime[tal][0] = '\0';
		  coisonoj[tal] = malloc(5);
		  coisonoj[tal][0] = '\0';
		  wbas[tal] = 0.0;
		 }
	     if(tal <= 7)  {
		  promtstr[tal] = malloc(80);
		  promtstr[tal][0] = '\0';
		 }
	     if(tal <= 2)  {
		  valtype[tal] = malloc(10);
		  valtype[tal][0] = '\0';
		 }
	    }

	strcpy(valtype[1], "Avista");
	strcpy(valtype[2], "Budget");

	strcpy(sti_server, "\\MASI\\");
	strcpy(raekkenr, "1");
	strcpy(YESnovalg, "off");

	printstri[0] = '\0';
	unistri[0] = '\0';
	facstri[0] = '\0';
	dimstri[0] = '\0';
	strcat(dimstri, dimvis[0]);
	strcat(dimstri, ",");
	for(tal = 1; tal <= 4; tal++)  {
	     if(tal <= 2)  strcat(printstri, printset[tal - 1]);
	     strcat(unistri, timedef[tal]);
	     strcat(facstri, isofac[tal]);
	     strcat(dimstri, dimvis[tal]);
	     if(tal <= 1)  strcat(printstri, ",");
	     if(tal <= 3)  {
		  strcat(unistri, ",");
		  strcat(facstri, ",");
		  strcat(dimstri, ",");
		 }

	    }

	compu[0] = compu[12] = compu[22] = compu[43] = compu[50] = compu[32] = 1;
	compu[1] = compu[13] = compu[23] = compu[42] = compu[49] = compu[33] = 2;
	compu[2] = compu[14] = compu[24] = compu[41] = compu[48] = compu[34] = 3;
	compu[3] = compu[15] = compu[25] = compu[40] = compu[47] = 4;
	compu[4] = compu[16] = compu[26] = compu[39] = compu[46] = 5;
	compu[5] = compu[17] = compu[27] = compu[38] = compu[45] = 6;
	compu[6] = compu[18] = compu[28] = compu[37] = compu[44] = 7;
	compu[7] = compu[19] = compu[29] = compu[36] = 8;
	compu[9] = compu[20] = compu[30] = compu[35] = 9;
	compu[11] = compu[21] = compu[31] = compu[8] = compu[10] = 10;

return;

punkt1:	for(tal = 0; tal <= 81; tal++)   {
	     free(paratex[tal]);
	     if(tal <= 24)  free(tid_Refer[tal]);
	     if(tal <= 11)  {
		  free(coparatex[tal]);
		  free(counitoftime[tal]);
		  free(coisonoj[tal]);
		 }
	     if(tal <= 7)  free(promtstr[tal]);
	     if(tal <= 2)  free(valtype[tal]);
	    }

}

int laesimpo(void)
{
char postlas[90], strmellem[80];
char tal, tal1, tal2, tegn, posi, erminus, erpunkt, fejl;
double  mellem;

//  Navn
	transname[0] = '\0';
	if(fgets(postlas, 90, fmem5) == NULL)  return(2);

	tal = strlen(postlas) - 1;
	if(tal <= 30)  {
	     strncat(transname, postlas, tal);
	     if(strncmp(transname, "                               ", tal) == 0)  tal = 31;
	    }
	if(tal > 30)  {
	     fejlmeld(147);
	     return(1);
	    }

	for(tal = 1; tal <= 17; tal++)  {
	     strmellem[0] = '\0';
	     fgets(postlas, 90, fmem5);
	     strncat(strmellem, postlas, strlen(postlas) - 1);
	     erminus = 0;
	     erpunkt = 0;
	     for(posi = 0; posi <= strlen(postlas) - 2; posi++)  {
		  fejl = 0;
		  if(tal <= 12)  {
		       if(erminus == 0 && posi == 0 && strmellem[posi] == 45)  {
			    erminus = 1;
			    fejl = 1;
			   }
		       if(erpunkt == 0 && strmellem[posi] == 46)  {
			    erpunkt = 1;
			    fejl = 1;
			   }
		       tal2 = 48;
		      }
		  else  tal2 = 49;
		  for(tegn = tal2; tegn <= 57; tegn++)  {
		       if(strmellem[posi] == tegn)  {
			    fejl = 1;
			    break;
			   }
		      }
		  if(fejl == 0)  {
		       styrk[2][2] = tal;
		       if(tal <= 12)  tal1 = 48;
		       else  tal1 = 73;
		       fejlmeld(tal1);
		       return(1);
		      }
		 }

	     if(tal <= 12)  {
// Numeriske vrdier
		  mellem = atof(strmellem);
		  out[1][tal] = mellem;
		  tal1 = tal;
		 }
	     else
		  {
		   mellem = (double) atoi(strmellem);
// Periode lngde
		   if(tal == 13)  {
			if(mellem > 12.0)  fejl = 0;
			else
			    {
			     out[1][0] = mellem;
			     tal1 = 25;
			    }
		       }
// Periode start
		   if(tal == 14)  {
			if(mellem > 12.0)  fejl = 0;
			else
			    {
			     mellem = 13.0 - mellem;
			     tal1 = 34;
			    }
		       }
// Tidsenhed
		   if(tal == 15)  {
			if(mellem > 4.0 && mellem != 12.0)  fejl = 0;
			else
			    {
			     if(mellem == 12.0)  mellem = 0.0;
			     tal1 = 27;
			    }
		       }
// Valuta
		   if(tal == 16)  {
			if(mellem > 15.0)  fejl = 0;
			else
			    {
			     strcpy(Uisonoj, isoval[(int) mellem]);
			     tal1 = 29;
			    }
		       }
// Dimension
		   if(tal == 17)  {
			mellem = mellem - 1.0;
			if(mellem > 5.0)  fejl = 0;
			else
			    {
			     out[1][13] = mellem;
			     tal1 = 13;
			    }
		       }
		  }

	     if(fejl == 0)  {
		  styrk[2][2] = tal;
		  fejlmeld(35);
		  return(1);
		 }

	     if(mellem > - 0.000001 && mellem < 0.000001)  mellem = 0.0;
	     sas[tal1] = mellem;
	    }

	sas[26] = - 1.0;
	numskal(6);
	sas[15] = out[0][0];
	for(tal = 1; tal <= 12; tal++)  sas[tal] = out[1][tal];

	strcpy(paratex[0], transname);
	pegestri(1,1);
	strcpy(transname, promtstr[0]);
	strcat(transname, "Importeret");

return(0);
}

void skrivexpo(void)
{
char strmellem[40];
int tal, tal1;
double mellem;

	strmellem[0] = '\0';
	strncat(strmellem, transname, 30);
	fprintf(fmem5, "%s\n", strmellem);

	for(tal = 1; tal <= 17; tal++)  {
	     if(tal <= 12)  {
		  mellem = sas[15] * sas[tal];
		  fprintf(fmem5, "%f\n", mellem);
		 }
	     else
		 {
		  if(tal == 13)  tal1 = (int) sas[25];
		  if(tal == 14)  tal1 = 13 - (int) sas[34];
		  if(tal == 15)  {
		       if(sas[27] == 0.0)  tal1 = 12;
		       else  tal1 = (int) sas[27];
		      }
		  if(tal == 16)  tal1 = (int) sas[29];
		  if(tal == 17)  tal1 = 1 + (int) sas[13];
		  fprintf(fmem5, "%d\n", tal1);
		 }
	    }

}

int fileshare(char skriv, char parm)
{
FILE *fmem1;
char strmellem[40];

	if(strcmp(valgdrive, dirbase_R) == 0)  strcpy(strmellem, dirbase_R);
	else strcpy(strmellem, netdrev);

	strcat(strmellem, sti_server);
	if(parm == 1)  strcat(strmellem, "MASIMULT");
	else  strcat(strmellem, "MASISESS");

	if((fmem1 = fopen(strmellem, "rt+")) == NULL)  {
	     mabaton = - 1;
	     return(1);
	    }
	else
	    {
	     if(skriv == 0)  {
		  fgets(strmellem, 40, fmem1);
		  if(strncmp(strmellem, "1", 1) == 0)  {
		       mabaton = - 2;
		       fclose(fmem1);
		       return(1);
		      }
		  fseek(fmem1, 0, 0);
		  fprintf(fmem1, "1\n");
		 }
	     else  fprintf(fmem1, "0\n");
	     fclose(fmem1);
	    }

return(0);
}

void uddstop(void)
{
int tal, tal1, nuta, uddata;

	uddata = 0;
	nuta = 0;
	for(tal1 = 1; tal1 <= jobtal; tal1++)  {
	     for(tal = 1; tal <= jobmax; tal++)  {
		  if(telec[tal] == tal1)  {
		       uddata = uddata + 1;
		       telec[tal] = uddata;
		       nuta = tal;
		       break;
		      }
		 }
	    }
	jobtal = - uddata;
	if(nuta == 0)  refaktside = 0;
	else  refaktside = 1 + (int) (((double) (nuta - 1))/20.0);
	aktside = refaktside;

}
/*
int testprot(unsigned int cyberlok[])
{
FILE *fmem1;
char *cyberdata[8], postlas[90], retstring[90], gemstring[80], dirbase[90];
char tal, tal1, tal2, tal3, nuta;

	for(tal = 0; tal <= 7; tal++)  {
	     cyberdata[tal] = malloc(10);
	     if(tal <= 3)  sprintf(cyberdata[tal], "%u", cyberlok[3 - tal]);
	    }

	for(nuta = 1; nuta <= 2; nuta++)  {
	     if(nuta == 1)  tal3 = 3;
	     else  tal3 = 7;
	     tal2 = - 1;
	     for(tal = 0; tal <= 10; tal++)  {
		  for(tal1 = 0; tal1 <= tal3; tal1++)  {
		       if(tal < strlen(cyberdata[tal1]))  {
			    tal2 = tal2 + 1;
			    dirbase[tal2] = cyberdata[tal1][tal];
			    strrev(cyberdata[tal1]);
			    tal2 = tal2 + 1;
			    dirbase[tal2] = cyberdata[tal1][tal];
			   }
		      }
		 }
	     dirbase[tal2 + 1] = '\0';
	     if(nuta == 1)  {
		  strcpy(gemstring, dirbase);
		  strcpy(retstring, dirbase);
		  tal = 0;
		  for(tal1 = 0; tal1 <= 7; tal1++)  {
		       cyberdata[tal1][0] = '\0';
		       tal = tal + 5;
		       strncat(cyberdata[tal1], retstring, 5);
		       strrev(retstring);
		       postlas[0] = '\0';
		       strncat(postlas, retstring, 40 - tal);
		       strrev(postlas);
		       strcpy(retstring, postlas);
		      }
		 }
	    }
	for(tal = 0; tal <= 7; tal++)  free(cyberdata[tal]);

	retstring[0] = '\0';
	if((fmem1 = fopen("MASIPROT", "rt")) != NULL)  {
	     fgets(postlas, 90, fmem1);
	     strncat(retstring, postlas, strlen(postlas) - 1);
	     fclose(fmem1);
	    }

	strcpy(postlas, dirbase_R);
	strcat(postlas, "\\MASI\\MASISIGN");

	if(strcmp(retstring, dirbase) != 0)  {
	     fmem1 = fopen(postlas, "wt");
		  fprintf(fmem1, "%s\n", gemstring);
	     fclose(fmem1);
	     return(1);
	    }
	else
	    {
	     strcpy(transname, postlas);
	     fileremo();
	     return(0);
	    }
}
*/
void overbank(char parm)
{
int tal;

	tal = nummer;
	if(strcmp(filbasis, "MASIBASE") == 0)  tal = basenum[tal];

	sas[0] = (double) tal;
	fmem5 = fopen(filbasis, "rt");
	finubase();
	fclose(fmem5);

	if(parm == 0)  return;

	tal = (int) sas[27];
	strcpy(Uunitoftime, timedef[tal]);
	tal = (int) sas[29];
	strcpy(Uisonoj, isoval[tal]);

	min_pos = (char) sas[34];

	if((int) sas[26] <= - 1)  {
	     out[1][0] = sas[25];
	     for(tal = 1; tal <= 14; tal++)  out[1][tal] = sas[tal];
	     out[0][0] = sas[15];
	     paratex[0][0] = '\0';
	     strncat(paratex[0], transname, 30);
	     styrk[0][1] = 30;
	    }

}

void filstoer(FILE *fmem1)
{
       fseek(fmem1, 0, 2);
       jobmaxt = (int) ((double) ftell(fmem1)/888.0);
       fclose(fmem1);
}

void taeljob(void)
{
FILE *fmem1;
char fejl;
int tal, tal1, tal2, nuta, Btype;

	Btype = styrk[1][1];

	if(strcmp(valgdrive, dirbase_R) == 0)  goto punvidC;

	tal = 0;
	tal1 = 0;
	tal2 = 0;
	nuta = 0;
	if(strcmp(valgdrive, "A:") == 0)  tal1 = testdisk();

	strcpy(FILECOMM, valgdrive);
	if(strcmp(valgdrive, netdrev) == 0)  strcat(FILECOMM, sti_server);
	else  strcat(FILECOMM, "\\");
	strcat(FILECOMM, "MASICOMM");

	if(strcmp(valgdrive, netdrev) == 0 || (strcmp(valgdrive, "A:") == 0 && tal1 >= 1))  {
	     if((fmem1 = fopen(FILECOMM, "rt")) != NULL)  {
		  filstoer(fmem1);
		  if(Btype == 25)  {
		       strcpy(transname, netdrev);
		       strcat(transname, sti_server);
		       strcat(transname, "MASIMULT");
		       tal = netaabne();
		       strcpy(transname, FILECOMM);
		       tal2 = netaabne();
		      }
		  if(Btype != 25 || (Btype == 25 && tal == 0 && tal2 == 0))  nuta = 1;
		 }
	     if(strcmp(valgdrive, "A:") == 0 && (1453 > styrk[0][2] + (int) (888.0 * ((double) (jobmaxt))/1000.0)))  tal1 = tal1 + 2;
	    }

   if(Btype != 25 && nuta == 0 && strcmp(valgdrive, netdrev) == 0)  {
	     fejlmeld(155);
	     Speaker();
	    }
	if(nuta == 0 && strcmp(valgdrive, netdrev) == 0)  goto punvidC;
	if(nuta == 1 && strcmp(valgdrive, netdrev) == 0)  goto punvidD;

	if(tal1 != 1)  {
      omigen:if(mabaton > 10000)  {
		  if(mabaton == 12000)  tal2 = 4;
		  if(mabaton == 13000)  tal2 = 96;
		  if(mabaton == 14000)  tal2 = 58;
		 }
	     else
		 {
		  if(tal1 == 3 || tal1 == 5)  {
		       tal2 = 7;
		       if(tal1 == 5)  tal1 = 6;
		      }
		  else
		      {
		       tal2 = 9;
		       if(tal1 == 4)  tal1 = 5;
		      }
		 }
	     fejlmeld(tal2);
	     if(tal1 == 5)  goto omigen;
	    }

	if(tal1 >= 1)  {
	     diskkode();
	     strcpy(installed, transdata);
	     fmem1 = fopen("A:\\MASIIDEN", "wt");
	     fprintf(fmem1, "%s\n", installed);
	     fclose(fmem1);

	     jobtotalt = 1620;
	    }
	if(tal1 >= 1)  goto punvid1;

punvidC:strcpy(valgdrive, dirbase_R);
	strcpy(FILECOMM, valgdrive);
	strcat(FILECOMM, sti_server);
	strcat(FILECOMM, "MASICOMM");
punvidD:if(Btype == 25)  return;
	jobtotalt = jobtotal;

punvid1:komfejl = 0;
	fejl = 0;
	if((fmem1 = fopen(FILECOMM, "rt")) == NULL)  fejl = 1;
	else  filstoer(fmem1);
	if(fejl != 0)  {
	     komfejl = 1;
	     fejlmeld(8);
	    }

}

void taeldrev(void)
{
char *drev[23] = {"C:","D:","E:","F:","G:","H:","I:","J:","K:","L:","M:","N:","O:","P:","Q:","R:","S:","T:","U:","V:","X:","Y:","Z:"};
char strmellem[5], drevstring[80], filecomm_R[20];
int tal;

	styrk[1][1] = 25;
	strcpy(strmellem, valgdrive);
	strcpy(filecomm_R, FILECOMM);

	drevstring[0] = '\0';
	strcat(drevstring, ",");
	for(tal = 0; tal <= 22; tal++)  {
	     if(strncmp(dirbase_R, drev[tal], 2) == 0)  continue;
	     valgdrive[0] = '\0';
	     strncat(valgdrive, drev[tal], 2);
	     strcpy(netdrev, valgdrive);
	     taeljob();
	     if(strcmp(valgdrive, dirbase_R) != 0)  {
		  strncat(drevstring, drev[tal], 2);
		  strcat(drevstring, ",");
		 }
	    }

	transdata[0] = '\0';
	strcat(transdata, "A:,");
	strcat(transdata, dirbase_R);
	if(strlen(drevstring) >= 2)  strncat(transdata, drevstring, strlen(drevstring) - 1);

	strcpy(FILECOMM, filecomm_R);
	strcpy(valgdrive, strmellem);
	styrk[1][1] = 0;

}

void filcheck(void)
{
int tal;

	if(strcmp(valgdrive, "A:") == 0)  {
	     if(2 == testdisk())  mabaton = 15000;
	     if(mabaton > 10000)  {
		  if(mabaton == 12000)  tal = 4;
		  if(mabaton == 13000)  tal = 96;
		  if(mabaton == 14000)  tal = 58;
		  if(mabaton == 15000)  tal = 5;
		  fejlmeld(tal);
		 }
	    }

	if(strcmp(valgdrive, netdrev) == 0)  {
	     taeljob();
	     if(strcmp(valgdrive, dirbase_R) == 0)  mabaton = 16000;
	    }

}
