#include <bios.h>
#include <mem.h>
#include <dos.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>

typedef unsigned char byte;
#define NUL 0
#define _DISK_DRIVE_A 0
#define _DISK_SET_DASD_TYPE  0x17
#define _DISK_SET_MEDIA_TYPE 0x18

struct tFormatAddr {
	byte Track;
	byte Head;
	byte Sector;
	byte Size;
};
struct tDiskBase {
	byte step_head_unload_time;
	byte head_load_time;
	byte wait_motor_off;
	byte bytes_sector;
	byte last_sector;
	byte gap_length;
	byte data_length;
	byte gap_len_format;
	byte data_val_for_format;
	byte head_settle_time;
	byte motor_start_time;
};

void main(void)
{
FILE *fmem1;

	byte track,head;
	tDiskBase gemdb;
	tDiskBase *db;
	char buffer[512];
	byte sector;
	byte nsects;
	byte status;
	byte trackno;
	byte secno;
	tFormatAddr fa[36];

       char refstre[100];
       char deltastr[20];
       char string[512];
       char typekode[10];

       char stridate[20];
       char striline[100];

       char licensee[80];

       struct date d;
       struct REGPACK reg;

       int tal, tal1, nuta, nutch, pas;

       getdate(&d);

	    strcpy(stridate, "");
	    itoa(d.da_day, deltastr, 10);
	    if(d.da_day <= 9)  strncat(stridate, " ", 1);
	    strncat(stridate, deltastr, strlen(deltastr));
	    strncat(stridate, " - ", 3);
	    itoa(d.da_mon, deltastr, 10);
	    if(d.da_mon <= 9)  strncat(stridate, " ", 1);
	    strncat(stridate, deltastr, strlen(deltastr));
	    strncat(stridate, " - ", 3);
	    itoa((int) d.da_year, deltastr, 10);
	    strncat(stridate, deltastr, strlen(deltastr));

	    strcpy(striline, "[ ");
	    strcat(striline, stridate);
	    strcat(striline, " ]");

       pas = 0;

start1:clrscr();
       if(pas > 0.5)  {
	    textbackground(BLUE);
	    textcolor(YELLOW);
	   }
       else
	   {
	     textbackground(RED);
	     textcolor(WHITE);
	    }
       printf("\n");
start: clrscr();
       if(pas > 0.5)  {
	    textbackground(BLUE);
	    textcolor(YELLOW);
	   }
       else
	   {
	     textbackground(RED);
	     textcolor(WHITE);
	    }
       printf("");
       printf("\n");
       printf("          L I C E N S   p  3 1/2 ''  DOS disketter 720 KB og 1.44 MB\n");
       printf("\n");
       printf("    COPYRIGHT (C) 1981 - 1992  civ. ing. Hans Jessen HD  Copenhagen Denmark\n");
       printf("\n");
       printf("%s", striline);
       gotoxy(1,22);
       printf("");
       gotoxy(1,24);
       printf("");
       gotoxy(21,22);
       printf("");
       gotoxy(21,23);
       printf("");
       gotoxy(22,23);
       printf("");
       gotoxy(21,24);
       printf("");
       if(pas > 0.5)  goto punpas;
       tal1 = 0;
       gotoxy(1,14);
       printf("                                P A S S W O R D  ?");
       gotoxy(38,16);
       for(tal = 1; tal <= 5; tal++)  {
	    nutch = getch();
	    printf("*");
	    if(nutch == 27)  break;
	    if(tal == 1 && nutch != 102)  tal1= 1;
	    if(tal == 2 && nutch != 105)  tal1= 1;
	    if(tal == 3 && nutch != 108)  tal1= 1;
	    if(tal == 4 && nutch != 117)  tal1= 1;
	    if(tal == 5 && nutch != 114)  tal1= 1;
	    if(tal == 5 && tal1 < 0.5)  pas = 1;
	   }
       if(nutch == 27)  goto punend;
       if(tal1 > 0.5)  goto punkt1;
       goto start1;
punpas:status = biosdisk(2,_DISK_DRIVE_A, 0, 79, 1, 1, buffer);
       if(status)  biosdisk(0,_DISK_DRIVE_A,NUL,NUL,NUL,NUL,NULL);

       nsects = 18;
       for(sector = 8; sector <= 10; sector++)  {
	  status = biosdisk(2,_DISK_DRIVE_A, 0, 79, sector, 1, buffer);
	  if(status) break;
	 }
       if(status && (sector == 10))  {
	   nsects = 9;
	   biosdisk(0,_DISK_DRIVE_A,NUL,NUL,NUL,NUL,NULL);
	  }

       if(status && sector == 8)  {
	     biosdisk(0,_DISK_DRIVE_A,NUL,NUL,NUL,NUL,NULL);
	     gotoxy(1,14);
	     printf("                  Disketten er ikke   F O R M A T T E R E T  !");
	    }

       if(sector == 8)  goto punkt1;

       trackno = 82;
       secno = 1;

       gotoxy(1,9);
       if(nsects == 18)  printf("                                 Format 1.44 MB");
       else  printf("                                 Format 720 KB");
       gotoxy(1,11);
       printf("                                    Kode: ");
       nutch = getch();
       printf("*");
       if(nutch != 33 && nutch != 36 && nutch != 51 && nutch != 53)  {
	      gotoxy(1,14);
	      printf("                                U G Y L D I G  !\n");
	     }
       if(nutch != 33 && nutch != 36 && nutch != 51 && nutch != 53)  goto punkt1;
       gotoxy(1,13);
       for(nuta = 1; nuta <= 80; nuta++) printf("");
       gotoxy(1,19);
       if(nutch == 33)  {
		   strcpy(typekode, "DEM");
		   strcpy(deltastr, " D-E-M-O !");
		   strcpy(refstre, "COPYRIGHT (C) 1981 - 1992  civ. ing. Hans Jessen HD  Copenhagen Denmark : ");
		   }
       if(nutch == 36)  {
		   strcpy(typekode, "DAT");
		   strcpy(deltastr, "$MASIDATA$");
		   strcpy(refstre, "COPYRIGHT (C) 1981 - 1992  civ. ing. Hans Jessen HD  Copenhagen Denmark : ");
		   }
       if(nutch == 33 || nutch == 36)  goto skriv;
licskr:if(nutch == 51)  {
		   strcpy(licensee, "L I C E N S   K a r t o t e k");
		   gotoxy(1,17);
		   strcpy(typekode, "KAT");
		   strcpy(refstre, "COPYRIGHT (C) 1984  Dipl.-Kfm. & Dipl.-Ing. Hans Graae :");
		   printf("               ....|....|....|\n");
		   printf(" Kartotek nr.:>");
		   gets(deltastr);
		   if(strlen(deltastr) != 15)  goto licskr;
		   trackno = 80;
		   secno = 1;
		  }
       if(nutch == 53)  {
	   punlic: gotoxy(1,15);
		   printf(" >                                Licenstager                               <\n");
		   printf(" >");
		   gets(licensee);
		   if(strlen(licensee) < 10 || strlen(licensee) > 76)  goto punlic;
	   punlice:gotoxy(1,17);
		   strcpy(typekode, "LIC");
		   strcpy(refstre, "COPYRIGHT (C) 1981 - 1992  civ. ing. Hans Jessen HD  Copenhagen Denmark : ");
		   printf("             ....|....|\n");
		   printf(" Licens nr.:>");
		   gets(deltastr);
		   if(strlen(deltastr) != 10)  goto punlice;
		  }

skriv: absread(_DISK_DRIVE_A,1,0,buffer);
// St diskette type op
	db=(tDiskBase *)getvect(0x1e);
	memcpy(&gemdb,db,sizeof(tDiskBase));
	db->gap_len_format=0x50;
	db->last_sector=0x09;
	biosdisk(_DISK_SET_DASD_TYPE,_DISK_DRIVE_A,NUL,NUL,NUL,0x20,NULL);
	biosdisk(_DISK_SET_MEDIA_TYPE,_DISK_DRIVE_A,NUL,39,nsects,NUL,NULL);

// Formater
		for(head=0;head<=1;head++)  {
		     for(sector = 0; sector < nsects; sector++)  {
			 fa[sector].Track  = trackno;
			 fa[sector].Head   = head;
			 fa[sector].Sector = sector+1;
			 fa[sector].Size   = 2;
			}
		     status=biosdisk(5,_DISK_DRIVE_A,head,trackno,1,nsects,&fa);
		     if (status) biosdisk(0,_DISK_DRIVE_A,NUL,NUL,NUL,NUL,NULL);
		    }

// Genetabler diskette type
	memcpy(&gemdb,db,sizeof(tDiskBase));

       strcpy(string, refstre);
       strcat(string, deltastr);
       biosdisk(3,_DISK_DRIVE_A, 0, trackno, secno, 1, string);
       biosdisk(2,_DISK_DRIVE_A, 0, trackno, secno, 1, buffer);

punskr:if(strcmp(string, buffer) != 0)  {
	      gotoxy(1,20);
	      printf("                                  F E J L  !\n");
	     }
       else
	    {
       pungen:gotoxy(1,20);
	      printf("                                                                            ");
	      gotoxy(1,20);
	      printf("     %s --->", typekode);
	      printf("   P R I N T  Ja/Nej ? ");
	      tal = getch();
	      if(tal != 78 && tal != 110)  {
		      intr(5, &reg);
		      printf("   O.K.  Ja/Nej ? ");
		      tal1 = getch();
		     }
	      if((tal != 78 && tal != 110) && (tal1 != 74 && tal1 != 106))  goto pungen;
	      if((nutch == 51 || nutch == 53) && (tal != 78 && tal != 110))  {
		    if((fmem1 = fopen("MASILICE", "at")) == NULL)  {
			gotoxy(1,20);
			printf("                    L I C E N S F I L   er ikke installeret !\n")  ;
			printf("\n");
			printf("Tryk  RETURN");
			getch();
		       }
		    if((fmem1 = fopen("MASILICE", "at")) == NULL)  goto punend;
			strcat(deltastr, "<|>");
			strcat(deltastr, stridate);
			strcat(deltastr, "<1|");
			strcat(licensee, "<2|");
			fprintf(fmem1, "%s\n", deltastr);
			fprintf(fmem1, "%s\n", licensee);
			fclose(fmem1);
		   }
	     }

punkt1:gotoxy(1,23);
       printf(" Afslut  Ja/Nej ? ");
       tal = getch();
       if(tal != 74 && tal != 106)  goto start;
punend:textbackground(0);
       normvideo();
       clrscr();
}
