/*
	sysbank.c

	08/11/95
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern char findstring[];
extern char yesnovalg[];
extern char Uisonoj[];

char jobnamew[80];
char unitoftime[20];
char atfactor[5];
char isonoj[5];
char valorden[16];
char sydata[7];
char password[8];
char printtype[20];

extern char activnr;
extern char eruddata;
extern char pctcalc;
extern char calcover;
extern char variper;
extern char FASE_peger;
extern char DELTA_peger;

char nextime;
char sam_tid = 1;

extern char *isoval[];
extern char *printset[];
extern char *paratex[];
extern char *timedef[];
extern char *isofac[];

extern double out[11][15];

double valuta[4][16];

extern double sas[];
extern double wbas[];

double bas[35];
double cas[35];
double das[25];
double conbas[5];

double faktor;
double X1, X2, X3, X4, X5;
double X6, X7, X8, X9;
double X10, X11, X12, X13;
double X14, X15, X16, X17, X18;
double X19, X20, X21;

extern float Bout[50][15];

float cout[61][15];
float senac1[41][22];
float senac2[41][22];

extern int telec[];

int basenum[10000];
int sencomp[44];

extern int styrk[3][3];

extern int calctime;
extern int nutime;
extern int fas1time;
extern int rappage;
extern int starbud;
extern int jobtal;
extern int jobmax;
extern int calcno;
extern int mabaton;

int protected;
int antalibase;

void numwor(void)
{
double X22;
int tal, tal1;

	 faktor = 1.0;
	 tal1 = (int) bas[28];
	 for(tal = 1; tal <= tal1 - 1; tal++)  faktor = 1000.0 * faktor;

	 for(tal = 1; tal <= 21; tal++)  {
	      if(das[tal] < - 40.0 || das[tal] > 40.0 || (bas[tal] > - 0.00001 && bas[tal] < 0.00001) || (tal == 12 && bas[6] == 0.0) || (tal == 13 && bas[7] == 0.0))  das[tal] = 0.0;
	      cas[tal] = bas[tal] * (1.0 + das[tal]/100.0);
	     }

	 X22 = bas[27]/360.0;

	 X1 = faktor * cas[1];
	 X2 = cas[2];
	 X3 = faktor * cas[3];
	 X4 = X22 * cas[4];
	 X5 = cas[5]/100.0;

	 X6 = faktor * cas[6];
	 X7 = faktor * cas[7];
	 X8 = X22 * cas[8];
	 X9 = cas[9]/100.0;

	 X10 = X22 * cas[10];
	 X11 = X22 * cas[11];

	 X12 = cas[12]/100.0;
	 X13 = cas[13]/100.0;

	 X14 = faktor * cas[14];

	 X15 = faktor * cas[15];
	 X16 = cas[16]/(100.0 * bas[27]);
	 X17 = cas[17]/(100.0 * bas[27]);
	 X18 = faktor * cas[18];

	 X19 = cas[19]/(100.0 * bas[27]);
	 X20 = cas[20]/100.0;
	 X21 = cas[21]/100.0;

	 X22 = cas[22]/(100.0 * bas[27]);

	 cout[31][0] = (float) (X3 * (1.0 - X5) * X2 * X4 * (1.0 + X22 * (0.0 - 0.5 * X4)));
	 cout[23][0] = (float) (X7 * X13 * X10 * X2);
	 cout[24][0] = (float) ((X13 * X7 + X12 * X6) * X11 * X2);
	 cout[40][0] = (float) (X7 * X13 * (1.0 - X9) * X2 * X8 * (1.0 + X22 * (X11 + X10 + 0.0 - 0.5 * X8)));

	 bas[0] = cout[31][0] + cout[23][0] + cout[24][0] - cout[40][0];
	 X22 = bas[0]/faktor;
	 if(X22 > - 0.000001 && X22 < 0.000001)  X22 = 0.0;
	 wbas[1] = X22;

}

void worksyst(void)
{
char overflow;
int tal;
double  bascalc, referen;

	 tal = 0;
	 overflow = 0;

	 numwor();
	 referen = 360.0 * faktor;
	 bascalc = 360.0 * bas[27]/referen;
	 wbas[2] = bascalc * X3 * (1.0 - X5) * X2;
	 wbas[3] = bascalc * X7 * X13 * (1.0 - X9) * X2;
	 wbas[5] = bascalc * X7 * X13 * X2;
	 wbas[6] = bascalc * (X7 * X13 + X6 * X12) * X2;
	 if(wbas[4] <= 0.0 && wbas[8] == 0.0 && wbas[10] <= 0.0 && wbas[11] <= 0.0)  goto  punend;

	 if(wbas[4] != 0.0)  {
	      if(X3 == 0.0 || X5 == 1.0)  {
		   bas[4] = 0.0;
		   if(X3 == 0.0)  bas[5] = 0.0;
		  }
	      else
		  {
		   bascalc = referen * wbas[4]/(X3 * (1.0 - X5) * X2 * bas[27]);
		   overflow = 4;
		  }
	      tal = 4;
	     }

	 if(wbas[10] != 0.0)  {
	      if(X7 == 0.0)  bas[10] = 0.0;
	      else
		  {
		   bascalc = referen * wbas[10]/(X7 * X13 * X2 * bas[27]);
		   overflow = 10;
		  }
	      tal = 10;
	     }

	 if(wbas[11] != 0.0)  {
	      if(X6 == 0.0 && X7 == 0.0)  bas[11] = 0.0;
	      else
		  {
		   bascalc = referen * wbas[11]/((X7 * X13 + X6 * X12) * X2 * bas[27]);
		   overflow = 11;
		  }
	      tal = 11;
	     }

	 if(wbas[8] != 0.0)  {
	      if(X7 == 0.0 || X9 == 1.0)  {
		   bas[8] = 0.0;
		   if(X7 == 0.0)  bas[9] = 0.0;
		  }
	      else
		  {
		   bascalc = referen * wbas[8]/(X7 * X13 * (1.0 - X9) * X2 * bas[27]);
		   overflow = 8;
		  }
	      tal = 8;
	     }

	 if(overflow != 0 && !((overflow == 8 && bascalc < - 360.0) || bascalc > 360.0))  {
	      bas[overflow] = bascalc;
	      overflow = 0;
	     }

punend:	 if(overflow == 0)  {
	      if(tal != 0)  wbas[tal] = 0.0;
	      numwor();
	     }
}

void konvjobs(double summe[], char parm)
{
int tal, tal1;
double atfak, valfak, mellem, procent, hastig;
double X22, X23, X24;

	hastig = summe[27]/360.0;
	procent = 100.0 * summe[27];
	if(parm == 1)  {
	     tal = (int) sas[29];
	     summe[30] = valuta[1][tal];

	     atfak = 1.0;
	     tal1 = (int) sas[28];
	     for(tal = 1; tal <= tal1 - 1; tal++)  atfak = 1000.0 * atfak;

	     valfak = atfak * summe[30]/summe[29];

	     X1 = valfak * sas[1];

	     X3 = valfak * sas[3];
	     X6 = valfak * sas[6];
	     X7 = valfak * sas[7];
	     mellem = sas[27]/summe[27];
	     if(jobtal >= 2 || (jobtal <= 1 && sas[2] != 1.0))  X2 = sas[2] * mellem;
	     else
		 {
		  X2 = sas[2];
		  X3 = X3 * mellem;
		  X6 = X6 * mellem;
		  X7 = X7 * mellem;
		 }

	     X4 = hastig * sas[4];
	     X5 = sas[5]/100.0;

	     X8 = hastig * sas[8];
	     X9 = sas[9]/100.0;

	     X10 = hastig * sas[10];
	     X11 = hastig * sas[11];

	     X12 = 1.0;
	     X13 = 1.0;

	     X14 = valfak * sas[14] * mellem;

	     X15 = valfak * sas[15];
	     X18 = valfak * sas[18];

	     X22 = sas[22]/procent;
	     X23 = sas[23]/procent;
	     X24 = sas[24]/procent;

	     summe[1] = summe[1] + X1;
	     summe[2] = summe[2] + X2;
	     summe[3] = summe[3] + X2 * X3;
	     summe[22] = summe[22] + X2 * X3 * X22;
	     summe[4] = summe[4] + X3 * (1.0 - X5) * X2 * X4;
	     summe[5] = summe[5] + X3 * X5 * X2;

	     summe[6] = summe[6] + X6 * X2;
	     summe[7] = summe[7] + X7 * X2;
	     summe[8] = summe[8] + X7 * (1.0 - X9) * X2 * X8;
	     summe[9] = summe[9] + X7 * X9 * X2;

	     summe[10] = summe[10] + X7 * X10 * X2;
	     summe[11] = summe[11] + (X7 + X6) * X11 * X2;

	     summe[14] = summe[14] + X14;
	     summe[23] = summe[23] + X14 * X23;
	     summe[15] = summe[15] + X15;
	     summe[24] = summe[24] + X15 * X24;
	     summe[18] = summe[18] + X18;
	    }
	else
	    {
	     for(tal = 1; tal <= 30; tal++)  {
		  if(summe[tal] > - 0.000001 && summe[tal] < 0.000001)  summe[tal] = 0.0;
		 }

	     X1 = summe[1];
	     X2 = 1.0;
	     X3 = summe[3];
	     if(X3 == 0.0)  goto punso1;
	     X22 = summe[22]/X3;
	     X5 = summe[5]/X3;
	     if(X5 != 1.0)  X4 = summe[4]/(X3 * (1.0 - X5));
	     else  X4 = 0.0;
	     goto punso2;
     punso1: X22 = 0.0;
	     X5 = 0.0;
	     X4 = 0.0;

     punso2: X6 = summe[6];
	     X7 = summe[7];
	     if(X7 == 0.0) goto punso3;
	     X9 = summe[9]/X7;
	     if(X9 != 1.0)  X8 = summe[8]/(X7 * (1.0 - X9));
	     else  X8 = 0.0;
	     X10 = summe[10]/X7;
	     goto punso4;
     punso3: X9 = 0.0;
	     X8 = 0.0;
	     X10 = 0.0;

     punso4: if(X7 == 0.0  && X6 == 0.0)  goto punso5;
	     X11 = summe[11]/(X7 + X6);
	     goto punso6;
     punso5: X11 = 0.0;

     punso6: X12 = 1.0;
	     X13 = 1.0;

	     X14 = summe[14];
	     if(X14 == 0.0)  goto punso7;
	     X23 = summe[23]/X14;
	     goto punso8;
     punso7: X23 = 0.0;
     punso8: X15 = summe[15];
	     if(X15 == 0.0)  goto punso9;
	     X24 = summe[24]/X15;
	     goto punso10;
     punso9: X24 = 0.0;
     punso10:X18 = summe[18];

	     if((jobtal == 1 && activnr == 0 && sas[2] != 1.0) || (activnr != 0 && strncmp(yesnovalg, "SUM", 3) == 0))  {
		  X2 = summe[2];
		  X3 = X3/X2;
		  X6 = X6/X2;
		  X7 = X7/X2;
		 }

	     sas[1] = X1;
	     sas[2] = X2;
	     sas[3] = X3;
	     sas[4] = X4/hastig;
	     sas[5] = 100.0 * X5;

	     sas[6] = X6;
	     sas[7] = X7;
	     sas[8] = X8/hastig;
	     sas[9] = 100.0 * X9;

	     sas[10] = X10/hastig;
	     sas[11] = X11/hastig;

	     sas[12] = X12 * 100.0;
	     sas[13] = X13 * 100.0;

	     sas[14] = X14;
	     sas[15] = X15;
	     sas[18] = X18;

	     sas[22] = X22 * procent;
	     sas[23] = X23 * procent;
	     sas[24] = X24 * procent;
	    }
	if(sas[3] != 0 && sas[4] == 0.0)  sas[5] = 100.0;
	if(sas[7] != 0 && sas[8] == 0.0)  sas[9] = 100.0;

}

void konvudda(double summe[], double minfun, double maxfun, double maxskal, int starnut, int nuta)
{
int tal, tal1, uddata;
double atfak, valfak, mellem, maxtid;
double X22;

	maxtid = out[1][0];

	X22 = out[0][0];
	out[0][1] = X22;
	if(pctcalc != 2)  {
	     if(!((eruddata == 5 && mabaton == 3) || eruddata == 6 || eruddata == 7))  {
		  if(nuta <= 2)  uddata = nuta;
		  else  uddata = 2;
		 }
	     else  uddata = 1;
	    }
	else
	    {
	     uddata = nuta;
	     tal1 = (int) sas[26];
	     sas[2] = sas[2] * (1.0 + sas[22]/(100.0 * sas[27]));
	     if(tal1 == 3)  mellem = sas[2] * sas[3];
	     if(tal1 == 4)  mellem = sas[2] * sas[6];
	     if(tal1 == 5)  mellem = sas[2] * sas[7];
	     if(tal1 == 6)  mellem = 1000.0 * (1.0 + sas[23]/(100.0 * sas[27])) * sas[14];
	     if(tal1 == 7)  mellem = 1000.0 * (1.0 + sas[24]/(100.0 * sas[27])) * sas[15];
	     if(tal1 == 8)  mellem = 1000.0 * (1.0 - sas[19]/(100.0 * sas[27])) * sas[18];
	     if(tal1 >= 3 && tal1 <= 6)  sas[13] = 1.0;
	     else  sas[13] = 0.0;
	     sas[14] = 0.0;
	     sas[15] = 1.0;
	     tal1 = (int) sas[28];
	     for(tal = 1; tal <= tal1 - 1; tal++)  sas[15] = 1000.0 * sas[15];
	     sas[1] = mellem;
	     sas[25] = 1.0;
	    }

	if((int) maxtid == - 1)  maxtid = sas[25];
	else
	    {
	     if(maxtid > sas[25])  maxtid = sas[25];
	    }

	tal = (int) sas[29];
	summe[30] = valuta[1][tal];
	if(sas[13] != 2.0 && sas[13] != 3.0 && ((eruddata == 2 && (mabaton == 5 || mabaton == 6)) || (eruddata >= 3 && eruddata <= 5) || eruddata == 8 || eruddata == 9))  valfak = summe[30]/summe[29];
	else valfak = 1.0;

	if((int) sas[14] == 1)  mellem = 1.0;
	else
	    {
	     mellem = valfak * sas[15];
	     if(eruddata >= 8 && mabaton != 4)  mellem = X22 * mellem;
	    }

	for(tal = 1; tal <= 12; tal++)  out[uddata][tal] = mellem * sas[tal];

	if(eruddata == 9 && mabaton == 4)  {
	     mellem = 1.0;
	     for(tal = 1; tal <= (int) maxtid; tal++)  {
		  mellem = mellem/(1.0 + (X22/100.0));
		  if(tal == 1)  out[uddata][1] = out[uddata][tal] * mellem;
		  else
		      {
		       out[uddata][1] = out[uddata][1] + out[uddata][tal] * mellem;
		       out[uddata][tal] = 0;
		      }
		 }
	     maxtid = 1.0;
	     mellem = out[1][13];
	     if(mellem == 1.0 || mellem == 3.0)  mellem = mellem - 1.0;
	     else
		 {
		  if(mellem == 0.0)  mellem = 0.0;
		  else  mellem = 2.0;
		 }
	     out[1][13] = mellem;
	     out[1][14] = 0.0;
	    }
	if(nuta == 2 && (eruddata == 1 || (eruddata == 2 && (mabaton == 3 || mabaton == 4))))  {
	     for(tal = 1; tal <= 12; tal++)  {
		  if(out[2][tal] == 0.0 || tal > (int) maxtid)  atfak = 0.0;
		  else
		      {
		       if(mabaton == 3)  atfak = 100.0 * (1.0 - (out[1][tal]/out[2][tal]));
		       else
			   {
			    if(X22 < 0.5)  mellem = 100.0;
			    else  mellem = 1.0;
			    atfak = mellem * out[1][tal]/out[2][tal];
			   }
		       if(mabaton == 3 || (mabaton == 4 && X22 < 0.5))  {
			    if(atfak > 999.0)  atfak = 999.0;
			    if(atfak < - 999.0)  atfak = - 999.0;
			   }
		      }
		  out[1][tal] = atfak;
		 }
	     if(mabaton == 3 || (mabaton == 4 && X22 < 0.5))  {
		  out[1][13] = 1.0;
		  out[1][14] = 1.0;
		 }
	     else
		 {
		  out[1][13] = X22;
		  out[1][14] = 0.0;
		 }
	    }
	if(((eruddata == 5 && mabaton == 3) || eruddata == 6 || eruddata == 7) && starnut <= 0)  {
	     for(tal = 1; tal <= (int) maxtid; tal++)  {
		  atfak = out[1][tal];
		  if(maxfun < atfak)  maxfun = atfak;
		  if(minfun > atfak)  minfun = atfak;
		 }
	    }
	if(((eruddata == 5 && mabaton == 3) || eruddata == 6 || eruddata == 7) && starnut >= 1)  {
	     tal1 = 0;
	     for(tal = 1; tal <= (int) maxtid; tal++)  {
		  atfak = 100.0 * out[1][tal]/maxskal;
		  if(X22 > atfak || out[10][0] < atfak)  {
		       tal1 = 1;
		       break;
		      }
		 }
	     if(tal1 != 0)  {
		  for(tal = 1; tal <= jobmax; tal++)  {
		       if(telec[tal] == nuta)  {
			    telec[tal] = 0;
			    break;
			   }
		      }
		 }
	    }
	if((eruddata == 5 && mabaton == 6 && nuta >= 2) || (nuta == 2 && ((eruddata == 2 && (mabaton == 5 || mabaton == 6)) || (eruddata >= 3 && eruddata <= 4))))  {
	     for(tal = 1; tal <= 12; tal++)  {
		  atfak = out[1][tal];
		  if(eruddata == 2 && mabaton == 6)  atfak = atfak - out[2][tal];
		  if(eruddata >= 3 && eruddata <= 4)  atfak = atfak * out[2][tal];
		  if((eruddata == 2 && mabaton == 5) || (eruddata == 5 && mabaton == 6))  atfak = atfak + out[uddata][tal];
		  out[1][tal] = atfak;
		 }
	     if(eruddata != 3 && eruddata != 4)  {
		  out[1][13] = sas[13];
		  out[1][14] = sas[14];
		 }
	     else
		 {
		  if(eruddata == 3)  out[1][13] = 0.0;
		  else  out[1][13] = 1.0;
		  out[1][14] = 0.0;
		 }
	    }

	out[1][0] = maxtid;

}

int maxnume(void)
{
int tal, tal1, tal2;
double mellem;
static char Bsim_tid = 1, sim_tid = 1, Gfas1time = 0, Gnextime = 0;
static float Gdas[24];

	tal2 = 0;
	for(tal = 1; tal <= 60; tal++)  {
	     for(tal1 = 0; tal1 <= 14; tal1++)  {
		  if(DELTA_peger == 1 && tal <= 49)  Bout[tal][tal1] = cout[tal][tal1];
		  mellem = cout[tal][tal1]/1000000000.0;
		  if(mellem < -9999.0 || mellem > 99999.0)  {
		       tal2 = 1;
		       break;
		      }
		 }
	     if(tal2 != 0)  {
		  fejlmeld(98);
		  break;
		 }
	    }
	if(DELTA_peger == 1)  {
	     Bsim_tid = (char) nextime;
	     sim_tid = 1;
	     variper = 1;
	    }
	else
	    {
	     sim_tid = (char) nextime;
	     tal1 = 0;
	     if(fas1time != Gfas1time || nextime != Gnextime)  tal1 = 1;
	     for(tal = 1; tal <= 24; tal++)  {
		  if((float) das[tal] != Gdas[tal - 1])  tal1 = 1;
		 }
	     if(tal1 != 0)  variper = 1;
	    }
	if(sim_tid > Bsim_tid)  sam_tid = Bsim_tid;
	else  sam_tid = sim_tid;

	Gfas1time = (char) fas1time;
	Gnextime = (char) nextime;
	for(tal = 1; tal <= 24; tal++)  Gdas[tal - 1] = (float) das[tal];

return(tal2);
}

int nummain(void)
{

int tal, tal1, tal2, tid, parm, sensit, refcalctime, Rcalctime;
double tiva, OLprik, mellem;
double Xp2, Xp2C, Xp14, Xp15;
double X22, X23, X24;

	Rcalctime = calctime;

	sensit = 0;
	mellem = 100.0 * bas[27];
	X22 = cas[22]/mellem;
	X23 = cas[23]/mellem;
	X24 = cas[24]/mellem;

	if(calcover != 0)  {
	     cout[21][0] = (float) calctime;
	     refcalctime = 1;
	     for(sensit = 0; sensit <= 2; sensit++)  {
		  for(parm = 2; parm <= 21; parm++)  {
		       if(sensit == 0 && parm >= 3)  continue;
		       for(tal = 1; tal <= 21; tal++)  {
			    if(tal == parm)  das[tal] = (double) (10.0 * sensit);
			    else  das[tal] = 0.0;
			   }
		       numwor();

		       Xp2 = X2;
		       Xp14 = X14;
		       Xp15 = X15;
		       goto punstca;
	       punfose:;
		      }
		 }
	     cas[21] = bas[21];
	     das[21] = 0.0;
	    }
	if(calcover != 0)  goto punkt1;
	if(starbud == 0)  calcno = calcno + 1;
	tal1 = calctime + nutime;
	if(12 - tal1 >= 0)  goto peri;
	calctime = 12 - nutime;
	tal1 = 12;
   peri:nextime = (char) tal1;

	Xp2 = X2;
	Xp14 = X14;
	Xp15 = X15;
	if(FASE_peger == 1)  {
	     calctime = Rcalctime;
	     nutime = calctime;
	     nextime = calctime;
	     fas1time = calctime;
	     DELTA_peger = 1;
	     for(tal = 1; tal <= 24; tal++)  {
		  if(das[tal] != 0.0)  DELTA_peger = 2;
		 }
	     numwor();
	    }
	refcalctime = calctime;
punstca:if(FASE_peger == 2)  {
	     tiva = (double) fas1time;
	     Xp2 = X2 * (1.0 + tiva * (cas[25]/mellem));
	     Xp14 = X14 * (1.0 + tiva * (cas[26]/mellem));
	     Xp15 = X15 * (1.0 + tiva * (cas[27]/mellem));
	     tal2 = fas1time + 1;
	    }
	else  tal2 = 1;
	for(tal = 1; tal <= 46; tal++)  {
	     if(DELTA_peger == 2 && tal == 21)  continue;
	     for(tal1 = tal2; tal1 <= 12; tal1++)  cout[tal][tal1] = 0.0;
	    }
	if(FASE_peger == 1)  {
// BAL P
	     cout[33][0] = (float) ((1.0 - X20) * cout[23][0]);
	     if(X20 == 1.0)  goto calcpu13;
	     cout[32][0] = (float) (X20 * cout[33][0]/(1.0 - X20));
	     goto calcpu14;
    calcpu13:cout[32][0] = 0.0;
    calcpu14:cout[35][0] = (float) ((1.0 - X20) * cout[24][0]);
	     if(X20 == 1.0)  goto calcpu15;
	     cout[34][0] = (float) (X20 * cout[35][0]/(1.0 - X20));
	     goto calcpu16;
    calcpu15:cout[34][0] = 0.0;
    calcpu16:cout[36][0] = (float) X18;
	     cout[38][0] = 0.0;
	     cout[41][0] = 0.0;
	     cout[42][0] = (float) bas[0];
	     cout[44][0] = (float) Xp15;
	     cout[43][0] = 0.0;
	     cout[45][0] = (float) X1;
	     cout[46][0] = cout[40][0] + cout[41][0] + cout[42][0] + cout[43][0] + cout[44][0] + cout[45][0];
	     cout[39][0] = cout[46][0];
	     cout[37][0] = cout[39][0] - cout[31][0] - cout[32][0] - cout[33][0] - cout[34][0] - cout[35][0] - cout[36][0] - cout[38][0];

	     cout[13][1] = (float) X18;
	    }

	for(tal2 = 1; tal2 <= refcalctime; tal2++)  {
// P + L
	     tid = tal2;
	     if(FASE_peger == 2)  tid = tal2 + fas1time;

	     tiva = (double) tal2;

	     Xp2C = Xp2 * (1.0 + X22 * tiva);
	     cout[1][tid] = (float) (X3 * Xp2C);
	     cout[2][tid] = (float) (X6 * Xp2C * X12);
	     cout[3][tid] = (float) (X7 * Xp2C * X13);
	     cout[4][tid] = cout[1][tid] - cout[2][tid] - cout[3][tid];
	     cout[5][tid] = (float) (Xp14 * (1.0 + X23 * tiva));
	     cout[6][tid] = cout[4][tid] - cout[5][tid];
	     if(tid >= 2)  {
		  if(X24 >= 0.0)  OLprik = 1.0;
		  else  OLprik = 0.0;
		  cout[13][tid] = cout[13][tid - 1] + (float) (OLprik * X24 * Xp15);
		 }
	     cout[7][tid] =  (float) (X19 * cout[13][tid]);
	     cout[13][tid] = (float) ((1.0 - X19) * cout[13][tid]);
	     cout[8][tid] = cout[6][tid] - cout[7][tid];
	     cout[16][tid] = (float) (Xp2C * (X11 * (X13 * X7 + X12 * X6) + X7 * X13 * X10) + X3 * (1.0 - X5) * X4 * Xp2 * (1.0 + X22 * (tiva - 0.5 * X4)) - X7 * X13 * (1.0 - X9) * X8 * Xp2 * (1.0 + X22 * (X11 + X10 + tiva - 0.5 * X8)));

	     if(tid == 1)  OLprik = 0.0;
	     else  OLprik = 1.0;
	     cout[9][tid] = (float) (X17 * (cout[16][tid] - bas[0]) + X16 * (bas[0] - OLprik * (cout[11][tid - 1] + cout[12][tid - 1]) + Xp15 * (1.0 + tiva * X24)));

	     cout[10][tid] = cout[8][tid] - cout[9][tid];

// OC
	     if(cout[1][tid] == 0.0)  goto calcpu1;
	     cout[27][tid] = 100.0 * cout[4][tid]/cout[1][tid];
	     goto calcpu2;
    calcpu1: cout[27][tid] = 0.0;
    calcpu2: cout[23][tid] = (float) (X7 * X13 * X10 * Xp2C);
	     cout[24][tid] = (float) ((X13 * X7 + X12 * X6) * X11 * Xp2C);
	     cout[14][tid] = (float) (cout[10][tid] - X20 * (cout[23][tid] - cout[23][tid - 1] + cout[24][tid] - cout[24][tid - 1]));
	     cout[15][tid] = (float) (Xp2 * (X3 * (1.0 + X22 * (tiva - X4 * ( 1.0 - X5))) - X6 * X12 * (1.0 + X22 * (tiva + X11)) - X7 * X13 * (1.0 + X22 * (X11 + X10 + tiva - X8 * (1.0 - X9)))) - cout[5][tid]);
	     cout[17][tid] = cout[13][tid];
	     OLprik = cout[6][tid] * (1.0 - X21) + Xp2 * X21 * X20 * X22 * (X7 * X13 * X10 + (X13 * X7 + X12 * X6) * X11);
	     if(OLprik == 0.0)  goto calcpu3;
	     cout[18][tid] = (float) (100.0 * (X21 - 1.0) * cout[9][tid]/ OLprik);
	     cout[19][tid] = (float) (100.0 * X21 * X19 * cout[17][tid]/OLprik);
	     goto calcpu4;
    calcpu3: cout[18][tid] = 0.0;
	     cout[19][tid] = 0.0;
    calcpu4: cout[20][tid] = (float) (OLprik * (1.0 + ((cout[18][tid] + cout[19][tid])/100.0)));

	     if(tid == 1)  OLprik = 0.0;
	     else  OLprik = 1.0;
	     if(cout[20][tid] >= 0.0)  {
		  tal = 11;
		  tal1 = 12;
		 }
	     else
		 {
		  tal = 12;
		  tal1 = 11;
		 }
	     cout[tal][tid] = (float) (OLprik * cout[tal][tid - 1] + cout[20][tid]);
	     cout[tal1][tid] = (float) (OLprik * cout[tal1][tid - 1]);

	     if(cout[20][tid] < 0.0)  cout[20][tid] = 0.0;

	     if(DELTA_peger == 1)  {
		  cout[21][tid] =  cout[20][tid];
		  cout[21][0] = (float) tid;
		 }
	     if(tid <= (int) cout[21][0])  cout[22][tid] =  cout[20][tid] - cout[21][tid];

// W+K
	     cout[31][tid] = (float) (X3 * (1.0 - X5) * Xp2 * X4 * (1.0 + X22 * (tiva - 0.5 * X4)));
	     cout[40][tid] = (float) (X7 * X13 * (1.0 - X9) * Xp2 * X8 * (1.0 + X22 * (X11 + X10 + tiva - 0.5 * X8)));
	     if(cout[1][tid] == 0.0)  goto calcpu5;
	     goto calcpu6;
    calcpu5: cout[27][tid] = 0.0;
    calcpu6: if(cout[27][tid] == 0.0)  goto calcpu7;
	     cout[25][tid] = (float) (100.0 * Xp14 * (1.0 + X23 * tiva)/cout[27][tid]);
	     goto calcpu8;
    calcpu7: cout[25][tid] = 0.0;
    calcpu8: if(cout[1][tid] == 0.0) goto calcpu9;
	     cout[26][tid] = 100.0 * (1.0 - cout[25][tid]/cout[1][tid]);
	     cout[28][tid] = 100.0 * cout[6][tid]/cout[1][tid];
	     goto calcpu10;
    calcpu9: cout[26][tid] = 0.0;
	     cout[28][tid] = 0.0;

// BAL U
    calcpu10:cout[33][tid] = (float) ((1.0 - X20) * X7 * X13 * X10 * Xp2C);
	     if(X20 == 1.0)  goto calcpu17;
	     cout[32][tid] = (float) (X20 * cout[33][tid]/(1.0 - X20));
	     goto calcpu18;
    calcpu17:cout[32][tid] = 0.0;
    calcpu18:cout[35][tid] = (float) ((1.0 - X20) * (X13 * X7 + X12 * X6) * X11 * Xp2C);
	     if(X20 == 1.0)  goto calcpu19;
	     cout[34][tid] = (float) (X20 * cout[35][tid]/(1.0 - X20));
	     goto calcpu20;
    calcpu19:cout[34][tid] = 0.0;
    calcpu20:cout[36][tid] = cout[13][tid];
	     cout[37][tid] = cout[37][0];
	     cout[38][tid] = cout[11][tid];
	     cout[39][tid] = cout[31][tid] + cout[32][tid] + cout[33][tid] + cout[34][tid] + cout[35][tid] + cout[36][tid] + cout[37][tid] + cout[38][tid];

	     cout[41][tid] = cout[16][tid] - (float) bas[0];
	     cout[42][tid] = (float) bas[0];
	     cout[44][tid] = (float) X15;

	     if(X24 >= 0.0)  OLprik = 1.0;
	     else  OLprik = 0.0;
	     cout[43][tid] = (float) (OLprik * tiva * X24 * Xp15 - cout[12][tid]);

	     cout[46][tid] = cout[39][tid];
	     cout[45][tid] = cout[46][tid] - cout[40][tid] - cout[41][tid] - cout[42][tid] - cout[43][tid] - cout[44][tid];

	     if(cout[39][tid] == 0.0)  goto calcpu11;
	     cout[29][tid] = 100.0 * cout[1][tid]/cout[39][tid];
	     cout[30][tid] = 100.0 * cout[6][tid]/cout[39][tid];
	     continue;
    calcpu11:cout[29][tid] = 0.0;
	     cout[30][tid] = 0.0;
	    }

	tal2 = 0;
pungent:tal2 = tal2 + 1;
	if(tal2 == 2 || (calcover == 0 && FASE_peger == 1 && DELTA_peger == 1) || (calcover != 0 && sensit == 0))  {
	     for(tal = 1; tal <= 40; tal++)  {
		  if(tal <= 10)  tal1 = tal;
		  if(tal > 10 && tal <= 13)  tal1 = tal + 3;
		  if(tal > 13 && tal <= 16)  tal1 = tal + 4;
		  if(tal > 16 && tal <= 24)  tal1 = tal + 6;
		  if(tal > 24 && tal <= 33)  tal1 = 64 - tal;
		  if(tal > 33)  tal1 = 80 - tal;
		  OLprik = cout[tal1][1];
		  if(tal2 != 2)  senac1[tal][0] = (float) OLprik;
		  else
		      {
		       senac2[tal][0] = (float) OLprik;
		       if(calcover != 0 && sensit != 0)  {
			    if(senac1[tal][0] != 0.0)  {
				 OLprik = (double) ((senac2[tal][0] - senac1[tal][0]) * 100.0/senac1[tal][0]);
				 if(OLprik > - 0.005 && OLprik < 0.005)  OLprik = 0.0;
				}
			    else  OLprik = 0.0;
			    if(OLprik >= 0)  {
				 if((int) (10.0 * OLprik) - 10.0 * (int) OLprik >= 5)  OLprik = 1.0 + OLprik;
				}
			    else
				{
				 if(- (int) (10.0 * OLprik) + 10.0 * (int) OLprik >= 5)  OLprik = - 1.0 + OLprik;
				}
			    if(sensit == 1)  senac1[tal][parm] = (float) OLprik;
			    else  senac2[tal][parm] = (float) OLprik;
			   }
		      }
		 }
	    }
	if(tal2 != 2 && ((calcover == 0 && FASE_peger == 1) || calcover != 0))  goto pungent;
	if(calcover != 0)  goto punfose;

punkt1: calcover = 0;
	tal2 = maxnume();

return(tal2);
}

void sysbank(char parm)
{
FILE *fmem1;

char postlas[90], strmellem[80];
int tal, tal1;
double mellem;

	if(parm == 1)  goto syskriv;

	for(tal = 0; tal <= 9999; tal++)  {
	     basenum[tal] = 0;
	     telec[tal] = 0;
	     if(tal <= 43)  sencomp[tal] = 0;
	     if(tal <= 34)  {
		  bas[tal] = 0.0;
		  cas[tal] = 0.0;
		 }
	     if(tal <= 24)  das[tal] = 0.0;
	     if(tal <= 15)  {
		  valorden[tal] = 0;
		  for(tal1 = 0; tal1 <= 3; tal1++)  valuta[tal1][tal] = 0.0;
		 }

	    }

	faktor = X1 = X2 = X3 = X4 = X5 = X6 = X7 = X8 = X9 = X10 = X11 = 0.0;
	X12 = X13 = X14 = X15 = X16 = X17 = X18 = X19 = X20 = X21 = 0.0;

	textlib(13);
	for(tal = 1; tal <= 8; tal++)  strcpy(paratex[tal], paratex[tal + 8]);

	valtistr(-1);

	for(tal1 = 2; tal1 <= 3; tal1++)  {
	     if(tal1 == 2)  fmem1 = fopen("MASICUAL", "rt");
	     else  fmem1 = fopen("MASIBUAL", "rt");
	     for(tal = 1; tal <= 15; tal++)  {
		  strmellem[0] = '\0';
		  fgets(postlas, 40, fmem1);
		  strncat(strmellem, postlas, strlen(postlas) - 1);
		  valuta[tal1][tal] = atof(strmellem);
		 }
	     fclose(fmem1);
	    }

	fmem1 = fopen("MASISYST", "rt");
	for(tal = 0; tal <= 69; tal++)  {
	     strmellem[0] = '\0';
	     fgets(postlas, 90, fmem1);
	     strncat(strmellem, postlas, strlen(postlas) - 1);
	     if(tal == 0)  strcpy(password, strmellem);
	     if(tal >= 1 && tal <= 68)  {
		  mellem = atof(strmellem);
		  if(tal <= 6)  sydata[tal] = (char) mellem;
		  if(tal == 7)  rappage = (int) mellem;
		  if(tal >= 8 && tal <= 47)  sencomp[tal - 7] = (int) mellem;
		  if(tal >= 48 && tal <= 62)  valorden[tal - 47] = (char) mellem;
		  if(tal >= 63 && tal <= 67)  conbas[tal - 63] = mellem;
//		  if(tal == 68)  dummy = (char) mellem;
		 }
	     if(tal == 69)  strcpy(jobnamew, strmellem);
	    }
	fclose(fmem1);
 
	strcpy(unitoftime, timedef[sydata[1]]);
	strcpy(atfactor, isofac[sydata[2]]);
	strcpy(isonoj, isoval[sydata[3]]);
	strcpy(Uisonoj, isonoj);
	strcpy(printtype, printset[sydata[4]]);

	strcpy(findstring, jobnamew);

	tal = - 1;
	jobmax = 0;
	antalibase = 0;
	fmem1 = fopen("MASINUBA", "rt");
punvid1:strmellem[0] = '\0';
	if(fgets(postlas, 40, fmem1) == NULL)  goto laeslut;
	tal = tal + 1;
	strncat(strmellem, postlas, strlen(postlas) - 1);
	tal1 = atoi(strmellem);
	if(tal == 0)  protected = tal1;
	if(tal >= 1)  {
	     basenum[tal] = tal1;
	     if(tal1 >= 1)  jobmax = jobmax + 1;
	     if(abs(tal1) > antalibase)  antalibase = abs(tal1);
	    }
	fgets(postlas, 40, fmem1);
	goto punvid1;
laeslut:fclose(fmem1);
	basenum[0] = tal;

	valtistr(0);
	compfile(0);
	taeljob();

return;

syskriv:for(tal1 = 2; tal1 <= 3; tal1++)  {
	     if(tal1 == 2)  fmem1 = fopen("MASICUAL", "wt");
	     else  fmem1 = fopen("MASIBUAL", "wt");
	     for(tal = 1; tal <= 15; tal++)  {
		  sprintf(strmellem, "%f", valuta[tal1][tal]);
		  fprintf(fmem1, "%s\n", strmellem);
		 }
	     fclose(fmem1);
	    }

	unit_num();
	sydata[1] = (char) bas[27];
	sydata[2] = (char) bas[28];
        
	for(tal = 1; tal <= 15; tal++)  {
	     if(strcmp(isoval[tal], isonoj) == 0)  break;
	    }
	sydata[3] = (char) tal;

	for(tal = 0; tal <= 1; tal++)  {
	     if(strcmp(printset[tal], printtype) == 0)  break;
	    }
	sydata[4] = (char) tal;

	fmem1 = fopen("MASISYST", "wt");
	for(tal = 0; tal <= 69; tal++)  {
	     if(tal == 0)  strcpy(strmellem, password);
	     if(tal >= 1 && tal <= 68)  {
		  if(tal <= 6)  mellem = (double) sydata[tal];
		  if(tal == 7)  mellem = (double) rappage;
		  if(tal >= 8 && tal <= 47)  mellem = (double) sencomp[tal - 7];
		  if(tal >= 48 && tal <= 62)  mellem = (double) valorden[tal - 47];
		  if(tal >= 63 && tal <= 67)  mellem = conbas[tal - 63];
		  if(tal == 68)  mellem = 0.0;
		  sprintf(strmellem, "%f", mellem);
		 }
	     if(tal == 69)  strcpy(strmellem, jobnamew);
	     fprintf(fmem1, "%s\n", strmellem);
	    }
	fclose(fmem1);

}
