/*
	compound.c

	08/11/95
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cscape.h"
#include "scancode.h"

#undef abs;

extern char transname[];
extern char transdata[];
extern char jobnamew[];
extern char compmelding[];
extern char pvarfelt[];
extern char Uunitoftime[];
extern char Uisonoj[];
extern char meldcomp[];
extern char filbasis[];

char meldBank[] = "from Bank";
char meldLager[] = "from Store";

char coskalfak[5];
char overattri[20];
char trans[10] = {0,0,0,0,0,0,0,0,0,0};
char comaxtime[12];

extern char savecomp;
extern char styresens;
extern char compalut;
extern char eruddata;
extern char datatrantype;
extern char grafisk;
extern char DELTA_peger;
extern char AUX_peger;
extern char STYR_peger;
extern char min_posT;
extern char min_posS;
extern char min_pos;

char PCT_peger = 0;
char rulle = 0;
char Xcomstatu = 0;
char Ycomstatu = 0;
char compeger = 0;
char Btypecomp = 0;
char udibank = 0;
char savecomp = 1;

char skalfak[5];

extern char *timedef[];
extern char *isofac[];
extern char *isoval[];
extern char *counitoftime[];
extern char *coisonoj[];
extern char *coparatex[];
extern char *paratex[];
extern char *dimvis[];

extern double out[11][15];

double cofaktor;

extern float cout[61][15];
extern float coout[12][16];

float Bout[50][15];

extern int styrk[3][3];

extern int nextime;
extern int nummer;
extern int jobtal;
extern int jobmax;
extern int mabaton;

extern sed_type sed;
extern sed_type bsed[];

aux_func(aux_comp);
spc_func(speciout);

void compfile(char parm)
{
FILE *fmem1;
FILE *fmem2;

char postlas[50], strmellem[40];
int tal, tal1, nuta;
double mellem;

	if(parm != 1)  {
	     fmem1 = fopen("MASICOMP", "rt");

             if(parm == - 1)  fmem2 = fopen("MAMELLEM", "wt");

	     for(nuta = 1; nuta <= 10; nuta++)  {

		  fgets(postlas, 50, fmem1);
                  strmellem[0] = '\0';
	          strncat(strmellem, postlas, strlen(postlas) - 1);
	          if(parm == 0)   strcpy(coparatex[nuta], strmellem);
                  else  fprintf(fmem2, "%s\n", strmellem);

		  for(tal = 0; tal <= 17; tal++)  {
		       fgets(postlas, 40, fmem1);
		       strmellem[0] = '\0';
		       strncat(strmellem, postlas, strlen(postlas) - 1);
		       mellem = atof(strmellem);
		       if(mellem > - 0.000001 && mellem < 0.000001)  mellem = 0.0;
		       if(tal <= 15)  {
			    if(tal == 0)  {
				 if((int) mellem < 0.0)  {
				      if(parm == 0)  trans[nuta - 1] = 1;
				      mellem = - mellem;
				     }
				 else  trans[nuta - 1] = 0;
				}
			    if(parm == 0)  coout[nuta][tal] =  (float) mellem;
		            else  sprintf(strmellem, "%f", mellem);
			   }
		       else
			   {
                            if(parm == 0)  {
			         if(coout[nuta][0] == 0.0)  {
				      if(tal == 16)  counitoftime[nuta][0] = '\0';
				      if(tal == 17)  coisonoj[nuta][0] = '\0';
				     }
			         else
				     {
				      if(tal == 16)  strcpy(counitoftime[nuta], timedef[(int) mellem]);
				      else  strcpy(coisonoj[nuta], isoval[(int) mellem]);
				     }
                                }
                           }
		       if(parm == - 1)  fprintf(fmem2, "%s\n", strmellem);
		      }
		 }

	     fgets(postlas, 40, fmem1);
	     strmellem[0] = '\0';
	     strncat(strmellem, postlas, strlen(postlas) - 1);
             if(parm == 0)  {
                  strcpy(coskalfak, isofac[atoi(strmellem)]);
	          cofaktor = 1.0;
	          for(tal = 1; tal <= 4; tal++)  {
		       if(strcmp(coskalfak, isofac[tal]) == 0)  break;
		       cofaktor = 1000.0 * cofaktor;
       		      }
                 }
             else  
                 { 
                  fprintf(fmem2, "%s\n", strmellem);
                  fclose(fmem2);
                 } 
	     fclose(fmem1);

             if(parm == - 1)  {
	          strcpy(transdata, "MAMELLEM");
	          strcpy(transname, "MASICOMP");
	          fileremo();
	          filerena();
	          filehide();
                 }
	    }
	else
	    {
	     fmem1 = fopen("MASICOMP", "wt");

	     for(nuta = 1; nuta <= 10; nuta++)  {

		  fprintf(fmem1, "%s\n", coparatex[nuta]);

		  for(tal = 0; tal <= 17; tal++)  {
		       if(tal <= 15)  {
			    mellem = coout[nuta][tal];
			    if(tal == 0 && trans[nuta - 1] >= 1)  mellem = - mellem;
			   }
		       else
			   {
			    if(coout[nuta][0] == 0.0)  {
				 if(tal == 16)  tal1 = 0;
				 if(tal == 17)  tal1 = 0;
				}
			    else
				{
				 if(tal == 16)  {
				      for(tal1 = 0; tal1 <= 5; tal1++)  {
					   if(strcmp(timedef[tal1], counitoftime[nuta]) == 0)  break;
					  }
				     }
				 else
				     {
				      for(tal1 = 0; tal1 <= 15; tal1++)  {
					   if(strcmp(isoval[tal1], coisonoj[nuta]) == 0)  break;
					  }
				     }
				}
			    mellem = (double) tal1;
			   }
		       sprintf(strmellem, "%f", mellem);
		       fprintf(fmem1, "%s\n", strmellem);
		      }
		 }

	     for(tal = 1; tal <= 4; tal++)  {
		  if(strcmp(isofac[tal], coskalfak) == 0)  break;
		 }
	     mellem = (double) tal;
	     sprintf(strmellem, "%f", mellem);
	     fprintf(fmem1, "%s\n", strmellem);

	     fclose(fmem1);
	    }

}

void absbalan(char type, char parm)
{
int tal, tal1;
double mellem;

	for(tal = 1; tal <= 10; tal++)  {
	     out[tal][0] = (double) nextime;
	     for(tal1 = 1; tal1 <= 14; tal1++)  {
		  if(tal <= type && tal1 <= 12)  {
		       if(PCT_peger != 2)  {
			    mellem = cout[tal + parm][tal1];
			    if(PCT_peger == - 1)  mellem = mellem - Bout[tal + parm][tal1];
			   }
		       else
			   {
			    if(Bout[tal + parm][tal1] != 0.0)  mellem = 100.0 * ((cout[tal + parm][tal1]/Bout[tal + parm][tal1]) - 1.0);
			    else  mellem = 0.0;
			    if(mellem < - 999.0)  mellem = - 999.0;
			    if(mellem > 999.0)  mellem = 999.0;
			   }
		      }
		  else  mellem = 0.0;
		  out[tal][tal1] = mellem;
		 }
	    }
	numskal(0);
	if(PCT_peger == 1)  {
	     for(tal = 1; tal <= type; tal++)  {
		  for(tal1 = 1; tal1 <= 12; tal1 ++)  {
		       if(out[type][tal1] != 0.0)  mellem = 100.0 * out[tal][tal1]/out[type][tal1];
		       else  mellem = 0.0;
		       out[tal][tal1] = mellem;
		      }
		 }
	    }
	if(PCT_peger >= 1)  strcpy(skalfak, "%");

}

void absnumge(void)
{
int tal, tal1, nuta, data, type;
double mellem;

	type = styrk[0][0];
	if(type == 4 || type == 8)  {
	     if(type == 8)  data = 0;
	     else  data = nextime;
	     for(nuta = 1; nuta <= 10; nuta++)  {
		  for(tal = 1; tal <= 12; tal++)  {
		       mellem = 0.0;
		       if((nuta <= 9 && tal == 1) || (nuta <= 7 && tal == 2))  {
			    if(tal == 1)  tal1 = 30;
			    else  tal1 = 39;
			    if(PCT_peger != 2)  {
				 mellem = cout[nuta + tal1][data];
				 if(PCT_peger == - 1)  mellem = mellem - Bout[nuta + tal1][data];
				}
			    else
				{
				 if(Bout[nuta + tal1][data] != 0.0)  mellem = 100.0 * ((cout[nuta + tal1][data]/Bout[nuta + tal1][data]) - 1.0);
				 else  mellem = 0.0;
				 if(mellem < - 999.0)  mellem = - 999.0;
				 if(mellem > 999.0)  mellem = 999.0;
				 mellem = ((double) ((int) (10.0 * mellem)))/10.0;
				}
			   }
		       out[nuta][tal] = mellem;
		      }
		 }
	     tal = 0;
	    }
	else
	    {
	     for(nuta = 1; nuta <= 10; nuta++)  {
		  if(type != 6 || (type == 6 && nuta == 3))  data = nextime;
		  else  data = (int) cout[21][0];
		  if(type == 6 && nuta == 2 && nextime < (int) cout[21][0])  data = nextime;
		  out[nuta][0] = data;
		  tal = 0;
		  tal1 = 0;
		  if(type == 1)  {
		       if(nuta <= 5  || nuta == 10)  tal = 1;
		       if(nuta == 3 || nuta == 8  || nuta == 9)  tal1 = 1;
		      }
		  if(type == 2 || (type == 3 && (nuta == 5 || nuta == 7)) || type == 6)  tal = 1;
		  if(type == 3 && nuta >= 6)  tal1 = 1;
		  out[nuta][13] = (double) tal;
		  out[nuta][14] = (double) tal1;
		  for(tal = 1; tal <= 12; tal++)  {
		       if(type == 1)  {
			    if(nuta == 1)  tal1 = 1;
			    if(nuta == 2)  tal1 = 6;
			    if(nuta == 3)  tal1 = 27;
			    if(nuta >= 4)  tal1 = nuta + 10;
			   }
		       if(type == 2)  tal1 = nuta;
		       if(type == 3)  {
			    if(nuta == 1)  tal1 = 31;
			    if(nuta == 2)  tal1 = 40;
			    if(nuta >= 3)  tal1 = nuta + 20;
			   }
		       if(type == 6 && nuta >= 4)  mellem = 0.0;
		       else
			   {
			    if(type == 6)  {
				 if(nuta <= 2)  tal1 = nuta + 20;
				 else tal1 = 20;
				}
			    if(PCT_peger != 2)  {
				 mellem = cout[tal1][tal];
				 if(PCT_peger == - 1)  mellem = mellem - Bout[tal1][tal];
				}
			    else
				{
				 if(Bout[tal1][tal] != 0.0)  mellem = 100.0 * ((cout[tal1][tal]/Bout[tal1][tal]) - 1.0);
				 else  mellem = 0.0;
				 if(mellem < - 999.0)  mellem = - 999.0;
				 if(mellem > 999.0)  mellem = 999.0;
				 mellem = ((double) ((int) (10.0 * mellem)))/10.0;
				}
			   }
		       out[nuta][tal] = mellem;
		      }
		 }
	     if(type == 1)  tal = 2;
	     if(type == 2)  tal = 0;
	     if(type == 3)  tal = 3;
	     if(type == 6)  tal = 0;
	    }

	numskal(tal);
	if(PCT_peger == 2)  strcpy(skalfak, "%");

}

void pctnum(void)
{
int tal, tal1, tal2, tal3, antal, type;
double mellem;

	type = styrk[0][0];
	if(type == 4 || type == 8)  {
	     for(tal1 = 1; tal1 <= 2; tal1++)  {
		  if(tal1 == 1)  tal2 = 9;
		  else  tal2 = 7;
		  for(tal = 1; tal <= tal2; tal++)  {
		       if(out[tal2][tal1] != 0.0)  mellem = 100.0 * out[tal][tal1]/out[tal2][tal1];
		       else  mellem = 0.0;
		       out[tal][tal1] = ((double) ((int) (10.0 * mellem)))/10.0;;
		      }
		 }
	    }
	else
	    {
	     if(type == 1 || type == 2)  antal = 10;
	     if(type == 3)  antal = 5;
	     if(type == 6)  antal = 3;
	     for(tal = 1; tal <= antal; tal++)  {
		  if(type == 1)  {
		       if(tal == 3 || (tal >= 8 && tal <= 9))  continue;
		       if(tal == 6 || tal == 7)  tal3 = 39;
		       else  tal3 = 1;
		      }
		  if(type == 2)  tal3 = 1;
		  if(type == 3)  {
		       if(tal != 5)  tal3 = 39;
		       else  tal3 = 1;
		      }
		  if(type == 6)  tal3 = 21;
		  for(tal1 = 1; tal1 <= 12; tal1 ++)  {
		       if((type == 1 || type == 6) && tal == 1)  mellem = 100.0;
		       else
			   {
			    if(type == 1)  {
				 if(tal == 2)  tal2 = 6;
				 else  tal2 = 10 + tal;
				}
			    if(type == 2)  tal2 = tal;
			    if(type == 3)  {
				 if(tal == 1)  tal2 = 31;
				 if(tal == 2)  tal2 = 40;
				 if(tal >= 3)  tal2 = 20 + tal;
				}
			    if(type == 6)  {
				 if(tal == 2)  tal2 = 22;
				 else  tal2 = 20;
				}
			   if(cout[tal3][tal1] != 0.0)  mellem = 100.0 * cout[tal2][tal1]/cout[tal3][tal1];
			   else  mellem = 0.0;
			  }
		       out[tal][tal1] = ((double) ((int) (10.0 * mellem)))/10.0;
		      }
		 }
	    }

	strcpy(skalfak, "%");

}

void pararefe(char parm)
{
FILE *fmem1;

char postlas[90], typeA;
int tal, tal1;

	tal1 = mabaton;

	if(parm == 1)  {
	     if(tal1 >= 1  && tal1 <= 8)  strcpy(paratex[tal1], paratex[tal1 + 8]);
	     else
		 {
		  fmem1 = fopen("MASIRETE", "rt");
		  for(tal = 1; tal <= tal1; tal++)  fgets(postlas, 90, fmem1);
		  paratex[tal1][0] = '\0';
		  strncat(paratex[tal1], postlas, strlen(postlas) - 1);
		  fclose(fmem1);
		 }
	    }
	else
	    {
	     if(!(styrk[0][0] == 8 ||  tal1 <= 29 || tal1 == 38 || tal1 == 40))  {
		  tal = 0;
		  if(tal1 >= 65 && tal1 <= 73)  {
		       typeA = 9;
		       parm = 30;
		       tal = 1;
		      }
		  if(tal1 >= 74 && tal1 <= 80)  {
		       typeA = 7;
		       parm = 39;
		       tal = 1;
		      }
		  styrk[0][1] = tal1;
		  if(tal != 0)  absbalan(typeA, parm);

		  if(AUX_peger != 2)  {
		       min_posT = min_posS;
		       comptran(0);
		      }
		  else
		      {
		       min_pos = min_posS;
		       combank(2);
		      }
		  if(styrk[0][0] == 4)  {
		       absnumge();
		       if(PCT_peger == 1) pctnum();
		      }
		 }
	    }
}

int trans_res(char parm, int felt, int type)
{
static char trans_1[3][40], trans_6[12], trans_4[64];
int tal, tal1;

	if(parm >= 1)  goto markdel;

	for(tal1 = 0; tal1 <= 63; tal1++)  {
	     if(tal1 <= 11)  trans_6[tal1] = 0;
	     if(tal1 <= 39)  {
		  for(tal = 0; tal <= 2; tal++)  trans_1[tal][tal1] = 0;
		 }
	     trans_4[tal1] = 0;
	    }

return(0);

markdel:if(grafisk == 1)  goto punkt2;
	if(type != 4)  {
	     if(type == 6)  tal1 = 8;
	     else
		 {
		  if(type == 1)  {
		       if(felt == 14 || felt == 16)  return(0);
		       tal1 = 17;
		      }
		  else  tal1 = 15;
		 }
	     if(felt > tal1)  {
		  Mtone();
		  return(0);
		 }
	     if(type == 1 && felt > 13)  {
		  if(felt == 15)  felt = 14;
		  else  felt = 15;
		 }
	    }
	else  felt = felt - 17;
punkt2:	if(type <= 3)  tal1 = 10;
	else
	    {
	     if(type == 6)  tal1 = 3;
	     else  tal1 = 16;
	    }
	tal = (PCT_peger + 1) * tal1 + (felt - 6);
	if(parm >= 2)  goto testdel;
	if(type <= 3)  trans_1[type - 1][tal] = 1;
	else
	    {
	     if(type == 6)  trans_6[tal] = 1;
	     else  trans_4[tal] = 1;
	    }

return(0);

testdel:if(type <= 3 && trans_1[type - 1][tal] == 1)  {
	     if(parm != 3)  tal = 0x72;
	     else  trans_1[type - 1][tal] = 0;
	    }
	else
	    {
	     if(type == 6 && trans_6[tal] == 1)  {
		  if(parm != 3)  tal = 0x72;
		  else  trans_6[tal] = 0;
		 }
	     else
		 {
		  if(type == 4 && trans_4[tal] == 1)  {
		       if(parm != 3)  tal = 0x72;
		       else  trans_4[tal] = 0;
		      }
		  else
		      {
		       if(parm != 3)  tal = 0x38;
		      }
		 }
	    }
	if(parm == 3)  tal = 0;

return(tal);
}

void opdafelter(int aktiv, int felt)
{
int tal, tal1, tal2, nuta;

	tal2 = styrk[0][0];
	if(aktiv == 8)  aktiv = 4;
	styrk[0][0] = aktiv;

	if(felt == 1)  felt = sed_GetFieldNo(sed);

	if(aktiv == 7)  {
	     tal = 16;
	     tal1 = 25;
	    }
	else
	    {
	     if(aktiv == 4)  {
		  tal = 23;
		  tal1 = 38;
		 }
	     else
		 {
		  tal = 6;
		  if(aktiv == 1)  tal1 = 17;
		  else
		      {
		       if(aktiv == 6)  tal1 = 8;
		       else  tal1 = 15;
		      }
		 }
	    }
	for(nuta = tal; nuta <= tal1; nuta++)  {
	     if(nuta == felt)  continue;
	     linmark(- nuta);
	    }

	styrk[0][0] = tal2;
}

void rulle_pct(void)
{
	rulle = rulle + 1;
	if((rulle == 2 && DELTA_peger == 1) || rulle == 4)  rulle = 0;
	if(rulle == 0)  PCT_peger = 0;
	else
	    {
	     if(rulle == 1)  PCT_peger = 1;
	     else
		 {
		  if(rulle == 2)  PCT_peger = 2;
		  else  PCT_peger = - 1;
		 }
	    }
}

void saveblank(void)
{
char strmellem[80];
int tal;

	strcpy(strmellem, jobnamew);
	nummer = jobmax;
	overbank(0);
	if(strncmp(transname, "                                                                                ", strlen(transname)) != 0)  {
	     tal = styrk[0][0];
	     styrk[0][0] = 7;
	     styrk[1][1] = 0;
	     AUX_peger = 0;
	     jobnamew[0] = '\0';
	     combank(1);
	     styrk[0][0] = tal;
	    }
	strcpy(jobnamew, strmellem);

}

void prolosda(void)
{
	sed_type        Varsed;
	int 		ret, tal, tal1, nuta;
	int             type, overcol, colorbasis;
	char            overskri[80], overbasis[80], balance;
	char            STYR_VAR, oldtime[5], typeA, parm;
	byte            regular, select;
	static char     palut[8] = {0,0,0,40,0,0,0,40};

	compmelding[0] = '\0';

	type = styrk[0][0];
	if(type != 4 && type != 8)  balance = 0;
	else  balance = 1;
	STYR_VAR = 0;
	pvarfelt[3] = - 1;

   colorbasis = 0x71;
   if(grafisk == 1)  grafisk = - 1;

   if(balance == 0)  ramcompo(overbasis, type);
   else  rambalance(oldtime, overbasis, type);

	absnumge();
	if(PCT_peger != 0)  {
	     if(PCT_peger == 1)  pctnum();
	     sed_MarkField(sed, 2, 0x8e, 0x70);
	    }
	if(grafisk != 0 && PCT_peger >= 1)  sed_MoveField(sed, 3, 1, 80);

punktpg:AUX_peger = 0;
	tal = 0;
	if(styresens == 0)  tal = palut[type - 1];
	else
	    {
	     if(grafisk == 0)  {
		  tal = meldpeg();
		  palut[type - 1] = (char) tal;
		  styresens = 0;
		 }
	    }

punkt11:if((tal >= 1 && grafisk == 0) || (type == 4 && grafisk == - 1)) {
	     if(mabaton == - 5 && tal == ret)  Mtone();
	     if(grafisk == - 1)  tal = palut[4];
	     sed_GotoField(sed, tal);
	    }
	else
	    {
	     if(mabaton == - 6)  ret = sed_GetFieldNo(bsed[0]);
	     sed_GotoLastField(sed);
	     sed_RightField(sed);
	     if((type != 6 && ret == 132) || (type == 6 && ret == 48))  Mtone();
	     else  sed_GotoFirstField(bsed[0]);
	    }
	grafisk = 0;

punkt10:strcpy(overskri, overbasis);
	if(PCT_peger != 0)  {
	     if(PCT_peger == 1)  strcpy(overattri, "* %-rela. *  ");
	     else
		 {
		  if(PCT_peger == 2)  strcpy(overattri, "* %-change *  ");
		  else  if(PCT_peger == - 1)  strcpy(overattri, "* Change *  ");
		 }
	     strcat(overskri, overattri);
	     overcol = 0x7f;
	    }
	else  overcol = colorbasis;

	sed_SetBorderColor(sed, overcol);
	sed_SetBorderTitle(sed, overskri);

	feltstring();

	sed_Repaint(sed);
punkt3: mabaton = 0;
	sed_Go(sed);

	if(mabaton == 500)  goto punkt3;

	if(mabaton > - 15)  Varsed = sed;
	else  Varsed = bsed[0];
	ret = sed_GetFieldNo(Varsed);

	if(mabaton == - 4)  goto opfelt;
	if(mabaton == - 5)  goto punkt8;
	if(mabaton == - 6)  goto punktpg;

	sed_GetFieldColors(Varsed, ret, &regular, &select);
	sed_MarkField(Varsed, ret, select, select);
	sed_UpdateField(Varsed, ret);

	if(mabaton == - 1 || mabaton == - 140)  goto punmen;

	if(abs(mabaton) == 135)  rulle_pct();
punktex:if(STYR_peger <= - 3 || abs(mabaton) >= 135)  goto punkt2;

	mabaton = sed_GetBaton(sed);

	if(mabaton == 40)  goto punkt40;
	if(mabaton == 44)  goto punkt44;
	if(mabaton == 49 || mabaton == 133)  goto punktG;
	if(balance == 1)  goto punmen;
	goto punkt8;

opfelt: sed_GotoField(sed, 6);
	goto punkt3;

punkt8: if(ret <= 38)  linmark(- ret);
	if(mabaton == - 5)  goto punktpg;
	if(styresens <= - 1)  goto punkt1;
	grafisk = 1;
	goto punkt11;

punmen: if(type == 8)  tal = 0;
	else
	    {
	     if((type == 4 && ret > 38) || (type != 4 && mabaton != - 1))  tal = testtimes(2, ret, type);
	     else
		 {
		  if(type == 1 && (ret == 14 || ret == 16))  {
		       linmark(- ret);
		       if(ret == 14)  ret = 13;
		       else  ret = 15;
		       sed_GotoField(sed, ret);
		       linmark(ret);
		       sed_MarkField(Varsed, ret, 0x1f, 0x1f);
		       sed_UpdateField(Varsed, ret);
		      }
		  if(0x72 == trans_res(2, ret, type))  tal = 0;
		  else  tal = 1;
		 }
	    }
	styrk[2][1] = tal;
	if(balance == 0)  sed_SetMouse(sed, sedmou_GreedyTrack);
	else
	    {
	     if(ret <= 38)  mabaton = - 1;
	     else  mabaton = 10;
	    }
	datamenu();
	if((DELTA_peger == 1 && mabaton == 4) || (DELTA_peger == 2 && mabaton == 6))  goto pundat;
punvide:if(balance == 0)  sed_SetMouse(sed, sedmou_Track);
	if((DELTA_peger == 1 && mabaton == 5) || (DELTA_peger == 2 && mabaton == 7))  goto punsav;
	if(((DELTA_peger == 1 && PCT_peger == 0) || (DELTA_peger == 2 && PCT_peger != 1)) && mabaton == 3)  goto punrel;
	if(DELTA_peger == 2 && ((PCT_peger <= 0 && mabaton == 4) || (PCT_peger == 1 && mabaton == 3)))  goto punaen;
	if(DELTA_peger == 2 && ((PCT_peger == 0 && mabaton == 5) || (PCT_peger >= 1 && mabaton == 4)))  goto absaen;
	if((DELTA_peger == 1 && PCT_peger == 1 && mabaton == 3) || (DELTA_peger == 2 && PCT_peger != 0 && mabaton == 5))  goto punabs;
	if(mabaton == 1)  STYR_VAR = 1;
	if(mabaton == 1 || mabaton == 2)  goto punkalk;
	sed_MarkField(Varsed, ret, regular, select);
	if(mabaton == 0)  goto punkt3;
	PCT_peger = 0;
	rulle = 0;
	mabaton = 1;
	goto punkt1;

pundat: datatran();
pundata:mabaton = 0;
	goto punvide;

punsav: sed_DoSpecial(Varsed, FN4);
	if(styrk[2][1] == - 1)  goto  pundata;
	if(Varsed == sed)  {
	     if(type == 1)  tal = 24;
	     else
		 {
		  if(type == 2 || type == 3)  {
		       if(type == 2)  tal = 36;
		       else  tal = 46;
		      }
		  else
		      {
		       if(type == 4)  tal = 42;
		       else   tal = 56;
		      }
		 }
	     if(!(type == 4 && ret > 38))  mabaton = ret + tal;
	    }
	goto punkt2;

punaen: PCT_peger = 2;
	rulle = 2;
	goto punudf;

punrel: PCT_peger = 1;
	rulle = 1;
	goto punudf;

absaen: PCT_peger = - 1;
	rulle = 3;
	goto punudf;

punabs: PCT_peger = 0;
	rulle = 0;

punudf:	mabaton = - 135;
	goto punktex;

punkalk:mabaton = 148;
punkt2: if(balance == 0)  sed_SetMouse(sed, sedmou_GreedyTrack);
	tal = mabaton;
	nuta = 1;
	if(STYR_peger <= - 3)  {
	     if(STYR_peger == - 3)  {
		  if(abs(mabaton) == 15)  {
		       mabaton = styrk[0][2];
		       nuta = styrk[2][0];
		      }
		  if(type != 6 && type != 1)  tal1 = 28;
		  else
		      {
		       if(type == 1)  tal1 = 30;
		       else  tal1 = 14;
		      }
		  if(balance == 1)  tal1 = 44;
		  sed_MarkField(sed, tal1, 0xce, 0x70);
		  sed_UpdateField(sed, tal1);
		  if(nuta != 1 && styrk[2][1] == 0)  saveblank();
		  AUX_peger = 2;
		 }
	     if(nuta != 1)  {
		  while (mabaton <= nuta)  {
		       pararefe(0);
		       mabaton = mabaton + 1;
		      }
		 }
	     else  pararefe(0);
	     if(STYR_peger == - 3)  {
		  if(nuta != 1)  {
		       saveblank();
		       testtimes(1, ret, type);
		       opdafelter(type, 1);
		      }
		  sed_MarkField(sed, tal1, 0x3b, 0x70);
		  sed_UpdateField(sed, tal1);
		 }
	     STYR_peger = 0;
	    }
	else
	    {
	     if(abs(tal) == 148)  {
		  if(STYR_VAR == 0)  kalkverd(-1);
		  else
		      {
		       styresens = - 3;
		       uddaalle();
		       STYR_VAR = 0;
		      }
		 }
	     else
		 {
		  nuta = sed_GetFieldRow(sed, 3);
		  if(PCT_peger != 0)  {
		       tal1 = 0x8f;
		       if(PCT_peger >= 1 && nuta != 80)  sed_MoveField(sed, 3, 1, 80);
		       if(PCT_peger == - 1 && nuta != 64)  nuta = - 1;
		      }
		  else
		      {
		       tal1 = 0x0e;
		       if(nuta != 64)  nuta = - 1;
		      }
		  if(nuta == - 1)  {
		       if(type != 4 && type != 8)  nuta = 1;
		       else  nuta = 2;
		       sed_MoveField(sed, 3, nuta, 64);
		      }
		  sed_MarkField(sed, 2, tal1, 0x70);
		 }
	     opdafelter(type, 1);
	     absnumge();
	     if(PCT_peger == 1)  pctnum();
	    }
	sed_MarkField(Varsed, ret, regular, select);
	if(balance == 0)  sed_SetMouse(sed, sedmou_Track);
	if(Varsed == sed && ret <= 38)  AUX_peger = 1;
	if(styresens <= - 1)  goto punkt8;
	if(abs(tal) >= 135)  goto punkt10;
	goto punkt3;

punkt40:styrk[0][0] = 4;
	typeA = 9;
	parm = 30;
	goto punkt1B;

punkt44:styrk[0][0] = 5;
	typeA = 7;
	parm = 39;
punkt1B:absbalan(typeA, parm);

punktG: grafisk = 1;
punkt1: sed_Close(sed);
	ramnulstr(0);
	if(grafisk == 0)  {
	     if(((type <= 3 || type == 6) && ret < 20) || type == 4 || type == 8)  {
		  palut[type - 1] = (char) ret;
		  if(type == 1 && (ret == 14 || ret == 16))  palut[type - 1] = (char) ret - 1;
		 }
	     else  palut[type - 1] = 0;
	    }
	else
	    {
	     if(type == 4)  palut[4] = (char) ret;
	    }

}

boolean spc_stat(sed_type sed, int scancode)
{

     if(!(styrk[0][0] == 7 && (scancode == CTRL_UP || scancode == CTRL_DOWN)))  {
	  if(TRUE == styrebil(sed, scancode, Ycomstatu, Xcomstatu))  return(TRUE);
	 }

     if(scancode == MOU_NOFIELD || scancode == MOU_THERE)  {
	  sed_ToggleExit(sed);
	  return(TRUE);
	 }

return(FALSE);
}

void comstatu(char parm, int raekke)
{
	menu_type	menu;
	sed_type	sed;
	int             ret, tal, tal1, tal2, color[2];
	char            strmellem[10], strmellemA[10];
	char            rakn[11] = {0,0,2,3,5,6,7,9,10,12,13};
	char            pos[8] = {20,5,34,14,27,1,17,21};

	if(parm != 0)  {
	     pos[0] = 21;
	     pos[1] = 1;
	     pos[2] = 40;
	     pos[3] = 10;
	     pos[4] = 28;
	     pos[5] = 2;
	     pos[6] = 18;
	     pos[7] = 22;
	    }

	menu = menu_Open();

   tal = - 1;
   for(ret = 1; ret <= 10; ret++)  {
	if(parm == 0)  tal = rakn[ret];
	else
	    {
	     tal = tal + 1;
	     tal1 = tal + 1;
	     if(tal1 == 10)  tal1 = 0;
	     menu_Printf(menu, "@p[%d,0]@a[0x71]%d@a[0x00]", tal, tal1);
	    }
	tal1 = comaxtime[ret];
	if(tal1 == 0)  counitoftime[ret][0] = '\0';
	menu_Printf(menu, "@p[%d,%d]@fp[@[15,#]]", tal, pos[5],
	  counitoftime[ret], &string_funcs);
	if(tal1 != 0)  {
	     strmellem[0] = '\0';
	     sprintf(strmellemA, "%d", tal1);
	     if(tal1 < 10)  strcat(strmellem, " ");
	     strcat(strmellem, strmellemA);
	    }
	else  strcpy(strmellem, "  ");
	menu_Printf(menu, "@p[%d,%d]@fp[%s ]", tal, pos[6],
	  NULL, &gmenu_funcs, strmellem);

	if(tal1 != 0)  {
	     tal2 = (int) coout[ret][13];
	     if(tal2 == 2 || tal2 == 3)  strcpy(strmellem, dimvis[2]);
	     else  strcpy(strmellem, coisonoj[ret]);
	     if((int) coout[ret][14] == 0)  {
		  if(tal2 == 1 || tal2 == 3)  strcat(strmellem, "/t");
		  if(tal2 == 4)  strcat(strmellem, "/p");
		 }
	    }
	else  strcpy(strmellem, "     ");
	menu_Printf(menu, "@p[%d,%d]@fp[%s]", tal, pos[7],
	  NULL, &gmenu_funcs, strmellem);
       }

	menu_Printf(menu, "@p[9,%d]@fd[ ]", pos[0],
	  NULL, &gmenu_funcs, "Press RETURN  or [Esc]");

	menu_Flush(menu);

	sed = sed_Open(menu);

   tal = 0;
   for(ret = 1; ret <= 10; ret++)  {
	if(ret == raekke)  {
	     color[0] = 0x1f;
	     color[1] = 0x1f;
	    }
	else
	    {
	     if((int) coout[ret][0] != 0)  {
		  color[0] = 0x4f;
		  color[1] = 0x31;
		 }
	     else
		 {
		  color[0] = 0x30;
		  color[1] = 0x30;
		 }
	    }
	for(tal2 = 1; tal2 <= 3; tal2++)  {
	     if(tal2 != 3)  tal1 = color[0];
	     else  tal1 = color[1];
	     sed_MarkField(sed, tal, tal1, 0x70);
	     tal = tal + 1;
	    }
       }

	sed_MarkField(sed, 30, 0x1f, 0x39);

        techset(sed, 3, BD_MOVE, 0x71, "  Status  units  ", 0x3f, pos[1], pos[2], pos[3], pos[4], NULL, spc_stat);
	Ycomstatu = pos[1];
	Xcomstatu = pos[2];

	sed_Repaint(sed);
	sed_Go(sed);

	sed_Close(sed);

}

void sletudda(int parm)
{
int tal;

	coparatex[parm][0] = '\0';
	coisonoj[parm][0] = '\0';
	counitoftime[parm][0] = '\0';
	for(tal = 0; tal <= 15; tal++)  coout[parm][tal] = 0.0;
	for(parm = 1; parm <= 10; parm++)  {
	     if((int) coout[parm][14] != 0)  continue;
	     for(tal = 1; tal <= 12; tal++)  coout[parm][tal] = (float) (cofaktor * coout[parm][tal]);
	    }
	numskal(1);
}

void compound(void)
{
	sed_type        Varsed;
	char            saver = 0;
	int 	        ret = 0, tal, tal1, tal2, nuta, gemme;
	static char     palut = 0;
	double          mellem;
	byte            regular, select;

	gemme = jobtal;
	styrk[0][0] = 7;

	if(grafisk == 0)  {
	     if(udibank == 0)  strcpy(meldcomp, meldLager);
	     else  strcpy(meldcomp, meldBank);
	    }
	else  grafisk = - 1;
	ramcompo(NULL, 7);

punktpg:if(palut != 0 && grafisk == 0)  {
	     tal = palut;
	     if(mabaton == - 5 && tal == ret)  Mtone();
	     sed_GotoField(sed, tal);
	    }
	else
	    {
	     sed_GotoLastField(sed);
	     sed_RightField(sed);
	     if(mabaton == - 6 && 132 == sed_GetFieldNo(bsed[0]))  Mtone();
	     else  sed_GotoFirstField(bsed[0]);
	    }
	grafisk = 0;

punkt10:malcomp(0);
	if(savecomp == 1 && comaxtime[0] == 0)  savecomp = - 1;
punkt3: mabaton = 0;
	sed_Go(sed);

	if(mabaton == 500)  goto punkt10;

	if(compalut >= 1)  Varsed = sed;
	else  Varsed = bsed[0];
	ret = sed_GetFieldNo(Varsed);

	if(mabaton == 100)  goto punmen;
	if(mabaton == - 4 || mabaton == - 432)  goto opfelt;
	if(mabaton == - 5)  goto punkt8;
	if(mabaton == - 6)  goto punktpg;
	if(mabaton == - 15)  goto tilbank;
	if(mabaton >= - 25 && mabaton <= - 16)  goto punsav;

	if(Btypecomp == - 2)  goto puncopy;
	if(Btypecomp == - 3)  goto annmark;
	if(mabaton >= 57 && mabaton <= 66)  goto sleteet;

	if(mabaton != 100)  mabaton = sed_GetBaton(sed);
	else  ret = 132;

	if(mabaton == 133)  goto punktG;

	if(mabaton == 0 && (ret >= 16 && ret <= 25))  goto punkt8;
	if(mabaton >= 17 && mabaton <= 26)  goto punmark;
punmen: if(Btypecomp == - 1)  Mtone();
	sed_GetFieldColors(Varsed, ret, &regular, &select);
	sed_MarkField(Varsed, ret, select, select);
	sed_UpdateField(Varsed, ret);
	sed_SetMouse(sed, sedmou_GreedyTrack);
	if(Varsed == sed)  mabaton = - 1;
	if(udibank == 1 || (Varsed == sed && trans[ret - 16] != 0))  styrk[2][1] = 0;
	else  styrk[2][1] = 1;
	datamenu();
	if(mabaton == 4)  goto pundat;
	if(mabaton == 5)  goto saveud;
punvide:sed_MarkField(Varsed, ret, regular, select);
	sed_SetMouse(sed, sedmou_Track);
	if(mabaton == 0)  goto punkt3;
	if(mabaton == 6)  goto punkt1;
        if(mabaton <= 2)  {
             udibank = 0;
	     strcpy(meldcomp, meldLager);
	     if(mabaton == 1)  compfile(1);
	     else  compfile(0);
	     savecomp = 1;
            }     
	if(mabaton == 1)  goto punkt10;
        tal2 = 1;
	if(mabaton == 2)  goto opdater;
	tal2 = 0;
	compeger = 0;
	goto sletalt;

opfelt:	if(mabaton == - 4)  tal = 16;
        else  tal = 25;
        sed_GotoField(sed, tal);
	goto punkt3;

pundat: datatrantype = 8;
	if(!(Btypecomp == - 1 && ret == compalut) && ret <= 25)  compeger =  - (char) ret;
	datatran();
	datatrantype = 4;
pundata:mabaton = 0;
	goto punvide;

saveud: sed_DoSpecial(Varsed, FN4);
	sed_MarkField(Varsed, ret, regular, select);
	if(styrk[2][1] == - 1)  goto pundata;
	if(Varsed == sed)  mabaton = - ret;
	if(Varsed == sed)  goto punsav;
	goto tilbank;

punkt8: linmark(- ret);
	if(mabaton == - 5)  goto punktpg;
	grafisk = 1;
	goto punktpg;

puncopy:tal2 = 1;
	tal1 = compeger;
	tal = mabaton - 16;
	goto operati;

punmark:if(Btypecomp == - 1 && compeger == mabaton - 16)  goto annmark;
	if(Btypecomp == - 1)  goto starfly;
	tal2 = 2;
	tal = 11;
	tal1 = mabaton - 16;
	compeger = (char) tal1;
	Btypecomp = - 1;
	goto operati;

starfly:tal2 = 0;
	tal = compeger;
	tal1 = mabaton - 16;
	goto operati;

slutfly:tal2 = 1;
	tal = mabaton - 16;
	tal1 = 11;
operati:strcpy(counitoftime[tal], counitoftime[tal1]);
	strcpy(coisonoj[tal], coisonoj[tal1]);
	strcpy(coparatex[tal], coparatex[tal1]);
	for(ret = 0; ret <= 15; ret++)  coout[tal][ret] = coout[tal1][ret];

	if(tal2 == 0)  goto slutfly;
	if(tal2 == 2)  goto punkt10;

	tal1 = compeger;
	ret = trans[tal1 - 1];
	nuta = trans[tal - 1];
	if(Btypecomp == - 1)  {
	     if(ret != 0 && nuta == 0)  trans[tal - 1] = 1;
	     if(ret == 0 && nuta != 0)  trans[tal - 1] = 0;
	     if(nuta != 0 && ret == 0)  trans[tal1 - 1] = 1;
	     if(nuta == 0 && ret != 0)  trans[tal1 - 1] = 0;
	    }
	else
	    {
	     if(ret != 0)  trans[tal - 1] = 1;
	     else  trans[tal - 1] = 0;
	    }
	sletsave();

annmark:compeger = 0;
	tal2 = 1;
	goto opdater;

sleteet:tal = mabaton - 56;
	tal2 = 1;
sletalt:if(tal2 == 0)  tal = 0;
punmel: if(tal2 == 0)  tal = tal + 1;
	sletudda(tal);
	if(tal2 == 0 && tal < 10)  goto punmel;
	sletsave();
	compenhe();
	if(comaxtime[0] == 0)  savecomp = - 2;

opdater:for(ret = 16; ret <= 25; ret++)  {
             if((ret == mabaton - 41) || tal2 == 0)  trans[ret - 16] = 0;
	     linmark(- ret);
	    }
	Btypecomp = 0;
	goto punkt10;

tilbank:mabaton = - 15;
	saver = 1;
	strcpy(meldcomp, meldBank);
	strcpy(filbasis, "MASIBASE");

punsav: tal1 = - mabaton - 15;
	tal2 = - mabaton;
	sed_MarkField(sed, 28, 0xce, 0x70);
	sed_UpdateField(sed, 28);
	if(saver != 0)  goto punsava;
punsavb:strcpy(paratex[0], coparatex[tal1]);
	strcpy(Uunitoftime, counitoftime[tal1]);
	strcpy(Uisonoj, coisonoj[tal1]);
	out[1][0] = (double) comaxtime[tal1];
	min_pos = (char) coout[tal1][15];
	for(tal = 1; tal <= 14; tal++)  {
	     if(tal > 12 || (int) coout[tal1][14] != 0)  mellem = 1.0;
	     else  mellem = cofaktor;
	     out[1][tal] = mellem * coout[tal1][tal];
	    }
	AUX_peger = - 2;
	eruddata = 10;
punsava:if(saver == 0)  {
	     sed_GetFieldColors(sed, tal2, &regular, &select);
	     sed_MarkField(sed, tal2, select, select);
	     sed_UpdateField(sed, tal2);
	    }
	if(saver != 1)  combank(2);
        if(mabaton == - 55)  goto stopend;
	if(saver == 1)  saver = 2;
        if(saver == 0)  {
	     trans[tal1 - 1] = 1;
	     sed_MarkField(sed, tal2, 0x72, 0xce);
             if(savecomp == 1)  compfile(1);
            }
	else
            {
	     if(tal1 >= 1)  {
		  trans[tal1 - 1] = 0;
		  sed_MarkField(sed, tal2, 0x38, 0xce);
		 }
	     for(tal = tal1 + 1; tal <= 10; tal++)  {
		  if(comaxtime[tal] != 0)  {
		       tal1 = tal;
		       break;
		      }
		 }
	     if(tal > 10)  {
		  saveblank();
		  STYR_peger = 0;
		  saver = - 1;
		  udibank = 1;
		 }
	     else  tal2 = tal1 + 15;
	    }
	if(saver == 2)  goto punsavb;
stopend:sed_MarkField(sed, 28, 0x3b, 0x70);
        saver = 0;
        AUX_peger = 0;
	goto punkt10;

punktG: grafisk = 1;
punkt1: sed_Close(sed);
	ramnulstr(0);
	jobtal = gemme;
	if(grafisk == 0)  {
	     if(savecomp == - 2)  udibank = 0;
	     palut = compalut;
	     Btypecomp = 0;
	     compeger = 0;
	    }
}