/*
	grafout.c

	08/11/95
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <graphics.h>
#include "cscape.h"
#include "scancode.h"

extern char licensee[];
extern char jobnamew[];
extern char unitoftime[];
extern char isonoj[];
extern char stridate[];
extern char skalfak[];
extern char coskalfak[];
extern char overattri[];
extern char comaxtime[];
extern char meldcomp[];
extern char meldLager[];
extern char trans[];
extern char deltaA[];
extern char deltaP[];

extern char grafisk;
extern char compalut;
extern char Btypecomp;
extern char compeger;
extern char savecomp;
extern char datatrantype;
extern char PCT_peger;
extern char udibank;
extern char er_alleE;
extern char min_posE;

char grafrap = 0;
char xaxistime = 0;
char kurvenr;
char antkurv;

extern char *promtstr[];
extern char *paratex[];
extern char *coparatex[];
extern char *counitoftime[];
extern char *timedef[];
extern char *coisonoj[];
extern char *dimvis[];
extern char *tid_skalaE[];
extern char *tid_skalaS[];

extern double out[11][15];

extern float cout[61][15];
extern float coout[12][16];

float Gout[11][15];

extern int styrk[3][3];

extern int nextime;
extern int rapside;
extern int calcno;
extern int mabaton;

extern sed_type sed;

void compenhe(void)
{
char procen, test, prokurve, data13, data14;
int tal, tal1, type;
double mellem;

	type = styrk[0][0];
	test = 0;
	if(type == 7)  {
	     comaxtime[0] = 0;
	     for(tal = 1; tal <= 10; tal++)  {
		  tal1 = (int) coout[tal][0];
		  comaxtime[tal] = (char) tal1;
		  if(tal1 > comaxtime[0])  comaxtime[0] = (char) tal1;
		  if(tal1 == 0 || test == 3) continue;
		  if(test == 0)  {
		       strcpy(counitoftime[0], counitoftime[tal]);
		       test = 1;
		       continue;
		      }
		  if(strcmp(counitoftime[0], counitoftime[tal]) != 0)  {
		       strcpy(counitoftime[0], timedef[5]);
		       test = 3;
		      }
		 }
	    }

	test = 0;
	procen = 0;
	for(tal = 1; tal <= 10; tal++)  {
	     if(type == 7)  {
		  if(comaxtime[tal] == 0)  continue;
		  data13 = (char) coout[tal][13];
		  data14 = (char) coout[tal][14];
		 }
	     else
		 {
		  if((char) Gout[tal][0] == 0)  continue;
		  data13 = (char) Gout[tal][13];
		  data14 = (char) Gout[tal][14];
		 }
	     if((type != 7 && PCT_peger >= 1) || data14 >= 1)  prokurve = 1;
	     else  prokurve = 0;

	     for(tal1 = 1; tal1 <= 12; tal1++)  {
		  if(type == 7)  mellem = coout[tal][tal1];
		  else  mellem = Gout[tal][tal1];
		  if(mellem != 0.0 && prokurve == 1)  procen = 2;
		 }
	     if(procen != 2 && prokurve == 1)  procen = 1;
	     if(prokurve == 1 || test == 3)  continue;

	     if(test != 1)  {
		  if(data13 <= 1 || data13 == 4)  {
		       if(type == 7)  strcpy(coisonoj[0], coisonoj[tal]);
		       else  strcpy(coisonoj[0], isonoj);
		       test = 1;
		      }
		  else
		      {
		       strcpy(coisonoj[0], dimvis[2]);
		       test = 2;
		      }
		 }
	     else
		 {
		  if(type == 7 && (data13 <= 1 || data13 == 4) && strcmp(coisonoj[0], coisonoj[tal]) != 0)  {
		       strcpy(coisonoj[0], "MIX");
		       test = 3;
		      }
		 }
	    }

	styrk[0][2] = 0;
	if(test == 0)  {
	     if(procen != 0)  {
		  styrk[0][2] = 1;
		  if(type == 7)  {
		       coisonoj[0][0] = '\0';
		       strcpy(coskalfak, "%");
		      }
		 }
	     else
		 {
		  if(type == 7)  {
		       coisonoj[0][0] = '\0';
		       counitoftime[0][0] = '\0';
		      }
		 }
	    }

}

void graffort(char suffix, char mixuni, char pctmode)
{
char overskri[80], graskalfak[3], graisonoj[5], strmellem[60], talmod;
int tal, tal1, tal2, tal3, type;

	type = styrk[0][0];

	if(type != 5)  deltaA[0] = 11;
	else  deltaP[0] = 11;
	tal1 = (int) Gout[kurvenr][13];

	if(type == 7)  {
	     if(savecomp == - 1 || (savecomp == 1 && udibank == 0))  talmod = 1;
	     else
		 {
		  if(udibank == 1)  talmod = 2;
		  else  talmod = 5;
		 }
	     strcpy(overskri, "                  E I S  ");
	     strcat(overskri, meldcomp);
	     strcpy(graskalfak, coskalfak);
	     if(kurvenr == 0)  strcpy(graisonoj, coisonoj[0]);
	     else
		 {
		  if(tal1 == 2 || tal1 == 3)  strcpy(graisonoj, dimvis[2]);
		  else  strcpy(graisonoj, coisonoj[kurvenr]);
		 }
	    }
	else
	    {
             talmod = 1;
             for(tal = 1; tal <= antkurv; tal++)  {
                  if((int) Gout[tal][0] == 0)  talmod = 5;
                 }
	     if(type <= 3)  {
		  if(type == 1)  strcpy(overskri, "O u t p u t   c o m p r e s s e d");
		  else
		      {
		       if(type == 2)  strcpy(overskri, "P r o f i t   &   L o s s   c a l c.");
		       else  strcpy(overskri, "W o r k i n g  c a p.  &   K e y  n u m.");
		      }
		 }
	     else
		 {
		  if(type == 4)  strcpy(overskri, "U L T I M O    A s s e t s");
		  else
		      {
		       if(type == 5)  strcpy(overskri, "U L T I M O    L i a b i l i t i e s");
		       else  strcpy(overskri, "C a s h   f l o w");
		      }
		 }
	     if(PCT_peger != 0)  {
		  strcat(overskri, "  ");
		  strcat(overskri, overattri);
		 }
	     strcenter(overskri, 54);
	     strcpy(graskalfak, skalfak);
	     strcpy(graisonoj, isonoj);
	    }

	setcolor(LIGHTBLUE);
	outtextxy(20, 15, "Calc. no. ");
	itoa(calcno, strmellem, 10);
	outtextxy(95, 15, strmellem);
	outtextxy(540, 15, stridate);

	settextstyle(0, 1, 1);
	setcolor(DARKGRAY);
	outtextxy(620, 55, "Page ");
	itoa(rapside, strmellem, 10);
	outtextxy(620, 45, strmellem);

	strmellem[0] = '\0';
	if(strlen(jobnamew) > 58)  strncat(strmellem, jobnamew, 58);
	else  strcat(strmellem, jobnamew);
	outtextxy(635, 5, strmellem);
	settextstyle(0, 0, 1);
	outtextxy(15, 2, licensee);

// Overskrift
	setcolor(talmod);
	outtextxy(110, 20, overskri);

// y-akse

	setcolor(LIGHTBLUE);
	if(xaxistime == 0)  return;
	outtextxy(81, 30, "%");
	setcolor(BLUE);
	if(kurvenr == 0)  {
	     if(suffix > - 1)  tal = 5;
	     else  tal = 10;
	     if(pctmode == 1)  tal3 = 35;
	     else  tal3 = tal;
	     if(pctmode != 0 || (pctmode == 0 && strcmp(graskalfak, " ") != 0))  {
		  for(tal2 = 29; tal2 <= 37; tal2++)  line(tal3 - 1, tal2, tal3 + 7, tal2);
		 }
	     if(pctmode == 1)  goto putan1;
	     if(PCT_peger != - 1)  tal2 = YELLOW;
	     else  tal2 = WHITE;
	     setcolor(tal2);
	     outtextxy(tal, 30, graskalfak);
	     if(mixuni == 0)  tal2 = WHITE;
     putan1: if(pctmode == 1 || mixuni == 1)  tal2 = YELLOW;
	     setcolor(tal2);
	     if(pctmode == 1)  outtextxy(35, 30, "%");
	     else
		 {
		  if(suffix == 1)  strcat(graisonoj, "/t");
		  if(suffix == 2)  strcat(graisonoj, "/p");
		  if(suffix > - 1)  tal = tal + 9;
		  else tal = 19;
		  outtextxy(tal, 30, graisonoj);
		 }
	    }
	else
	    {
	     if(tal1 == 0 || tal1 == 2)  tal = 10;
	     else  tal = 5;
	     if((type == 7 && (int) Gout[kurvenr][14] >= 1) || (type != 7 && PCT_peger >= 1) || (type == 1 && (kurvenr == 3 || kurvenr == 8 || kurvenr == 9)) || (type == 3 && kurvenr >= 6))  {
		  tal3 = 35;
		  talmod = 0;
		 }
	     else
		 {
		  tal3 = tal;
		  talmod = 1;
		 }
	     if(talmod == 0 || (talmod != 0 && strcmp(graskalfak, " ") != 0))  {
		  for(tal2 = 29; tal2 <= 37; tal2++)  line(tal3 - 1, tal2, tal3 + 7, tal2);
		 }
	     if(talmod == 0)  {
		  setcolor(WHITE);
		  outtextxy(35, 30, "%");
		 }
	     else
		 {
		  setcolor(YELLOW);
		  outtextxy(tal, 30, graskalfak);
		  setcolor(WHITE);
		  if(tal1 == 1 || tal1 == 3)  strcat(graisonoj, "/t");
		  if(tal1 == 4)  strcat(graisonoj, "/p");
		  if(tal1 == 0 || tal1 == 2)  tal = 19;
		  else tal = tal + 9;
		  outtextxy(tal, 30, graisonoj);
		 }
	    }
	tal = mixuni;
}

void grafprep(char styrmode, double max, double dfak[], int ifak[])
{
char strmellem[20], strmellemA[40];
int tal, tal1, deltay;
double Yvalue, Ymellem;

	if(max > 0.0)  {
	     setcolor(LIGHTBLUE);
	     for(tal = 1; tal <= 10; tal++)  {
		  tal1 = 450 - 40 * tal;
		  line(60, tal1, 67, tal1);
		  tal1 = tal1 + 20;
		  line(60, tal1, 63, tal1);
		 }

	     if(styrmode == 1) line(60, 450, 60 + 7, 450);

	     for(tal = ifak[0]; tal <= 10; tal++)  {
		  if(styrmode == 1 && tal == 5)  continue;
		  itoa(ifak[1] * tal * 10 - ifak[2], strmellem, 10);
		  outtextxy(73, 447 - 40 * tal, strmellem);
		 }
	    }

	setcolor(WHITE);
	line(60, 450, 60, 30);
	line(54, 40, 60, 30);
	line(66, 40, 60, 30);

	if(max > 0.0)  {
	     for(tal = 1; tal <= 10; tal++)  {
		  tal1 = 450 - 40 * tal;
		  line(53, tal1, 60, tal1);
		  tal1 = tal1 + 20;
		  line(57, tal1, 60, tal1);
		 }
	     line(60 - 7, 450, 60, 450);
	    }

	deltay = 0;
	Ymellem = dfak[0] * max/50.0;
	for(tal = 0; tal <= 50; tal++)  {
	     strmellem[0] = '\0';
	     if((styrmode != 0 && tal == 25) || (styrmode == 0 && tal == 0))  strcat(strmellem, "     0");
	     else
		 {
		  if(max > 0.0)  {
		       Yvalue = Ymellem * ((double) tal) - dfak[1];
		       if((Yvalue <= - 1000.0 && Yvalue > - 10000.0) || (Yvalue >= 1000.0 && Yvalue < 10000.0))  Yvalue = ((int) (Yvalue/10.0)) * 10.0;
		       if(Yvalue <= - 10000.0 || Yvalue >= 10000.0)  Yvalue = ((int) (Yvalue/100.0)) * 100.0;
		       sprintf(strmellemA, "%f", Yvalue);
		       if(Yvalue < 10.0)  tal1 = 3;
		       else
			   {
			    if(Yvalue < 100.0)  tal1 = 4;
			    else
				{
				 if(Yvalue < 1000.0)  tal1 = 3;
				 else
				     {
				      if(Yvalue < 10000.0)  tal1 = 4;
				      else  tal1 = 5;
				     }
				}
			   }
		       if(styrmode != 0 && tal < 25)  {
			    if(Yvalue > - 10.0)  tal1 = 4;
			    else
				{
				 if(Yvalue > - 100.0)  tal1 = 5;
				 else
				     {
				      if(Yvalue > - 1000.0)  tal1 = 4;
				      else
					  {
					   if(Yvalue > - 10000.0)  tal1 = 5;
					   else  tal1 = 6;
					  }
				     }
				}
			   }
		       if(6 < strlen(strmellemA))  strncat(strmellem, strmellemA, tal1);
		       else strcat(strmellem, strmellemA);
		       if(tal != deltay && tal < 25 && styrmode != 0)  {
			    strcpy(strmellemA, strmellem);
			    strrev(strmellemA);
			    strmellem[0] = '\0';
			    strncat(strmellem, strmellemA, strlen(strmellemA) - 1);
			    strrev(strmellem);
			   }
		       tal1 = strlen(strmellem);
		       if(tal1 < 6)  {
			    strrev(strmellem);
			    strncat(strmellem, "       ", 6 - tal1);
			    strrev(strmellem);
			   }
		      }
		 }
	     tal1 = 447 - 8 * tal;
	     if(tal == deltay)  {
		  deltay = deltay + 5;
		  setcolor(WHITE);
		  outtextxy(2, tal1, strmellem);
		  setcolor(DARKGRAY);
		 }
	     else  outtextxy(2, tal1, strmellem);
	    }

	setcolor(WHITE);

	tal1 = 450 - ifak[3];
	line(60, 450 - ifak[3], 510, tal1);
	line(500, 444 - ifak[3], 510, tal1);
	line(500, 456 - ifak[3], 510, tal1);

}

void grafxko(char styrmode, char skalx, int ifak[])
{
char gratimeunit[20], strmellem[20];
int tal, tal1, type;

	type = styrk[0][0];

	setcolor(YELLOW);

	if(styrmode == 0)  tal = 455;
	else  tal = 258;
	if(type == 7)  {
	     if(kurvenr == 0)  {
		  feltstring();
		  if(er_alleE == 1)  setcolor(WHITE);
		 }
	     else
		 {
		  strcpy(counitoftime[0], counitoftime[kurvenr]);
		  min_posE = (char) coout[kurvenr][15];
		 }
	     if(strcmp(counitoftime[0], timedef[5]) != 0 && xaxistime != 0)  detecskala(0, 3);
	     strcpy(gratimeunit, counitoftime[kurvenr]);
	    }
	else  strcpy(gratimeunit, unitoftime);
	if(xaxistime != 0)  outtextxy(520, tal, gratimeunit);

	for(tal = 1; tal <= xaxistime; tal++)  {
	     tal1 = 60 + 35 * skalx * tal;
	     setcolor(WHITE);
	     line(tal1, 450 - 6 - ifak[3], tal1, 450 + 6 - ifak[3]);
	     setcolor(YELLOW);
	     if(type == 7 && (strcmp(counitoftime[0], timedef[5]) == 0 || er_alleE == 1))  itoa(tal, strmellem, 10);
	     else
		 {
		  if(type == 7)  strcpy(strmellem, tid_skalaE[tal]);
		  else  strcpy(strmellem, tid_skalaS[tal]);
		 }
	     outtextxy(tal1 - 5, ifak[5], strmellem);
	    }

}

void strtograf(char strmellem[], int tal)
{
char textnum;
int tal1, type;

	type = styrk[0][0];

	if(type == 7)  strcpy(strmellem, coparatex[tal]);
	else
	    {
	     if(type <= 3)  {
		  if(type == 1)  textnum = 29;
		  else
		      {
		       if(type == 2)  textnum = 41;
		       else textnum = 51;
		      }
		 }
	     else
		 {
		  if(type == 4)  textnum = 64;
		  else
		      {
		       if(type == 5)  textnum = 73;
		       else  textnum = 61;
		      }
		 }
	     if(tal <= 8)  tal1 = textnum + tal;
	     if(tal == 9)  {
		  if(type != 1 && type != 4)  tal1 = 9 + textnum;
		  else
		      {
		       if(type == 1)  tal1 = 39;
		       else  tal1 = 73;
		      }
		 }
	     if(tal == 10)  {
		  if(type == 1)  tal1 = 41;
		  else  tal1 = 10 + textnum;
		 }
	     strcpy(strmellem, paratex[tal1]);
	    }

}

void grafregn(char *grafstr[], char Rkvadrant[], char Rperiode[], char sidstenr, \
	      char skalx, char styrmode, char kurve_type)
{
char strmellem[40], pctmode, mixuni, suffix;
int tal, tal1, tal2, tal3, tal4, tal5, type, data[3], ifak[6];
int farve[10] = {RED,BROWN,BLUE,LIGHTGREEN,WHITE,MAGENTA,LIGHTRED,GREEN,LIGHTMAGENTA,CYAN};
double mellem, max, minfun, maxfun, dfak[3];

	type = styrk[0][0];

	cleardevice();

	tal3 = 0;
	tal4 = 0;
	tal5 = 0;
	for(tal = 1; tal <= antkurv; tal++)  {
	     for(tal1 = 0; tal1 <= 14; tal1++)  {
		  if(type != 4 && type != 5)  tal2 = tal;
		  else
		      {
		       if(type == 4)  tal2 = 10 - tal;
		       else  tal2 = 8 - tal;
		      }
		  if(type != 7)  {
		      suffix = 0;
		      Gout[tal2][tal1] = 0.0;
		      if(type != 5)  {
			    if(deltaA[0] == 0)  {
				 suffix = 1;
				 if(tal >= 1)  deltaA[tal] = 1;
				}
			    if(deltaA[tal2] == 1)  suffix = 1;
			   }
		       else
			   {
			    if(deltaP[0] == 0)  {
				 suffix = 1;
				 if(tal >= 1)  deltaP[tal] = 1;
				}
			    if(deltaP[tal2] == 1)  suffix = 1;
			   }
		       if(suffix == 1)  Gout[tal2][tal1] = (float) out[tal][tal1];
		       if((type >= 1 && type <= 3 && (PCT_peger == - 1 || PCT_peger == 2) || (type == 6 && PCT_peger != 0)) && (int) cout[21][0] < nextime)  {
			    if(tal1 == 0)  Gout[tal2][tal1] = cout[21][0];
			    else
				{
				 if(tal1 > cout[21][0] && tal1 <= 12)  Gout[tal2][tal1] = 0.0;
				}
			   }
		      }
		  else  Gout[tal2][tal1] = coout[tal][tal1];
		 }
	     if((int) Gout[tal2][0] != 0 && (int) Gout[tal2][14] <= 0)  {
		  tal2 = (int) Gout[tal2][13];
		  if(tal2 == 0 || tal2 == 2)  tal3 = 1;
		  if(tal2 == 1 || tal2 == 3)  tal4 = 1;
		  if(tal2 == 4)  tal5 = 1;
		 }
	    }
	if((tal4 == 0 && tal5 == 0) || (tal3 == 0 && tal5 == 0) || (tal3 == 0 && tal4 == 0))  {
	     mixuni = 0;
	     if(tal4 == 0 && tal5 == 0)  suffix = - 1;
	     else
		 {
		  if(tal3 == 0 && tal5 == 0)  suffix = 1;
		  else  suffix = 2;
		 }
	    }
	else
	    {
	     mixuni = 1;
	     suffix = - 1;
	    }

	compenhe();
	pctmode = (char) styrk[0][2];

	if(kurvenr == 0)  {
	     xaxistime = 0;
	     for(tal = 1; tal <= antkurv; tal++)  {
		  if((int) Gout[tal][0] > xaxistime)  xaxistime = (int) Gout[tal][0];
		 }
	    }
	else  xaxistime = (char) Gout[kurvenr][0];

	maxfun = 0.0;
	minfun = 0.0;
	for(tal = 1; tal <= xaxistime; tal++)  {
	     for(tal1 = 1; tal1 <= antkurv; tal1++)  {
		  if(kurvenr != 0)  tal1 = kurvenr;
		  else
		      {
		       if(pctmode == 0 && (int) Gout[tal1][14] >= 1)  continue;
		      }
		  max = (double) Gout[tal1][tal];
		  if(max > maxfun)  maxfun = max;
		  if(max < minfun)  minfun = max;
		  if(kurvenr != 0)  break;
		 }
	    }

	max = maxfun;
	if(styrmode == 0)  {
	     strcpy(Rkvadrant, "1.+ 4. Qud.");
	     if(max < 0.0000001)  max = - minfun;
	     dfak[0] = 1.0;
	     dfak[1] = 0.0;
	     dfak[2] = 400.0;
	     ifak[0] = 1;
	     ifak[1] = 1;
	     ifak[2] = 0;
	     ifak[3] = 0;
	     ifak[4] = 449;
	     ifak[5] = 456;
	    }
	else
	    {
	     strcpy(Rkvadrant, "1. Quadrant");
	     if(- minfun > maxfun)  max = - minfun;
	     dfak[0] = 2.0;
	     dfak[1] = max;
	     dfak[2] = 200.0;
	     ifak[0] = 0;
	     ifak[1] = 2;
	     ifak[2] = 100;
	     ifak[3] = 200;
	     ifak[4] = 250;
	     ifak[5] = 260;
	    }
	if(max < 0.0000001)  max = 0.0;

	for(tal = 1; tal <= antkurv; tal++)  {
	     grafstr[tal][0] = '\0';
	     if((int) Gout[tal][0] == 0)  continue;
	     if(tal == 10)  tal1 = 0;
	     else  tal1 = tal;
	     itoa(tal1, grafstr[tal], 10);
	     strcat(grafstr[tal], " ");
	     strtograf(strmellem, tal);
	     strpreclip(strmellem);
	     strclip(strmellem);

	     if(skalx == 2)  {
		  strcpy(Rperiode, "12");
		  if(xaxistime <= 4) tal1 = 25;
		  else
		      {
		       if(kurvenr == 0)  tal1 = 22;
		       else  tal1 = 19;
		      }
		 }
	     else
		 {
		  strcpy(Rperiode, " 5");
		  if(xaxistime <= 9)  tal1 = 25;
		  if(xaxistime == 10)  tal1 = 20;
		  if(xaxistime >= 11)  {
		       if(kurvenr == 0)  tal1 = 14;
		       else  tal1 = 13;
		      }
		 }

	     if(strlen(strmellem) > tal1)  {
		  strncat(grafstr[tal], strmellem, tal1 - 2);
		  strcat(grafstr[tal], "..");
		 }
	     else  strcat(grafstr[tal], strmellem);
	    }

        if(type == 7)  tal2 = 19;
        else  tal2 = 18;
	for(tal = 0; tal <= tal2; tal++)  {
             if(tal <= 16)  tal1 = 0x3f;
             else
                 {
                  if(tal <= 18)  tal1 = 0x31;
                  else  tal1 = 0x3a;
                 }
	     if(tal >= 5 && tal <= 14)  linmark(- tal - 11);
	     else  sed_MarkField(sed, tal, tal1, 0x4e);
	    }

	if(xaxistime >= 6)  {
	     skalx = 1;
	     if(!sed_IsProtectedField(sed, 16))  {
		  sed_ProtectField(sed, 16);
		  sed_MoveField(sed, 16, 30, 80);
		 }
	    }
	else
	    {
	     if(sed_IsProtectedField(sed, 16))  {
		  sed_UnProtectField(sed, 16);
		  sed_MoveField(sed, 16, 30, 50);
		 }
	    }
	if(xaxistime == 0)  Rperiode[0] = '\0';

	graffort(suffix, mixuni, pctmode);
	grafprep(styrmode, max, dfak, ifak);

// out
	if(kurvenr != 0 && kurve_type != 2)  goto tegnKu;
	for(sidstenr = 1; sidstenr <= antkurv; sidstenr++)  {
	     if(kurvenr != 0)  {
		  if(sidstenr != kurvenr)  continue;
		  tal2 = 2;
		 }
	     else  tal2 = sidstenr - 1;
	     setcolor(farve[tal2]);
	     tal2 = (int) Gout[sidstenr][0];
	     if(pctmode == 0 && (int) Gout[sidstenr][14] >= 1 && kurvenr == 0)  maxfun = max/100.0;
	     else  maxfun = 1.0;
	     for(tal = 1; tal <= tal2; tal++)  {
		  tal1 = 35 * skalx * tal + 60;
		  if(max > 0.0)  minfun = maxfun * Gout[sidstenr][tal]/max;
		  else  minfun = 0.0;
		  data[0] =  (int) (dfak[2] * (1.0 - minfun) + 50.0);
		  if(tal < tal2)  {
		       data[1] = tal1 + 35 * skalx;
		       if(max > 0.0)  minfun = maxfun * Gout[sidstenr][tal + 1]/max;
		       else  minfun = 0.0;
		       data[2] = (int) (dfak[2] * (1.0 - minfun) + 50.0);
		       line(tal1, data[0], data[1], data[2]);
		      }
		  else
		      {
		       if(tal == 1)  line(tal1, data[0], tal1 + 3, data[0]);
		       else  line(data[1], data[2], data[1] + 3, data[2]);
		       tal1 = tal1 + 10;
		       data[0] = data[0] - 4;
		       outtextxy(tal1, data[0], grafstr[sidstenr]);
		      }
		 }
	    }
	if(kurvenr == 0)  sidstenr = 0;
	else  sidstenr = kurvenr;
	goto afslGra;

tegnKu: setcolor(BLUE);
	setfillstyle(3, LIGHTBLUE);
	if(skalx == 1)  {
	     tal2 = 2;
	     mellem = 0.35;
	    }
	else
	    {
	     tal2 = 5;
	     mellem = 0.21;
	    }
	for(tal = 1; tal <= xaxistime; tal++)  {
	     tal3 = 35 * skalx * tal;
	     tal1 = tal3 + (69 - skalx * 17);
	     if(max > 0.0)  minfun = Gout[kurvenr][tal]/max;
	     else  minfun = 0.0;
	     data[0] = (int) (dfak[2] * (1.0 - minfun) + 50.0);
	     data[1] = tal3 + (51 + skalx * 17);
	     if(kurve_type == 0)  {
		  tal3 = tal1;
		  tal4 = data[1];
		  data[2] = 0;
		 }
	     else
		 {
		  tal3 = tal1 + tal2;
		  tal4 = data[1] - tal2;
		  data[2] = (int) (mellem * (double) (data[1] - tal1));
		 }
	     bar3d(tal3, data[0], tal4, ifak[4], data[2], kurve_type);
	    }
	data[0] = data[0] - 4;
	data[1] = data[1] + 11;
	outtextxy(data[1], data[0], grafstr[kurvenr]);

afslGra:grafxko(styrmode, skalx, ifak);
	sed_Repaint(sed);

}

boolean spc_graf(sed_type sed, int scancode)
{
char strmellem[40];
int palo, tal, tal1, tal2, tal3, nuta, type;
static int varfelt = 0;

	palo = sed_GetFieldNo(sed);

	type = styrk[0][0];

	if(ascii(scancode) == 32)  {
	     palo = 3;
	     scancode = ENTER;
	    }
	if(ascii(scancode) == 84 || ascii(scancode) == 116)  {
	     palo = 16;
	     scancode = ENTER;
	    }

        if(scancode == MOU_CLICK)  scancode = ENTER;

        tal = - 1;
	if(scancode == HOME)  tal = 0;
	if(scancode == END)  tal = 18;
	if(scancode == RIGHT && palo == 16)  tal = 17;
        if(tal >= 0)  {
	     sed_GotoField(sed, tal);
	     return(TRUE);
	    }

	if(scancode == DEL)  scancode = FN8;

        if(palo >= 17 && scancode == ENTER)  {
             if(palo == 17)  scancode = CTRL_N;
             else
                 {
                  if(palo == 18)  scancode = CTRL_O;
                  else  scancode = CTRL_P;
                 }
            }

	if(xaxistime != 0 && ((type == 7 && scancode == CTRL_P) || scancode == CTRL_O || scancode == CTRL_N))  {
	     grafisk = 2;
	     tidsmark(scancode);
	     grafisk = 1;
	     mabaton = 300;
	     sed_ToggleExit(sed);
	     return(TRUE);
	    }

	if(type == 7 && scancode == FN8 && compeger != 0)  {
	     Btypecomp = 0;
	     compeger = 0;
	     mabaton = 300;
	     sed_ToggleExit(sed);
	     return(TRUE);
	    }

	if((palo == 3 || palo == 16) && scancode == ENTER) {
	     if(palo == 3)  mabaton = 32;
	     else  mabaton = 17;
	     sed_ToggleExit(sed);
	     return(TRUE);
	    }

	tal = 0;
	if(palo == 3 && TRUE == sed_IsHome(sed))  {
	     if(scancode == END)  tal = 16;
	     if(scancode == RIGHT)  tal = 5;
	     if(scancode == LEFT)  tal = 2;
	     if(scancode == UP || scancode == DOWN)  return(TRUE);
	    }
	if(palo == 16)  {
	     if(TRUE == sed_IsHome(sed) && scancode == LEFT)  {
		  if(type == 4)  tal = 1;
		  if(type == 5)  tal = 3;
		  if(type == 6)  tal = 7;
		  tal = 14 - tal;
		 }
	     if(scancode == UP || scancode == DOWN  || scancode == RIGHT)  return(TRUE);
	    }
	if(tal != 0)  {
	     sed_GotoField(sed, tal);
	     return(TRUE);
	    }

	if(ascii(scancode) >= 48 && ascii(scancode) <= 57)  {
	     if(ascii(scancode) >= 49)  varfelt = ascii(scancode) - 44;
	     else  varfelt = 14;
	     tal = 1;
	    }

	if(scancode == ENTER)  {
	     if(palo >= 5 && palo <= 14)  varfelt = palo;
	     else  varfelt = 0;
	     return(FALSE);
	    }

	if(scancode == CTRL_C)  {
	     if(palo >= 5 && palo <= 14)  {
		   tal = palo - 4;
		   strtograf(strmellem, tal);
		   strcpy(promtstr[7], strmellem);
		  }
	     else  gemnavn();
	     return(TRUE);
	    }

	if(scancode == FN6 || scancode == ALT_FN6)  tal1 = 1;
	else  tal1 = 0;
	if((tal1 == 1 || scancode == FN8) && ((kurvenr == 0 && (palo < 5 || palo > 14)) || (kurvenr != 0 && palo != varfelt && varfelt != 0)))  {
	     if(kurvenr == 0)  varfelt = 5;
	     sed_GotoField(sed, varfelt);
	     if(kurvenr == 0)  {
		  Mtone();
		  return(TRUE);
		 }
	     palo = varfelt;
	    }

	if(scancode == ESC || scancode == MOU_NOFIELD || scancode == MOU_THERE)  tal = 3;
	if(tal1 == 1 || scancode == FN7 || scancode == FN8)  tal = 4;
	if(scancode == FN1)  tal = 81;
	if(scancode == FN2)  tal = 82;
	if(scancode == FN3)  tal = 80;
	if(ascii(scancode) == 88 || ascii(scancode) == 120)  tal = 88;
	if(tal != 0)  {
	     if(tal == 1)  mabaton = ascii(scancode);
	     if(tal == 3)  mabaton = 100;
	     if(tal == 4)  {
		  tal2 = 0;
		  for(tal3 = 1; tal3 <= antkurv; tal3++)  {
		       if((int) Gout[tal3][0] != 0)  tal2 = tal2 + 1;
		      }
		  if(scancode == FN8 && tal2 == 0)  {
		       scancode = ALT_FN6;
		       tal1 = 1;
		      }
		  tal3 = 0;
		  if(tal1 == 1 || scancode == FN7)  {
		       if((type == 7 || (tal1 == 1 && type != 7)) && (palo >= 5 && palo <= 14))  {
			    if(scancode == FN7)  compalut = palo + 11;
			    else
				{
				 if(scancode == FN6)  {
				      if(type != 7)  {
					   if((int) Gout[palo - 4][0] != 0)  {
						Mtone();
						return(TRUE);
					       }
					   if(type != 5)  deltaA[(char) palo - 4] = 1;
					   else  deltaP[(char) palo - 4] = 1;
					  }
				      else
					  {
					   grafrap = 3;
					   tidsind(0);
					   grafrap = 0;
					   if(mabaton != 0)  tal3 = 1;
					  }
				     }
				 else
				     {
				      if(tal2 == antkurv)  {
					   Mtone();
					   return(TRUE);
					  }
				      else
					  {
					   if(type != 7)  {
						if(type != 5)  deltaA[0] = 0;
						else  deltaP[0] = 0;
					       }
					   else
					       {
						udibank = 0;
						savecomp = 1;
						strcpy(meldcomp, meldLager);
						compfile(0);
					       }
					  }
				     }
				 mabaton = 300;
				}
			   }
		       if(scancode == FN7)  mabaton = 200;
		      }
		  else
		      {
		       if(kurvenr != 0 && xaxistime == 0)  {
			    Mtone();
			    return(TRUE);
			   }
		       if(kurvenr != 0)  goto finfora;
		       nuta = palo;
		       tal1 = 0;
		       tal2 = 0;
		igenop:if(tal2 == 5 + antkurv)  tal1 = 1;
		       for(tal2 = nuta + 1; tal2 <= 4 + antkurv; tal2++)  {
			    if((int) Gout[tal2 - 4][0] != 0) {
				 if(palo != tal2)  sed_GotoField(sed, tal2);
				 break;
				}
			   }

		       if(tal2 <= 4 + antkurv)  goto finfora;
		       if(tal1 == 0)  nuta = 4;
		       if(tal1 == 0)  goto igenop;
	       finfora:if((int) Gout[palo - 4][0] != 0)  {
			    if(type == 7)  sletudda(palo - 4);
			    else
				{
				 tal = palo - 4;
				 for(tal3 = 0; tal3 <= 14; tal3++)  Gout[tal][tal3] = 0.0;
				 if(type != 5)  deltaA[tal] = 0;
				 else  deltaP[tal] = 0;
				}
			    tal3 = 1;
			   }
		       else  return(TRUE);
		      }
		  if(tal3 == 1)  {
		       if(type == 7)  {
			    trans[palo - 5] = 0;
			    savecomp = 0;
			    udibank = 0;
			   }
		       mabaton = 300;
		      }
		 }
	     if(tal >= 80)  mabaton = tal;
	     sed_ToggleExit(sed);
	     return(TRUE);
	    }
	if(scancode == PGUP || scancode == PGDN || ascii(scancode) > 32 && ascii(scancode) <= 255)  return(TRUE);

return(FALSE);
}

int aux_graf(sed_type sed, int msg, void *indata, void *outdata)
{
int palo;
static char nuto = 0;

     oak_notused(indata);
     oak_notused(outdata);

     palo = sed_GetFieldNo(sed);

     if(palo != 3 && palo != 16)  nuto = 0;
     else
	 {
	  nuto = nuto + 1;
	  if(msg == SED_FENTER)  nuto = 1;
	  if(nuto == 2)  Mcursor(sed);
	  if(msg == SED_FEXIT)  nuto = 0;
	 }

return(TRUE);
}

void grafout(void)
{
	menu_type     menu;
	char          *grafstr[12], Rperiode[10], Rkvadrant[15], sidstenr = 0;
	static char   styrmode = 0, skalx = 2, kurve_type = 1;
	int           tal, tal1, tal2, tal3, Rmabaton, felt, type;
	byte          regular = 0, select = 0;

	for(tal = 0; tal <= 11; tal++)  {
	     grafstr[tal] = malloc(34);
	     grafstr[tal][0] = '\0';
	    }

	grafstart();

	Rperiode[0] = '\0';
	Rkvadrant[0] = '\0';
	Rmabaton = mabaton;
	type = styrk[0][0];

	if(type != 5)  {
	     if(deltaA[0] == - 1)  deltaA[0] = 0;
	    }
	else
	    {
	     if(deltaP[0] == - 1)  deltaP[0] = 0;
	    }

	if(type <= 3 || type == 7)  antkurv = 10;
	else
	    {
	     if(type == 4)  antkurv = 9;
	     else
		 {
		  if(type == 5)  antkurv = 7;
		  else  antkurv = 3;
		 }
	    }

	menu = menu_Open();

	menu_Printf(menu, "@p[30,0]@f[ Return [Esc@] ]",
	  NULL, &gmenu_funcs);
	menu_Printf(menu, "@p[30,15]@f[ Rem ]",
	  NULL, &gmenu_funcs);
	menu_Printf(menu, "@p[30,21]@f[P]",
	  NULL, &gmenu_funcs);
	menu_Printf(menu, "@p[30,23]@f[ ########### ]",
	  Rkvadrant, &string_funcs);

	tal2 = 36;
	for(tal = 0; tal <= 11; tal++)   {
	     strcpy(grafstr[tal], " ");
	     tal2 = tal2 + 1;
	     if(tal >= 1 && tal <= antkurv)  {
		  if(tal == 10)  tal1 = 0;
		  else  tal1 = tal;
		  itoa(tal1, grafstr[tal], 10);
		 }
	     menu_Printf(menu, "@p[30,%d]@fp[%s]", tal2,
	       NULL, &gmenu_funcs, grafstr[tal]);
	    }

	menu_Printf(menu, "@p[30,50]@f[ ### ]",
	  Rperiode, &string_funcs);

        if(type == 7)  tal = 30;
        else   tal = - 1;
        felttid(menu, 30, 56, tal, 59);

	menu_Flush(menu);

	sed = sed_Open(menu);

	for(tal = 5; tal <= 4 + antkurv; tal++)  sed_UnProtectField(sed, tal);

        techset(sed, 0, 0, 0, NULL, 0x00, 29, 0, 1, 63, aux_graf, spc_graf);

starvis:kurvenr = 0;
	felt = 3;
	sed_GotoField(sed, 3);

sletGr:	grafregn(grafstr, Rkvadrant, Rperiode, sidstenr, \
		 skalx, styrmode, kurve_type);

	if(grafrap != 0)  goto prirem;

punkt3:	mabaton = 0;
	sed_Go(sed);

	felt = sed_GetFieldNo(sed);

feltcol:if((mabaton >= 80 && mabaton <= 82) || mabaton == 200)  {
	     sed_GetFieldColors(sed, felt, &regular, &select);
	     sed_MarkField(sed, felt, select, select);
	     sed_UpdateField(sed, felt);
	    }

	if(mabaton == 80) goto printr;
	if(mabaton == 81) goto help;
	if(mabaton == 82) goto starrap;
	if(mabaton == 88 && xaxistime <= 6) goto skaltim;
	if(mabaton == 88 && xaxistime > 6) goto punkt3;
	if(mabaton == 200)  goto bank;
	if(mabaton == 300)  goto sletGr;
	if(mabaton == 32 || (mabaton >= 48 && mabaton <= 57))  goto nykva;
	if(mabaton == 17)  goto skaltim;
	if(mabaton == 100 && felt != 0) goto udposi;

	if(mabaton != 100)  mabaton = sed_GetBaton(sed);
	if(mabaton == 1 || mabaton == 100)  goto udgraf;

	if(mabaton == 2)  mabaton = 82;
	if(mabaton == 3)  mabaton = 80;
	if(mabaton == 82 || mabaton == 80)  goto feltcol;
	if(mabaton == 4)  mabaton = 32;
	if(mabaton >= 6 && mabaton <= 15)  {
	     if(mabaton == 15) mabaton = 48;
	     else  mabaton = mabaton + 43;
	    }

  nykva:if(mabaton >= 48 && mabaton <= 57)  {
	     if(mabaton >= 49)  tal1 = mabaton - 44;
	     else  tal1 = 14;
	     sed_GotoField(sed, tal1);
	    }

	tal = 0;
	if(mabaton != 32)  {
	     if(mabaton == 48)  tal1 = 10;
	     else  tal1 = mabaton - 48;
	     tal2 = tal1 + 4;
	     if(sed_IsProtectedField(sed, tal2))  tal = 1;
	     else
		 {
		  kurvenr = (char) tal1;
		  if(sidstenr == kurvenr)  {
		       kurve_type = kurve_type + 1;
		       if(kurve_type >= 3)  kurve_type = 0;
		      }
		  else  sidstenr = kurvenr;
		 }
	    }
	else
	    {
	     if(styrmode == 0)  styrmode = 1;
	     else  styrmode = 0;
	    }
	if(tal != 0)  goto punkt3;
	goto sletGr;

udgraf:	if(kurvenr != 0) goto starvis;
	goto pexit;

udposi: if(felt >= 5)  tal = 3;
	else  tal = 0;
	sed_GotoField(sed, tal);
	goto punkt3;

help:   bankhelp(4);
	goto sletGr;

prirem: if(grafrap != 4)  goto rapport;
printr:	grafrap = 3;
	prirap();
	if(grafrap != 4)  grafrap = 0;
	goto sletGra;

starrap:grafrap = - 1;
rapport:if(grafrap == - 2)  grafrap = - 1;
	raptext();
	if(grafrap == - 1)  grafrap = 0;
sletGra:if(grafrap == 0)  {
	     sed_MarkField(sed, felt, regular, select);
	     sed_UpdateField(sed, felt);
	    }
	goto sletGr;

skaltim:if(skalx == 2)  skalx = 1;
	else skalx = 2;
	goto sletGr;

bank:   datatran();
	if(type == 7)  compalut = 0;
	goto sletGr;

pexit:  grafslut();
	for(tal = 0; tal <= 11; tal++)  free(grafstr[tal]);
	mabaton = Rmabaton;
}