/*
	ramcompo.c

	08/11/95
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cscape.h"
#include "scancode.h"

extern char licensee[];
extern char unitoftime[];
extern char skalfak[];
extern char coskalfak[];
extern char isonoj[];
extern char compmelding[];
extern char stridate[];
extern char meldBank[];
extern char raekkenr[];
extern char Uunitoftime[];
extern char Uskalfak[];
extern char Uisonoj[];
extern char coskalfak[];
extern char trans[];
extern char comaxtime[];
extern char meldcomp[];
extern char compu[];

extern char styresens;
extern char Btypecomp;
extern char udibank;
extern char savecomp;
extern char compeger;
extern char compalut;
extern char datatrantype;
extern char SAVE_peger;
extern char PCT_peger;

char min_posT = 0;
char Xtran = 0;
char Ytran = 0;
char STYR_tran = 0;
char grafisk = 0;

char *Fout[11][12];

extern char *paratex[];
extern char *coparatex[];
extern char *isofac[];
extern char *dimvis[];
extern char *promtstr[];
extern char *counitoftime[];
extern char *coisonoj[];
extern char *tid_skalaS[];

char *compoundstr[4];

extern double out[11][15];

extern double faktor;
extern double cofaktor;

extern float coout[12][16];

extern int styrk[3][3];

extern int nextime;
extern int calcno;
extern int mabaton;

extern sed_type sed;

sed_type bsed[1];

aux_func(aux_comp);
spc_func(spc_comp);
spc_func(speciout);
spc_func(spc_EmbedU);

void pegestri(int tal1, char parm)
{
int tal;
char strmellem[40], uddatype, procen;
double mellem;

	procen = 0;
	if(PCT_peger >= 1 || (int) out[tal1][14] != 0)  procen = 1;
	strcpy(promtstr[0], paratex[0]);
	strncat(promtstr[0], "                                ", 30 - strlen(paratex[0]));
	strcat(promtstr[0], ">");
	strcat(promtstr[0], "(");
	if(procen == 0)  {
	     if(parm != - 1)  {
		  mellem = 1.0;
		  for(tal = 1; tal <= 4; tal++)  {
		       if(tal >= 2)  mellem = 1000.0 * mellem;
		       if(mellem == out[0][0])  {
			    strcpy(Uskalfak, isofac[tal]);
			    break;
			   }
		      }
		 }
	     if(strcmp(Uskalfak, " ") != 0)  strcat(promtstr[0], Uskalfak);
	     uddatype = (char) out[tal1][13];
	     if(uddatype == 2 || uddatype == 3)  strcat(promtstr[0], dimvis[2]);
	     else  strcat(promtstr[0], Uisonoj);
	     if(uddatype == 1 || uddatype == 3)  strcat(promtstr[0], "/t");
	     if(uddatype == 4)  strcat(promtstr[0], "/p");
	    }
	else  strcat(promtstr[0], "%");
	strcat(promtstr[0], ")");

	if(parm != 1)  {
	     strcat(promtstr[0], ", ");
	     strcpy(strmellem, Uunitoftime);
	     strclip(strmellem);
	     strcat(promtstr[0], strmellem);
	    }
	else
	    {
	     tal = 0;
	     if(procen == 1)  tal = 5;
	     else
		 {
		  if(strcmp(Uskalfak, " ") == 0)  tal = tal + 1;
		  if(uddatype == 0 || uddatype == 2)  tal = tal + 2;
		 }
	     tal = tal + 1;
	     strncat(promtstr[0], "        ", tal);
	     mellem = out[tal1][1];
	     if(mellem >= 1.0)  gcvt(mellem, 6, strmellem);
	     else
		 {
		  if(mellem == 0.0)  strcpy(strmellem, "0");
		  else sprintf(strmellem, "%f", mellem);
		 }
	     tal1 = strlen(strmellem);
	     if(tal1 > 6)  {
		  strncat(promtstr[0], strmellem, 6);
		  tal = 2;
		 }
	     else
		 {
		  strcat(promtstr[0], strmellem);
		  tal = 8 - tal1;
		 }
	     strncat(promtstr[0], "         ", tal);
	    }
}

void tranmark(sed_type Trsed, int parm)
{
int palo, tal, tal1, tal2, tal3;

	palo = abs(parm);

	tal1 = 0x4e;
	tal2 = 0xcb;
	if(compalut == palo + 6)  tal3 = 1;
	else
	    {
	     tal3 = 0;
	     if(0 != (int) coout[palo - 9][0])  {
		  if(trans[palo - 10] != 0)  tal1 = 0x72;
		  else  tal1 = 0x38;
		 }
	     else  tal1 = 0x33;
	     tal2 = 0xce;
	    }
	sed_MarkField(Trsed, palo, tal1, tal2);
	sed_UpdateField(Trsed, palo);
	if(parm >= 1)  {
	     if(tal3 == 1)  tal2 = 0x3e;
	     else  tal2 = 0x1f;
	    }
	else
	    {
	     if(tal3 == 1)  tal2 = 0x3f;
	     else  tal2 = 0x7f;
	    }
	tal1 = 5 * (palo - 10) + 19;
	for(tal = tal1; tal <= tal1 + 5; tal++)  {
	     if(tal == tal1)  tal3 = palo - 10;
	     else  tal3 = tal;
	     sed_MarkField(Trsed, tal3, tal2, tal2);
	     sed_UpdateField(Trsed, tal3);
	    }

}

int aux_tran(sed_type Trsed, int msg, void *indata, void *outdata)
{
static char nuto = 0;
int palo;

	oak_notused(indata);
	oak_notused(outdata);

	palo = sed_GetFieldNo(Trsed);

	if(palo < 10)  nuto = 0;
	else
	    {
	     nuto = nuto + 1;
	     if(msg == SED_FENTER)  nuto = 1;
	     if(nuto == 2 || msg == SED_FEXIT)  {
		  if(nuto != 2)  palo = - palo;
		  tranmark(Trsed, palo);
		  if(msg == SED_FEXIT)  nuto = 0;
		 }
	    }

return(TRUE);
}

boolean spc_tran(sed_type Trsed, int scancode)
{
int palo, tal, tal1;

	palo = sed_GetFieldNo(Trsed);

	if(TRUE == styrebil(Trsed, scancode, Ytran, Xtran))  return(TRUE);

	if(palo <= 9)  {
	     tal = palo + 10;
	     sed_GotoField(Trsed, tal);
	    }
	if(scancode == ESC || scancode == MOU_NOFIELD || scancode == MOU_THERE)  STYR_tran = 0;

	if(ascii(scancode) > 31 && ascii(scancode) <= 255)  return(TRUE);

	if(scancode == DOWN && palo == 19)  {
	     sed_GotoField(Trsed, 10);
	     return(TRUE);
	    }

	if(scancode == FN2)  {
	     raptext();
	     return(TRUE);
	    }
	if(scancode == FN3)  {
	     prirap();
	     return(TRUE);
	    }

	if(scancode == FN5)  {
	     mabaton = palo + 1;
	     sed_ToggleExit(Trsed);
	     return(TRUE);
	    }

	if(scancode == CTRL_FN5)  {
	     tal1 = compalut - 6;
	     if(compalut == 0 || palo == tal1 || STYR_tran != 0)  Mtone();
	     else  sed_GotoField(Trsed, tal1);
	     return(TRUE);
	    }

	if(scancode == FN8)  {
	     if(comaxtime[0] == 0)  Mtone();
	     else
		 {
		  mabaton = - 2;
		  sed_ToggleExit(Trsed);
		 }
	     return(TRUE);
	    }

	if(scancode == FN10)  {
	     styrk[2][0] = palo - 9;
	     mabaton = - 1;
	     sed_ToggleExit(Trsed);
	     return(TRUE);
	    }

return(FALSE);
}

void comptran(char parm)
{
	menu_type	menu;
	sed_type	Trsed;
	char            command1[80], command1R[80], overskri[80], strmellem[40];
	char            deltacom[20], uddata, gem;
	int 		ret, nuta, overcol, felt;
	static char     blokfra = 0;
	byte            regular, select;

	ret = styrk[0][1];
	uddata = compu[ret - 30];
	if(parm == 0)  {
	     strcpy(paratex[0], paratex[ret]);
	     strcpy(Uunitoftime, unitoftime);
	     strcpy(Uisonoj, isonoj);
	     out[0][0] = faktor;
	    }
	if(STYR_tran == 1)  goto slette;
	if(STYR_tran == 2)  goto serienr;

	strcpy(command1R, "Press RETURN or [F5] for CHOICE  or , | [F8] Delete, [F10] sta.");

	pegestri(uddata,0);
	strcpy(overskri, "  Place: ");
	strcat(overskri, promtstr[0]);
	strcat(overskri, "  ");

	menu = menu_Open();

   for(ret = 0; ret <= 9; ret++)  {
	nuta = ret + 1;
	menu_Printf(menu, "@p[%d,0]@f[@[30,#] ]", ret,
	  coparatex[nuta], &string_funcs);
       }

   for(ret = 0; ret <= 9; ret++)  {
	felt = ret + 1;
	if(felt == 10)  felt = 0;
	itoa(felt, strmellem, 10);
	menu_Printf(menu, "@p[%d,31]@fd[%s]", ret,
	  NULL, &gmenu_funcs, command1, strmellem);
       }

   for(ret = 0; ret <= 9; ret++)  {
	for(felt = 0; felt <= 4; felt++)  {
	     if(felt == 0)  nuta = 32;
	     else  nuta = (felt - 1) * 8 + 40;
	     menu_Printf(menu, "@p[%d,%d]@fpd3[########]", ret, nuta,
	       Fout[ret + 1][felt], &string_funcs, NULL, NULL, ">");
	    }
       }

	menu_Flush(menu);

	Trsed = sed_Open(menu);

        techset(Trsed, 1, BD_MOVE, 0x71, overskri, 0x3f, 0, 4, 4, 72, aux_tran, spc_tran);
	Ytran = 0;
	Xtran = 4;

punkt5: nuta = styrk[0][0];
	styrk[0][0] = 7;
	compenhe();
	styrk[0][0] = nuta;
	if(savecomp == - 1 || savecomp == 1 || udibank == 1)  overcol = 0x71;
	else  overcol = 0x75;
	sed_SetBorderColor(Trsed, overcol);

	strcpy(command1, command1R);
	strcpy(deltacom, "[");
	if(strcmp(coskalfak, " ") != 0)  strcat(deltacom, coskalfak);
	strcat(deltacom, coisonoj[0]);
	strcat(deltacom, "]");
	if(strcmp(coskalfak, " ") == 0)  strcat(deltacom, "");
	strcat(command1, deltacom);

	gem = datatrantype;
	datatrantype = - 8;
	feltstring();
	datatrantype = gem;
	for(ret = 0; ret <= 9; ret++)  tranmark(Trsed, - ret - 10);

	for(ret = 10; ret <= 19; ret++)  {
	     if(comaxtime[ret - 9] == 0)  break;
	    }

	sed_Repaint(Trsed);
	if(ret == 20)  ret = 19;
	sed_GotoField(Trsed, ret);

punkt3: mabaton = 0;
	ret = 0;
	sed_Go(Trsed);

	felt = sed_GetFieldNo(Trsed);

	if(mabaton == - 1)  goto punkt6;
	if(mabaton == - 2)  goto slette;
	if(mabaton >= 1)  goto punkt9;

	mabaton = sed_GetBaton(Trsed);

	if(mabaton != 0)  goto punkt9;
	goto punkt1;

punkt6: sed_GetFieldColors(Trsed, felt, &regular, &select);
	sed_MarkField(Trsed, felt, select, select);
	sed_UpdateField(Trsed, felt);
	comstatu(1, felt - 9);
	sed_MarkField(Trsed, felt, regular, select);
	sed_UpdateField(Trsed, felt);
	goto punkt3;

slette: ret = 26;
	blokfra = 10;
	for(nuta = 1; nuta <= 10;  nuta++)  {
	     sletudda(nuta);
	     trans[nuta - 1] = 0;
	    }
	if(datatrantype == 8)  {
	     sletsave();
	     malcomp(0);
	     for(nuta = 16; nuta <= 25; nuta++)  {
		  if(nuta == compalut)  continue;
		  linmark(- nuta);
		 }
	    }
	else  compalut = 0;
	udibank = 0;
	savecomp = - 2;
	if(mabaton == - 2)  goto punkt5;
serienr:mabaton = blokfra - 9;
	goto dataned;

punkt9: ret = 0;
	for(nuta = 10; nuta <= 19; nuta++)  {
	     if(strcmp(coparatex[nuta - 9], paratex[0]) == 0)  {
		  ret = nuta;
		  break;
		 }
	    }
	if(ret != 0)  {
	     styrk[2][2] = ret - 9;
	     malfejl(Trsed, felt, 134);
	     tranmark(Trsed, - felt);
	     if(mabaton == 0)  sed_GotoField(Trsed, ret);
	    }
	if(mabaton == 0)  goto punkt3;
	mabaton = mabaton - 10;
	Mtone();

dataned:strcpy(coparatex[mabaton], paratex[0]);
	strcpy(counitoftime[mabaton], Uunitoftime);
	strcpy(coisonoj[mabaton], Uisonoj);
	for(nuta = 1; nuta <= 10; nuta++)  {
	     if((int) coout[nuta][14] != 0)  continue;
	     for(ret = 1; ret <= 12; ret++)  coout[nuta][ret] = (float) (cofaktor * coout[nuta][ret]);
	    }

	if(PCT_peger >= 1 || (int) out[uddata][14] != 0)  {
	     coisonoj[mabaton][0] = '\0';
	     nuta = 1;
	     out[0][0] = 1.0;
	    }
	else  nuta = 0;
	coout[mabaton][14] = (float) nuta;
	coout[mabaton][15] = (float) min_posT;
	for(ret = 0; ret <= 13; ret++)  {
	     if(ret >= 1 && ret <= 12)  coout[mabaton][ret] = (float) (out[0][0] * out[uddata][ret]);
	     else  coout[mabaton][ret] = (float) out[uddata][ret];
	    }
	numskal(1);

	if(parm == 1)  {
	     if(STYR_tran == 0)  trans[mabaton - 1] = 1;
	     else  trans[mabaton - 1] = 0;
	    }

	savecomp = 0;
	if(STYR_tran == 0)  udibank = 0;

	if(datatrantype == 8)  {
	     if(STYR_tran == 0)  uddata = 15 + (char) mabaton;
	     else  uddata = 0;
	     malcomp(uddata);
	    }

punkt1: if(STYR_tran == 0)  sed_Close(Trsed);
	if(mabaton != 0)  {
	     if(STYR_tran >= 1)  {
		  if(udibank != 1)  {
                       udibank = 1;
                       if(datatrantype == 8)  {
                            sed_SetBorderColor(sed, 0x72);
                            sed_RepaintBorder(sed);
                           }
                      }
		  if(STYR_tran == 1)  strcpy(meldcomp, meldBank);
		  STYR_tran = 2;
		  if(mabaton == 10)  STYR_tran = 0;
		  blokfra = blokfra + 1;
		 }
	    }
}

void idendata(menu_type menu)
{
int tal, tal1, type;

	type = styrk[0][0];

	if(type != 4 && type != 8)  tal1 = 24;
	else  tal1 = 70;

	menu_Printf(menu, "@p[0,1]@fp[@[76,#]]",
	  licensee, &string_funcs);
	menu_Printf(menu, "@p[1,10]@fp[###]",
	  &calcno, &int_funcs);
	menu_Printf(menu, "@p[1,63]@fp[#]",
	  skalfak, &string_funcs);
	menu_Printf(menu, "@p[1,64]@fp[###]",
	  isonoj, &string_funcs);
	if(type == 6)  tal = 10;
	else
	    {
	     if(type != 7)  tal = 19;
	     else  tal = 24;
	    }
	menu_Printf(menu, "@p[%d,%d]@fp[ ]", tal, tal1,
	  NULL, &gmenu_funcs);
	menu_Printf(menu, "@p[1,70]@fp[@[8,#]]",
	  stridate, &string_funcs);

}

void ramopstr(char parm)
{
int tal, nuta;

	for(nuta = 0; nuta <= 10; nuta++)  {
	     if(parm == 0 && nuta <= 3)  {
		  compoundstr[nuta] = malloc(80);
		  compoundstr[nuta][0] = '\0';
		 }
	     for(tal = 0; tal <= 11; tal++)  {
		  Fout[nuta][tal] = malloc(10);
		  Fout[nuta][tal][0] = '\0';
		 }
	    }
}

void ramnulstr(char parm)
{
int tal, nuta;

       for(nuta = 0; nuta <= 10; nuta++)  {
	    if(parm == 0 && nuta <= 3)  free(compoundstr[nuta]);
	    for(tal = 0; tal <= 11; tal++)  free(Fout[nuta][tal]);
	   }
}

void felttid(menu_type menu, int parm, int parm1, int parm2, int parm3)
{
int tal;

        if(grafisk == 1)  {
             if(styrk[0][0] != 10 && styrk[0][0] != - 20)  tal = 5;
             else  tal = 3;
            }
        else
            {
             if(styrk[0][0] == 9 || styrk[0][0] == 4)  tal = 4;
             else  tal = 3;
            }

	menu_Printf(menu, "@p[%d,%d]@fd[ (]", parm, parm1,
	  NULL, &gmenu_funcs, "Press ENTER to decrease time or arrows");
	menu_Printf(menu, "@p[%d,%d]@fd[) ]", parm, parm1 + tal,
	  NULL, &gmenu_funcs, "Press ENTER to increase time  or arrows");

        if(parm2 != - 1)  {
 	     menu_Printf(menu, "@p[%d,%d]@fd[<]", parm2, parm3,
	       NULL, &gmenu_funcs, "Press ENTER to decrease period or arrows");
            }

}

void rambalance(char oldtime[], char overbasis[], int type)
{
	menu_type	menu;
	char            rakn[17] = {0,4,6,7,9,11,12,14,15,17,4,6,7,8,12,13,17};
	char            strmellem[3];
	int             color[7]  = {0x38,0x39,0x0e,0x39,0x39,0x39,0x3e};
	int             ret, tal, tal1, nuta;

	ramopstr(0);

	if(type == 8)  strcpy(compoundstr[0], "Write  or tryk [F11]/[F12] rec., arrows | [F10] modus, [F6] In data, [F5] Menu");
	else  strcpy(compoundstr[0], "Write  or press RETURN, [F11]/[F12] recall, [F4] Bank or arrows | [F10] modus");

	if(SAVE_peger >= 1)  color[4] = 0x6e;

	menu = menu_Open();

	menu_Printf(menu, "\n@a[0x39]Calc. no.@[50, ]Val\n@a[0x3e]");
	if(type == 8)  menu_Printf(menu, "@p[2,42]Primo");
	else  menu_Printf(menu, "@p[2,41]Ultimo");
	menu_Printf(menu, "\n@a[0x00]@[38,]@[38,]\n@[38,]\n@[38,]@[38,]\n");
	for(tal = 1; tal <= 12; tal++)  menu_Printf(menu, "@[38, ]\n");
	menu_Printf(menu, "@[38,]@[38,]\n  @a[0x38] Return [Esc] @a[0x39]@[53, ][ ]");

	idendata(menu);
	menu_Printf(menu, "@p[2,24]@fp[@[15,#]]",
	  unitoftime, &string_funcs);

   tal = 31;
   tal1 = 9;
   nuta = 0;
   for(ret = 1; ret <= 16; ret++)  {
	menu_Printf(menu, "@p[%d,%d]@fpd3[#######]",  rakn[ret], tal,
	  Fout[tal1][nuta], &string_funcs, NULL, NULL, ">");
	tal1 = tal1 - 1;
	if(ret == 9)  {
	     tal = 71;
	     tal1 = 7;
	     nuta = 1;
	    }
       }

   tal = 0;
   for(ret = 1; ret <= 16; ret++)  {
	menu_Printf(menu, "@p[%d,%d]@fd[@[30,#]]",  rakn[ret], tal,
	  paratex[ret + 64], &string_funcs, compoundstr[0]);
	if(ret == 9)  tal = 40;
       }

	menu_Printf(menu, "@p[19,18]@fpd[ Graph ]",
	  NULL, &gmenu_funcs, "Press RETURN  or arrow RIGHT,UP        | [F10] modus, [F6] In data, [F4] Bank");
	menu_Printf(menu, "@p[19,31]@fd[ Rem ]",
	  NULL, &gmenu_funcs, "Press RETURN  for REMARKS              | [F10] modus, [F6] In data, [F4] Bank");
	menu_Printf(menu, "@p[19,42]@fd[ Modus ]",
	  NULL, &gmenu_funcs, "Press RETURN for PCT/ABS  or arrows    | [F10] modus, [F6] In data, [F4] Bank");
	menu_Printf(menu, "@p[19,51]@fd[P]",
	  NULL, &gmenu_funcs, "Press RETURN for PRINT  or arrows      | [F10] modus, [F6] In data, [F4] Bank");
	menu_Printf(menu, "@p[19,57]@fpd[ Graph ]",
	  NULL, &gmenu_funcs, "Press RETURN  or arrow LEFT,UP         | [F10] modus, [F6] In data, [F4] Bank");

	menu_Printf(menu, "@p[19,72]@fp[ ]",
	  NULL, &gmenu_funcs);
	menu_Printf(menu, "@p[2,49]@fp[##]",
	  oldtime, &string_funcs);

   tal = 30;
   nuta = 3;
   for(ret = 1; ret <= 16; ret++)  {
	if(ret <= 9)  tal1 = ret;
	else  tal1 = ret - 9;
	itoa(tal1, strmellem, 10);
	menu_Printf(menu, "@p[%d,%d]@fp[%s]",  rakn[ret], tal,
	  NULL, &gmenu_funcs, strmellem);

	if(ret == 9)  {
	     tal = 70;
	     nuta = 4;
	    }
       }

    if(type == 4)  felttid(menu, 2, 47, - 1, 0);

	menu_Flush(menu);

	sed = sed_Open(menu);

   for(ret = 0; ret <= 38; ret++)  {
	if(ret <= 22)  {
	     if(ret >= 7)  tal = 0x7f;
	     else  tal = color[ret];
	    }
	else  tal = 0x7f;
	sed_MarkField(sed, ret, tal, 0x1f);
       }

	opdafelter(4, 0);

	color[0] = 0x71;
	color[1] = 0x71;
	color[2] = 0x71;
	color[3] = 0x38;
	color[4] = 0x71;
	color[5] = 0x3f;
	color[6] = 0x3e;
    for(ret = 39; ret <= 45; ret++)  {
	tal = color[ret - 39];
	sed_MarkField(sed, ret, tal, 0x4e);
       }

    if(type == 8)  {
	 sed_MoveField(sed, 39, 19, 80);
	 sed_MoveField(sed, 43, 20, 80);
	 strcpy(overbasis, "  Balance Primo  ");
	 tal = 1;
	}
    else
	{
	 sed_UnProtectField(sed, 39);
	 sed_UnProtectField(sed, 43);
	 sed_MarkField(sed, 62, 0x71, 0x4e);
	 sed_MarkField(sed, 63, 0x71, 0x4e);
	 strcpy(overbasis, "  Balance Ultimo  ");
	 tal = nextime;
	}
	strcpy(oldtime, tid_skalaS[tal]);

        techset(sed, 3, 0, 0x7f, overbasis, 0x38, 1, 0, 21, 78, aux_comp, speciout);

}

void ramcompo(char overbasis[],int type)
{
	menu_type	menu, bmenu[1];
	int 		ret, tal, tal1, tal2, nuta, pos, color[4];
	char            strmellem[20];
	char            rakn[11] = {29,4,5,6,7,8,9,11,13,15,17};

	ramopstr(0);

	mabaton = - 1;

	if(type == 7)  {
	     strcpy(compoundstr[1], "Press RETURN, [PgUp]/[PgDn] or arrows    | [F10] status, [F5] Menu, [F4] Bank");
	     strcpy(compoundstr[2], "Press RETURN for TRANS, [F4] Bank, [F8] Del., pil ,  arrows, [F6] Data inp.");
	     strcpy(compoundstr[3], "Press RETURN for MOVE  or [F11] to copy         | [F8] cansel TRANS, [F5] Menu");
	     rakn[2] = 6;
	     rakn[3] = 7;
	     rakn[4] = 9;
	     rakn[5] = 10;
	     rakn[6] = 11;
	     rakn[7] = 13;
	     rakn[8] = 14;
	     rakn[9] = 16;
	     rakn[10] = 17;
	     rakn[0] = 29;
	    }
	else
	    {
	     strcpy(compoundstr[1], "Press RETURN, [PgUp]/[PgDn] or arrows   | [F10] modus, [F6] Indata, [F4] Bank");
	     strcpy(compoundstr[2], "Write name  or press RETURN, [F11]/[F12] rec., [F4] Bank  | [F10] modus, [F6]");
	     strcpy(compoundstr[3], "Write name  or press [F11]/[F12] rec., arr.  | [F10] mo., [F6] Indat., [F5] M.");
	    }
	compmelding[0] = '\0';

	if(type == 2)  {
	     rakn[2] = 6;
	     rakn[3] = 7;
	     rakn[4] = 8;
	     rakn[5] = 10;
	     rakn[6] = 11;
	     rakn[7] = 13;
	     rakn[8] = 14;
	     rakn[9] = 16;
	     rakn[10] = 17;
	     rakn[0] = 41;
	    }

	if(type == 3)  {
	     rakn[2] = 5;
	     rakn[3] = 7;
	     rakn[4] = 8;
	     rakn[5] = 10;
	     rakn[6] = 11;
	     rakn[7] = 12;
	     rakn[8] = 14;
	     rakn[9] = 15;
	     rakn[10] = 17;
	     rakn[0] = 51;
	    }

	if(type == 6)  {
	     rakn[2] = 6;
	     rakn[3] = 8;
	     rakn[0] = 61;
	    }

	menu = menu_Open();

  if(type != 6)  tal1 = 19;
  else  tal1 = 10;

	menu_Printf(menu, "\n@a[0x39]Calc. no.@a[0x00]@[50, ]@a[0x39]Val@a[0x00]\n");
	menu_Printf(menu, "@[29, ]@a[0x3e]t");
	menu_Printf(menu, "@a[0x00]\n@[32,]@p[%d,2]@a[0x38] Return [Esc] @a[0x00]@[7, ]", tal1);
	if(type != 7)  menu_Printf(menu, "@a[0x39][ ]@a[0x00]      ");
	else  menu_Printf(menu, "@[9, ]");

	idendata(menu);

   for(ret = 1; ret <= 12; ret++)  {
	tal = rakn[ret];
	tal1 = 2;
	nuta = rakn[0];
	if(type != 1 && type != 6 && ret == 11)  break;
	if(type == 6 && ret == 4)  break;
	if(type == 1 && ret >= 9)  {
	     if(ret == 9 || ret == 11)  {
		  if(ret == 9)  tal = 14;
		  else  tal = 16;
		  tal1 = 3;
		 }
	     else
		 {
		  if(ret == 10)  tal = rakn[9];
		  else  tal = rakn[10];
		  tal1 = 2;
		 }
	     nuta = 29;
	    }

	menu_Printf(menu, "@p[%d,0]@fd[ @[30,#] ]", tal,
	  paratex[ret + nuta], &string_funcs, compoundstr[tal1]);
       }

	for(ret = 1; ret <= 10; ret++)  {
	     tal1 = ret;
	     if(type == 6 && ret == 4)  break;
	     if(ret == 10)  tal1 = 0;
	     itoa(tal1, strmellem, 10);
	     menu_Printf(menu, "@p[%d,32]@fd[%s]",  rakn[ret],
	       NULL, &gmenu_funcs, compoundstr[0], strmellem);
	    }

	tal = 18;
	tal1 = 20;
	if(type == 6)  {
	     tal = 9;
	     tal1 = 11;
	    }

	menu_Printf(menu, "@p[2,6]@fp[@[15,#]]",
	  unitoftime, &string_funcs);

	menu_Printf(menu, "@p[%d,0]@fp[@[32,]]", tal,
	  NULL, &gmenu_funcs);
	menu_Printf(menu, "@p[%d,26]@fp[ ]", tal1 - 1,
	  NULL, &gmenu_funcs);
	menu_Printf(menu, "@p[%d,4]@fd[<<]", tal1,
	  NULL, &gmenu_funcs, "Press ENTER to move window LEFT  or arrows");
	menu_Printf(menu, "@p[%d,11]@fd[>>]", tal1,
	  NULL, &gmenu_funcs, "Press ENTER to move window RIGHT  or arrows");

        if(type == 7)  tal = 1;
        else  tal = - 1;
        felttid(menu, 2, 27, tal, 29);

	/* Generate bobbed sed */

	bmenu[0] = menu_Open();

	menu_Printf(bmenu[0], "\n@[96,]");
	for(tal = 1; tal <= 14; tal++)  {
	     if(type == 6 && tal == 6)  break;
	     menu_Printf(bmenu[0], "\n@[96, ]");
	    }
	menu_Printf(bmenu[0], "\n@[96,]");
	if(type == 7)  menu_Printf(bmenu[0], "\n\n@p[18,26]@a[0x38]row@a[0x00]");

   for(ret = 0; ret <= 11; ret++)  {
	tal = ret * 8 + 3;
	menu_Printf(bmenu[0], "@p[0,%d]@fp[###]", tal,
	  Fout[0][ret], &string_funcs);
       }

   for(ret = 1; ret <= 10; ret++)  {

	if(type == 6 && ret == 4)  break;

	tal = rakn[ret] - 2;
	for(tal1 = 0; tal1 <= 11; tal1++)  {
	     if(tal1 != 0)  nuta = (tal1 - 1) * 8 + 8;
	     else nuta = 0;
	     menu_Printf(bmenu[0], "@p[%d,%d]@fpd3[########]", tal, nuta,
	       Fout[ret][tal1], &string_funcs, NULL, NULL, ">");
	    }
       }

   if(type != 6)  pos = 17;
   else  pos = 8;

	menu_Printf(bmenu[0], "@p[%d,0]@fd[ Graph ]", pos,
	  NULL, &gmenu_funcs, compoundstr[1]);
	menu_Printf(bmenu[0], "@p[%d,9]@fd[ Rem ]", pos,
	  NULL, &gmenu_funcs, compoundstr[1]);

   if(type != 7)  strcpy(strmellem, " Modus ");
   else  strcpy(strmellem, " S ");
	menu_Printf(bmenu[0], "@p[%d,17]@fd[%s]", pos,
	  NULL, &gmenu_funcs, compoundstr[1], strmellem);

   if(type == 7)  {
	menu_Printf(bmenu[0], "@p[%d,23]@fd[ Data input ]", pos,
	  NULL, &gmenu_funcs, compoundstr[1]);
	tal1 = 3;
       }
   else  tal1 = 2;

   for(ret = tal1; ret <= 10; ret++)  {
	tal = (ret - 1) * 8 + 23;
	if((type != 7 && ret == 2) || (type == 7 && ret == 3))  strcpy(strmellem, "P");
	if((type != 7 && ret == 3) || (ret >= 4 && ret <= 9))  strcpy(strmellem, ".");
	if(ret == 10)  {
	     strcpy(strmellem, "<<<");
	     tal = 94;
	    }
	menu_Printf(bmenu[0], "@p[%d,%d]@fd[%s]", pos, tal,
	  NULL, &gmenu_funcs, compoundstr[1], strmellem);
       }

    if(type == 7)  {
	menu_Printf(bmenu[0], "@p[18,31]@fd2[#]",
	  raekkenr, &list_funcs, "Press SPACEBAR, arrow UP, DOWN, select  and RETURN  or arrow UP, DOWN", "1,2,3,4,5,6,7,8,9,0");
       }

	menu_Flush(bmenu[0]);

	bsed[0] = sed_Open(bmenu[0]);

   color[0]= 0x71;
   color[1]= 0x71;
   color[2]= 0x71;
   if(type != 7)  {
	color[3]= 0x78;
	tal2 = 2;
       }
   else
       {
	color[3]= 0x71;
	tal2 = 3;
       }
   if(type != 6)  {
	tal1 = 132;
	tal = 19;
       }
   else
       {
	tal1 = 48;
	tal = 10;
       }

	for(ret = tal1; ret <= tal1 + 12; ret++)  {
	     if(ret <= tal1 + tal2)  nuta = color[ret - tal1];
	     else nuta = 0x38;
	     if(ret - tal1 <= 11)  sed_MarkField(bsed[0], ret - tal1, 0x3e, 0x3e);
	     sed_MarkField(bsed[0], ret, nuta, 0x4e);
	    }
	if(type == 7)  sed_MarkField(bsed[0], 144, 0x78, 0x4e);

        techset(bsed[0], - 1, 0, 0, NULL, 0x3f, 3, 34, tal, 46, NULL, spc_EmbedU);

	menu_Printf(menu, "@p[2,33]@fb[]",
	  NULL, &bob_funcs, sed_CreateBob(bsed[0], BOB_DEPENDENT));

	menu_Flush(menu);

	sed = sed_Open(menu);

      for(ret = 0; ret <= 5; ret++)  {
	   if(ret == 2)  {
		if((type != 7 && PCT_peger == 0) || type == 7)  tal1 = 0x0e;
		else  tal1 = 0x8e;
	       }
	   else
	       {
		if(ret != 0)  tal1 = 0x39;
		else  tal1 = 0x38;
	       }
           if(ret == 4)  {
	        if(type != 7)  {
	             if(SAVE_peger >= 1)  tal1 = 0x6e;
	             else  tal1 = 0x3b;
	            }
	        else tal1 = 0x3b;
               }
	   sed_MarkField(sed, ret, tal1, 0x70);
	  }

	opdafelter(type, 0);

   if(type == 1)  {
	sed_MarkField(sed, 14, 0x3f, 0x1f);
	sed_MarkField(sed, 16, 0x3f, 0x1f);
	ret = 28;
	tal = 31;
       }
   if(type != 1 && type != 6)  {
	ret = 26;
	tal = 29;
       }
   if(type == 6)  {
	ret = 12;
	tal = 15;
        tal2 = 6;
        nuta = 12;
       }
   else
       {
        tal2 = 1;
        nuta = 21;
       }

	sed_MarkField(sed, ret, 0x3e, 0x70);
	ret = ret + 1;
	sed_MarkField(sed, ret, 0x3f, 0x70);
	ret = ret + 1;
	sed_MarkField(sed, ret, 0x3b, 0x70);
        for(tal1 = tal; tal1 <= tal + 3; tal1++)  sed_MarkField(sed, tal1, 0x71, 0x4e);
	if(type == 7)  sed_MarkField(sed, tal + 4, 0x72, 0x4e);

        techset(sed, 3, 0, 0x7f, NULL, 0x3f, tal2, 0, nuta, 79, aux_comp, speciout);

	sed_RedirectPrompt(bsed[0], sed);
	sed_SetMouse(sed, sedmou_Track);
	sed_SetMouse(bsed[0], sedmou_Track);

   if(type == 7)  {
	sed_SetSpecial(sed, spc_comp);

	sed_SetVar(sed, 2, (void *) coskalfak);
	sed_SetVar(sed, 3, (void *) coisonoj[0]);
	sed_SetVar(sed, 26, (void *) counitoftime[0]);
	for(tal = 1; tal <= 10; tal++)  {
	     ret = tal + 5;
	     sed_SetVar(sed, ret, (void *) coparatex[tal]);
	    }
       }
   else
       {
	if(type != 6)  {
	    if(type == 1)  strcpy(overbasis, "  Outdata compressed (source: \"Economic Keynumbers\")  ");
	    else
		{
		 if(type == 2)  strcpy(overbasis, "  Profit & Loss calculation  ");
		 else  strcpy(overbasis, "  Working capital & Key numbers  ");
		}
	    }
	else   strcpy(overbasis, "  Cash flow  ");
       }

}